/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 42 "parser.yy"

#define YYDEBUG_LEXER_TEXT (yylval)						// lexer loads this up each time
#define YYDEBUG 1										// get the pretty debugging code to compile

#undef __GNUC_MINOR__

#include <cstdio>
#include <stack>
#include "lex.h"
#include "parser.h"
#include "ParseNode.h"
#include "TypedefTable.h"
#include "TypeData.h"
#include "LinkageSpec.h"
using namespace std;

extern DeclarationNode * parseTree;
extern LinkageSpec::Spec linkage;
extern TypedefTable typedefTable;

stack< LinkageSpec::Spec > linkageStack;

void appendStr( string *to, string *from ) {
	// "abc" "def" "ghi" => "abcdefghi", remove new text from quotes and insert before last quote in old string.
	to->insert( to->length() - 1, from->substr( 1, from->length() - 2 ) );
} // appendStr

DeclarationNode * distAttr( DeclarationNode * specifier, DeclarationNode * declList ) {
	// distribute declaration_specifier across all declared variables, e.g., static, const, __attribute__.
	DeclarationNode * cur = declList, * cl = (new DeclarationNode)->addType( specifier );
	//cur->addType( specifier );
	for ( cur = dynamic_cast< DeclarationNode * >( cur->get_next() ); cur != nullptr; cur = dynamic_cast< DeclarationNode * >( cur->get_next() ) ) {
		cl->cloneBaseType( cur );
	} // for
	declList->addType( cl );
//	delete cl;
	return declList;
} // distAttr

void distExt( DeclarationNode * declaration ) {
	// distribute EXTENSION across all declarations
	for ( DeclarationNode *iter = declaration; iter != nullptr; iter = (DeclarationNode *)iter->get_next() ) {
		iter->set_extension( true );
	} // for
} // distExt


/* Line 268 of yacc.c  */
#line 119 "Parser/parser.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TYPEDEF = 258,
     AUTO = 259,
     EXTERN = 260,
     REGISTER = 261,
     STATIC = 262,
     INLINE = 263,
     FORTRAN = 264,
     CONST = 265,
     VOLATILE = 266,
     RESTRICT = 267,
     FORALL = 268,
     LVALUE = 269,
     VOID = 270,
     CHAR = 271,
     SHORT = 272,
     INT = 273,
     LONG = 274,
     FLOAT = 275,
     DOUBLE = 276,
     SIGNED = 277,
     UNSIGNED = 278,
     ZERO_T = 279,
     ONE_T = 280,
     VALIST = 281,
     BOOL = 282,
     COMPLEX = 283,
     IMAGINARY = 284,
     TYPEOF = 285,
     LABEL = 286,
     ENUM = 287,
     STRUCT = 288,
     UNION = 289,
     OTYPE = 290,
     FTYPE = 291,
     DTYPE = 292,
     TTYPE = 293,
     TRAIT = 294,
     SIZEOF = 295,
     OFFSETOF = 296,
     ATTRIBUTE = 297,
     EXTENSION = 298,
     IF = 299,
     ELSE = 300,
     SWITCH = 301,
     CASE = 302,
     DEFAULT = 303,
     DO = 304,
     WHILE = 305,
     FOR = 306,
     BREAK = 307,
     CONTINUE = 308,
     GOTO = 309,
     RETURN = 310,
     CHOOSE = 311,
     DISABLE = 312,
     ENABLE = 313,
     FALLTHRU = 314,
     TRY = 315,
     CATCH = 316,
     CATCHRESUME = 317,
     FINALLY = 318,
     THROW = 319,
     THROWRESUME = 320,
     AT = 321,
     ASM = 322,
     ALIGNAS = 323,
     ALIGNOF = 324,
     ATOMIC = 325,
     GENERIC = 326,
     NORETURN = 327,
     STATICASSERT = 328,
     THREADLOCAL = 329,
     IDENTIFIER = 330,
     QUOTED_IDENTIFIER = 331,
     TYPEDEFname = 332,
     TYPEGENname = 333,
     ATTR_IDENTIFIER = 334,
     ATTR_TYPEDEFname = 335,
     ATTR_TYPEGENname = 336,
     INTEGERconstant = 337,
     CHARACTERconstant = 338,
     STRINGliteral = 339,
     REALDECIMALconstant = 340,
     REALFRACTIONconstant = 341,
     FLOATINGconstant = 342,
     ZERO = 343,
     ONE = 344,
     ARROW = 345,
     ICR = 346,
     DECR = 347,
     LS = 348,
     RS = 349,
     LE = 350,
     GE = 351,
     EQ = 352,
     NE = 353,
     ANDAND = 354,
     OROR = 355,
     ELLIPSIS = 356,
     MULTassign = 357,
     DIVassign = 358,
     MODassign = 359,
     PLUSassign = 360,
     MINUSassign = 361,
     LSassign = 362,
     RSassign = 363,
     ANDassign = 364,
     ERassign = 365,
     ORassign = 366,
     ATassign = 367,
     THEN = 368
   };
#endif
/* Tokens.  */
#define TYPEDEF 258
#define AUTO 259
#define EXTERN 260
#define REGISTER 261
#define STATIC 262
#define INLINE 263
#define FORTRAN 264
#define CONST 265
#define VOLATILE 266
#define RESTRICT 267
#define FORALL 268
#define LVALUE 269
#define VOID 270
#define CHAR 271
#define SHORT 272
#define INT 273
#define LONG 274
#define FLOAT 275
#define DOUBLE 276
#define SIGNED 277
#define UNSIGNED 278
#define ZERO_T 279
#define ONE_T 280
#define VALIST 281
#define BOOL 282
#define COMPLEX 283
#define IMAGINARY 284
#define TYPEOF 285
#define LABEL 286
#define ENUM 287
#define STRUCT 288
#define UNION 289
#define OTYPE 290
#define FTYPE 291
#define DTYPE 292
#define TTYPE 293
#define TRAIT 294
#define SIZEOF 295
#define OFFSETOF 296
#define ATTRIBUTE 297
#define EXTENSION 298
#define IF 299
#define ELSE 300
#define SWITCH 301
#define CASE 302
#define DEFAULT 303
#define DO 304
#define WHILE 305
#define FOR 306
#define BREAK 307
#define CONTINUE 308
#define GOTO 309
#define RETURN 310
#define CHOOSE 311
#define DISABLE 312
#define ENABLE 313
#define FALLTHRU 314
#define TRY 315
#define CATCH 316
#define CATCHRESUME 317
#define FINALLY 318
#define THROW 319
#define THROWRESUME 320
#define AT 321
#define ASM 322
#define ALIGNAS 323
#define ALIGNOF 324
#define ATOMIC 325
#define GENERIC 326
#define NORETURN 327
#define STATICASSERT 328
#define THREADLOCAL 329
#define IDENTIFIER 330
#define QUOTED_IDENTIFIER 331
#define TYPEDEFname 332
#define TYPEGENname 333
#define ATTR_IDENTIFIER 334
#define ATTR_TYPEDEFname 335
#define ATTR_TYPEGENname 336
#define INTEGERconstant 337
#define CHARACTERconstant 338
#define STRINGliteral 339
#define REALDECIMALconstant 340
#define REALFRACTIONconstant 341
#define FLOATINGconstant 342
#define ZERO 343
#define ONE 344
#define ARROW 345
#define ICR 346
#define DECR 347
#define LS 348
#define RS 349
#define LE 350
#define GE 351
#define EQ 352
#define NE 353
#define ANDAND 354
#define OROR 355
#define ELLIPSIS 356
#define MULTassign 357
#define DIVassign 358
#define MODassign 359
#define PLUSassign 360
#define MINUSassign 361
#define LSassign 362
#define RSassign 363
#define ANDassign 364
#define ERassign 365
#define ORassign 366
#define ATassign 367
#define THEN 368




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 139 "parser.yy"

	Token tok;
	ParseNode * pn;
	ExpressionNode * en;
	DeclarationNode * decl;
	DeclarationNode::Aggregate aggKey;
	DeclarationNode::TypeClass tclass;
	StatementNode * sn;
	ConstantExpr * constant;
	ForCtl * fctl;
	LabelNode * label;
	InitializerNode * in;
	OperKinds op;
	std::string * str;
	bool flag;



/* Line 293 of yacc.c  */
#line 400 "Parser/parser.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 412 "Parser/parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  238
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11059

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  138
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  242
/* YYNRULES -- Number of rules.  */
#define YYNRULES  756
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1556

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   368

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   126,     2,     2,     2,   129,   123,     2,
     114,   115,   122,   124,   121,   125,   118,   128,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   135,   137,
     130,   136,   131,   134,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   116,     2,   117,   132,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,   133,   120,   127,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     5,     7,     9,    11,    13,    15,
      17,    19,    21,    23,    25,    27,    29,    31,    33,    35,
      37,    40,    42,    44,    46,    50,    54,    56,    63,    68,
      72,    80,    83,    87,    95,    98,   101,   109,   114,   116,
     120,   121,   123,   125,   129,   131,   134,   141,   145,   153,
     157,   165,   168,   171,   174,   175,   178,   180,   182,   184,
     187,   190,   193,   196,   199,   202,   207,   210,   215,   222,
     224,   229,   234,   236,   238,   240,   242,   244,   246,   248,
     253,   255,   259,   263,   267,   269,   273,   277,   279,   283,
     287,   289,   293,   297,   301,   305,   307,   311,   315,   317,
     321,   323,   327,   329,   333,   335,   339,   341,   345,   347,
     353,   358,   360,   362,   366,   367,   369,   371,   373,   375,
     377,   379,   381,   383,   385,   387,   389,   391,   393,   400,
     408,   410,   414,   416,   420,   421,   423,   425,   427,   429,
     431,   433,   435,   437,   439,   446,   451,   454,   462,   464,
     468,   470,   473,   475,   478,   481,   483,   486,   489,   495,
     503,   509,   519,   525,   535,   537,   541,   543,   545,   549,
     553,   556,   558,   561,   564,   565,   567,   570,   574,   575,
     577,   580,   584,   588,   593,   594,   596,   598,   601,   607,
     615,   622,   629,   634,   638,   643,   646,   650,   653,   657,
     661,   665,   669,   675,   679,   683,   688,   690,   696,   703,
     709,   716,   726,   737,   747,   758,   761,   763,   766,   769,
     772,   774,   781,   790,   801,   814,   829,   830,   832,   833,
     835,   837,   841,   846,   854,   855,   857,   861,   863,   867,
     869,   871,   873,   877,   879,   881,   883,   887,   888,   890,
     894,   899,   901,   905,   907,   909,   913,   917,   921,   925,
     929,   932,   936,   943,   947,   951,   956,   958,   961,   964,
     968,   974,   982,   990,   996,  1006,  1009,  1012,  1018,  1022,
    1028,  1033,  1037,  1042,  1047,  1055,  1060,  1064,  1068,  1072,
    1076,  1083,  1085,  1087,  1089,  1091,  1093,  1095,  1097,  1099,
    1100,  1102,  1104,  1107,  1109,  1111,  1113,  1115,  1117,  1119,
    1121,  1122,  1128,  1130,  1133,  1137,  1139,  1142,  1144,  1146,
    1148,  1150,  1152,  1154,  1156,  1158,  1160,  1162,  1164,  1166,
    1168,  1170,  1172,  1174,  1176,  1178,  1180,  1182,  1184,  1186,
    1188,  1190,  1193,  1196,  1200,  1204,  1206,  1210,  1212,  1215,
    1218,  1221,  1226,  1231,  1236,  1241,  1243,  1246,  1249,  1253,
    1255,  1258,  1261,  1263,  1266,  1269,  1273,  1275,  1278,  1281,
    1283,  1285,  1291,  1295,  1296,  1304,  1313,  1317,  1319,  1321,
    1322,  1325,  1328,  1332,  1336,  1341,  1343,  1346,  1350,  1353,
    1355,  1360,  1361,  1363,  1366,  1369,  1371,  1372,  1374,  1377,
    1384,  1388,  1389,  1398,  1401,  1406,  1407,  1410,  1411,  1413,
    1415,  1417,  1423,  1429,  1435,  1437,  1443,  1449,  1459,  1461,
    1467,  1468,  1470,  1472,  1478,  1480,  1482,  1488,  1494,  1496,
    1500,  1504,  1509,  1511,  1513,  1515,  1517,  1520,  1522,  1526,
    1530,  1533,  1537,  1539,  1543,  1545,  1547,  1549,  1551,  1553,
    1555,  1557,  1559,  1561,  1563,  1565,  1568,  1570,  1572,  1573,
    1576,  1579,  1581,  1586,  1587,  1589,  1592,  1596,  1601,  1604,
    1607,  1609,  1612,  1615,  1621,  1627,  1635,  1642,  1644,  1647,
    1650,  1654,  1656,  1659,  1662,  1667,  1670,  1675,  1676,  1681,
    1684,  1686,  1688,  1690,  1692,  1693,  1696,  1702,  1708,  1722,
    1724,  1726,  1730,  1734,  1737,  1741,  1745,  1748,  1753,  1755,
    1762,  1772,  1773,  1785,  1787,  1791,  1795,  1799,  1801,  1803,
    1809,  1812,  1818,  1819,  1821,  1823,  1827,  1828,  1830,  1832,
    1834,  1840,  1841,  1848,  1851,  1853,  1856,  1861,  1864,  1868,
    1872,  1876,  1881,  1887,  1893,  1899,  1906,  1908,  1910,  1912,
    1916,  1917,  1923,  1924,  1926,  1928,  1931,  1938,  1940,  1944,
    1945,  1947,  1952,  1954,  1956,  1958,  1960,  1963,  1965,  1968,
    1971,  1973,  1977,  1980,  1984,  1989,  1992,  1997,  2002,  2006,
    2015,  2019,  2022,  2024,  2027,  2034,  2043,  2047,  2050,  2054,
    2058,  2063,  2068,  2072,  2074,  2076,  2078,  2083,  2092,  2096,
    2099,  2103,  2107,  2112,  2117,  2121,  2124,  2126,  2129,  2132,
    2134,  2138,  2141,  2145,  2150,  2153,  2158,  2163,  2167,  2174,
    2183,  2187,  2190,  2192,  2195,  2198,  2201,  2205,  2210,  2213,
    2218,  2223,  2227,  2234,  2243,  2247,  2250,  2252,  2255,  2258,
    2260,  2262,  2265,  2269,  2274,  2277,  2282,  2289,  2298,  2300,
    2303,  2306,  2308,  2311,  2314,  2318,  2323,  2325,  2330,  2335,
    2339,  2345,  2354,  2358,  2361,  2365,  2367,  2373,  2379,  2386,
    2393,  2395,  2398,  2401,  2403,  2406,  2409,  2413,  2418,  2420,
    2425,  2430,  2434,  2440,  2449,  2453,  2455,  2458,  2460,  2463,
    2470,  2476,  2483,  2491,  2499,  2501,  2504,  2507,  2509,  2512,
    2515,  2519,  2524,  2526,  2531,  2536,  2540,  2549,  2553,  2555,
    2557,  2560,  2562,  2564,  2567,  2571,  2574,  2578,  2581,  2585,
    2589,  2592,  2597,  2601,  2604,  2608,  2611,  2616,  2620,  2623,
    2630,  2637,  2644,  2652,  2654,  2657,  2659,  2661,  2663,  2666,
    2670,  2673,  2677,  2680,  2684,  2688,  2693,  2696,  2700,  2705,
    2708,  2714,  2721,  2728,  2729,  2731,  2732
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     308,     0,    -1,    -1,    -1,    82,    -1,    85,    -1,    86,
      -1,    87,    -1,    83,    -1,    75,    -1,    79,    -1,   145,
      -1,    75,    -1,    79,    -1,    75,    -1,   145,    -1,    88,
      -1,    89,    -1,   147,    -1,    84,    -1,   147,    84,    -1,
      75,    -1,   145,    -1,   175,    -1,   114,   177,   115,    -1,
     114,   181,   115,    -1,   148,    -1,   149,   116,   139,   172,
     140,   117,    -1,   149,   114,   150,   115,    -1,   149,   118,
     144,    -1,   149,   118,   116,   139,   152,   140,   117,    -1,
     149,    86,    -1,   149,    90,   144,    -1,   149,    90,   116,
     139,   152,   140,   117,    -1,   149,    91,    -1,   149,    92,
      -1,   114,   281,   115,   119,   285,   378,   120,    -1,   149,
     119,   150,   120,    -1,   151,    -1,   150,   121,   151,    -1,
      -1,   172,    -1,   153,    -1,   152,   121,   153,    -1,   154,
      -1,    85,   153,    -1,    85,   116,   139,   152,   140,   117,
      -1,   154,   118,   153,    -1,   154,   118,   116,   139,   152,
     140,   117,    -1,   154,    90,   153,    -1,   154,    90,   116,
     139,   152,   140,   117,    -1,    82,   155,    -1,    87,   155,
      -1,   144,   155,    -1,    -1,   155,    86,    -1,   149,    -1,
     141,    -1,   146,    -1,    43,   159,    -1,   157,   159,    -1,
     158,   159,    -1,    91,   156,    -1,    92,   156,    -1,    40,
     156,    -1,    40,   114,   281,   115,    -1,    69,   156,    -1,
      69,   114,   281,   115,    -1,    41,   114,   281,   121,   144,
     115,    -1,    79,    -1,    79,   114,   151,   115,    -1,    79,
     114,   282,   115,    -1,   122,    -1,   123,    -1,   124,    -1,
     125,    -1,   126,    -1,   127,    -1,   156,    -1,   114,   281,
     115,   159,    -1,   159,    -1,   160,   122,   159,    -1,   160,
     128,   159,    -1,   160,   129,   159,    -1,   160,    -1,   161,
     124,   160,    -1,   161,   125,   160,    -1,   161,    -1,   162,
      93,   161,    -1,   162,    94,   161,    -1,   162,    -1,   163,
     130,   162,    -1,   163,   131,   162,    -1,   163,    95,   162,
      -1,   163,    96,   162,    -1,   163,    -1,   164,    97,   163,
      -1,   164,    98,   163,    -1,   164,    -1,   165,   123,   164,
      -1,   165,    -1,   166,   132,   165,    -1,   166,    -1,   167,
     133,   166,    -1,   167,    -1,   168,    99,   167,    -1,   168,
      -1,   169,   100,   168,    -1,   169,    -1,   169,   134,   177,
     135,   170,    -1,   169,   134,   135,   170,    -1,   170,    -1,
     170,    -1,   156,   174,   172,    -1,    -1,   172,    -1,   136,
      -1,   112,    -1,   102,    -1,   103,    -1,   104,    -1,   105,
      -1,   106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,
      -1,   111,    -1,   116,   139,   121,   176,   140,   117,    -1,
     116,   139,   172,   121,   176,   140,   117,    -1,   173,    -1,
     176,   121,   173,    -1,   172,    -1,   177,   121,   172,    -1,
      -1,   177,    -1,   180,    -1,   181,    -1,   185,    -1,   186,
      -1,   198,    -1,   200,    -1,   201,    -1,   206,    -1,   132,
     149,   119,   150,   120,   137,    -1,   278,   135,   318,   179,
      -1,   119,   120,    -1,   119,   139,   139,   217,   182,   140,
     120,    -1,   183,    -1,   182,   139,   183,    -1,   220,    -1,
      43,   220,    -1,   314,    -1,    43,   314,    -1,   179,   140,
      -1,   179,    -1,   184,   179,    -1,   178,   137,    -1,    44,
     114,   177,   115,   179,    -1,    44,   114,   177,   115,   179,
      45,   179,    -1,    46,   114,   177,   115,   191,    -1,    46,
     114,   177,   115,   119,   139,   213,   192,   120,    -1,    56,
     114,   177,   115,   191,    -1,    56,   114,   177,   115,   119,
     139,   213,   194,   120,    -1,   171,    -1,   171,   101,   171,
      -1,   316,    -1,   187,    -1,   188,   121,   187,    -1,    47,
     188,   135,    -1,    48,   135,    -1,   189,    -1,   190,   189,
      -1,   190,   179,    -1,    -1,   193,    -1,   190,   184,    -1,
     193,   190,   184,    -1,    -1,   195,    -1,   190,   197,    -1,
     190,   184,   196,    -1,   195,   190,   197,    -1,   195,   190,
     184,   196,    -1,    -1,   197,    -1,    59,    -1,    59,   137,
      -1,    50,   114,   177,   115,   179,    -1,    49,   179,    50,
     114,   177,   115,   137,    -1,    51,   114,   139,   199,   115,
     179,    -1,   178,   140,   137,   178,   137,   178,    -1,   220,
     178,   137,   178,    -1,    54,   278,   137,    -1,    54,   122,
     177,   137,    -1,    53,   137,    -1,    53,   278,   137,    -1,
      52,   137,    -1,    52,   278,   137,    -1,    55,   178,   137,
      -1,    64,   173,   137,    -1,    65,   173,   137,    -1,    65,
     173,    66,   172,   137,    -1,    60,   181,   202,    -1,    60,
     181,   204,    -1,    60,   181,   202,   204,    -1,   203,    -1,
      61,   114,   101,   115,   181,    -1,   203,    61,   114,   101,
     115,   181,    -1,    62,   114,   101,   115,   181,    -1,   203,
      62,   114,   101,   115,   181,    -1,    61,   114,   139,   139,
     205,   140,   115,   181,   140,    -1,   203,    61,   114,   139,
     139,   205,   140,   115,   181,   140,    -1,    62,   114,   139,
     139,   205,   140,   115,   181,   140,    -1,   203,    62,   114,
     139,   139,   205,   140,   115,   181,   140,    -1,    63,   181,
      -1,   233,    -1,   233,   315,    -1,   233,   363,    -1,   372,
     144,    -1,   372,    -1,    67,   207,   114,   146,   115,   137,
      -1,    67,   207,   114,   146,   135,   208,   115,   137,    -1,
      67,   207,   114,   146,   135,   208,   135,   208,   115,   137,
      -1,    67,   207,   114,   146,   135,   208,   135,   208,   135,
     211,   115,   137,    -1,    67,   207,    54,   114,   146,   135,
     135,   208,   135,   211,   135,   212,   115,   137,    -1,    -1,
      11,    -1,    -1,   209,    -1,   210,    -1,   209,   121,   210,
      -1,   146,   114,   171,   115,    -1,   116,   171,   117,   146,
     114,   171,   115,    -1,    -1,   146,    -1,   211,   121,   146,
      -1,   144,    -1,   212,   121,   144,    -1,   140,    -1,   214,
      -1,   220,    -1,   214,   139,   220,    -1,   140,    -1,   216,
      -1,   230,    -1,   216,   139,   230,    -1,    -1,   218,    -1,
      31,   219,   137,    -1,   218,    31,   219,   137,    -1,   280,
      -1,   219,   121,   280,    -1,   221,    -1,   230,    -1,   222,
     140,   137,    -1,   227,   140,   137,    -1,   224,   140,   137,
      -1,   299,   140,   137,    -1,   302,   140,   137,    -1,   223,
     283,    -1,   239,   223,   283,    -1,   222,   140,   121,   139,
     278,   283,    -1,   373,   278,   317,    -1,   376,   278,   317,
      -1,   235,   376,   278,   317,    -1,   225,    -1,   235,   225,
      -1,   239,   225,    -1,   239,   235,   225,    -1,   224,   140,
     121,   139,   278,    -1,   376,   278,   114,   139,   266,   140,
     115,    -1,   226,   278,   114,   139,   266,   140,   115,    -1,
     116,   139,   268,   140,   117,    -1,   116,   139,   268,   140,
     121,   139,   269,   140,   117,    -1,     3,   223,    -1,     3,
     225,    -1,   227,   140,   121,   139,   144,    -1,     3,   233,
     315,    -1,   228,   140,   121,   139,   315,    -1,   235,     3,
     233,   315,    -1,   233,     3,   315,    -1,   233,     3,   235,
     315,    -1,     3,   144,   136,   172,    -1,   229,   140,   121,
     139,   144,   136,   172,    -1,   232,   231,   140,   137,    -1,
     228,   140,   137,    -1,   229,   140,   137,    -1,   247,   140,
     137,    -1,   315,   317,   283,    -1,   231,   121,   318,   315,
     317,   283,    -1,   243,    -1,   247,    -1,   249,    -1,   289,
      -1,   244,    -1,   248,    -1,   250,    -1,   290,    -1,    -1,
     235,    -1,   236,    -1,   235,   236,    -1,   237,    -1,   320,
      -1,    10,    -1,    12,    -1,    11,    -1,    14,    -1,    70,
      -1,    -1,    13,   114,   238,   292,   115,    -1,   240,    -1,
     235,   240,    -1,   239,   235,   240,    -1,   241,    -1,   240,
     241,    -1,     5,    -1,     7,    -1,     4,    -1,     6,    -1,
       8,    -1,     9,    -1,    72,    -1,    74,    -1,    16,    -1,
      21,    -1,    20,    -1,    18,    -1,    19,    -1,    17,    -1,
      22,    -1,    23,    -1,    15,    -1,    27,    -1,    28,    -1,
      29,    -1,    26,    -1,    24,    -1,    25,    -1,   244,    -1,
     239,   244,    -1,   243,   241,    -1,   243,   241,   235,    -1,
     243,   241,   244,    -1,   245,    -1,   234,   246,   234,    -1,
     242,    -1,   235,   242,    -1,   245,   236,    -1,   245,   242,
      -1,    30,   114,   282,   115,    -1,    30,   114,   177,   115,
      -1,    81,   114,   282,   115,    -1,    81,   114,   177,   115,
      -1,   248,    -1,   239,   248,    -1,   247,   241,    -1,   247,
     241,   235,    -1,   251,    -1,   235,   251,    -1,   248,   236,
      -1,   250,    -1,   239,   250,    -1,   249,   241,    -1,   249,
     241,   235,    -1,    77,    -1,   235,    77,    -1,   250,   236,
      -1,   252,    -1,   262,    -1,   254,   318,   119,   255,   120,
      -1,   254,   318,   280,    -1,    -1,   254,   318,   280,   253,
     119,   255,   120,    -1,   254,   318,   114,   298,   115,   119,
     255,   120,    -1,   254,   318,   291,    -1,    33,    -1,    34,
      -1,    -1,   255,   256,    -1,   257,   137,    -1,    43,   257,
     137,    -1,   233,   258,   137,    -1,    43,   233,   258,   137,
      -1,   372,    -1,   372,   280,    -1,   257,   121,   280,    -1,
     257,   121,    -1,   259,    -1,   258,   121,   318,   259,    -1,
      -1,   261,    -1,   324,   260,    -1,   337,   260,    -1,   363,
      -1,    -1,   261,    -1,   135,   171,    -1,    32,   318,   119,
     264,   378,   120,    -1,    32,   318,   280,    -1,    -1,    32,
     318,   280,   263,   119,   264,   378,   120,    -1,   280,   265,
      -1,   264,   121,   280,   265,    -1,    -1,   136,   171,    -1,
      -1,   267,    -1,   269,    -1,   268,    -1,   268,   140,   121,
     139,   269,    -1,   269,   140,   121,   139,   101,    -1,   268,
     140,   121,   139,   101,    -1,   273,    -1,   269,   140,   121,
     139,   273,    -1,   268,   140,   121,   139,   273,    -1,   268,
     140,   121,   139,   269,   140,   121,   139,   273,    -1,   274,
      -1,   269,   140,   121,   139,   274,    -1,    -1,   271,    -1,
     272,    -1,   272,   140,   121,   139,   101,    -1,   276,    -1,
     275,    -1,   272,   140,   121,   139,   276,    -1,   272,   140,
     121,   139,   275,    -1,   275,    -1,   368,   278,   379,    -1,
     376,   278,   379,    -1,   235,   376,   278,   379,    -1,   225,
      -1,   276,    -1,   368,    -1,   376,    -1,   235,   376,    -1,
     377,    -1,   232,   342,   379,    -1,   232,   346,   379,    -1,
     232,   379,    -1,   232,   357,   379,    -1,   144,    -1,   277,
     121,   144,    -1,   142,    -1,    77,    -1,    78,    -1,   143,
      -1,    77,    -1,    78,    -1,   144,    -1,    77,    -1,    78,
      -1,   372,    -1,   233,    -1,   233,   351,    -1,   281,    -1,
     377,    -1,    -1,   136,   284,    -1,   112,   284,    -1,   172,
      -1,   119,   285,   378,   120,    -1,    -1,   284,    -1,   286,
     284,    -1,   285,   121,   284,    -1,   285,   121,   286,   284,
      -1,   287,   135,    -1,   280,   135,    -1,   288,    -1,   287,
     288,    -1,   118,   280,    -1,   116,   139,   172,   140,   117,
      -1,   116,   139,   316,   140,   117,    -1,   116,   139,   171,
     101,   171,   140,   117,    -1,   118,   116,   139,   152,   140,
     117,    -1,   290,    -1,   239,   290,    -1,   289,   241,    -1,
     289,   241,   235,    -1,   291,    -1,   235,   291,    -1,   290,
     236,    -1,    78,   114,   298,   115,    -1,   293,   379,    -1,
     292,   121,   293,   379,    -1,    -1,   295,   280,   294,   296,
      -1,   233,   342,    -1,    35,    -1,    37,    -1,    36,    -1,
      38,    -1,    -1,   296,   297,    -1,   133,   280,   114,   298,
     115,    -1,   133,   119,   139,   304,   120,    -1,   133,   114,
     139,   292,   140,   115,   119,   139,   304,   120,   114,   298,
     115,    -1,   282,    -1,   172,    -1,   298,   121,   282,    -1,
     298,   121,   172,    -1,    35,   300,    -1,   240,    35,   300,
      -1,   299,   121,   300,    -1,   301,   296,    -1,   301,   296,
     136,   282,    -1,   280,    -1,   279,   114,   139,   292,   140,
     115,    -1,    39,   280,   114,   139,   292,   140,   115,   119,
     120,    -1,    -1,    39,   280,   114,   139,   292,   140,   115,
     119,   303,   304,   120,    -1,   305,    -1,   304,   139,   305,
      -1,   306,   140,   137,    -1,   307,   140,   137,    -1,   223,
      -1,   225,    -1,   306,   140,   121,   139,   278,    -1,   233,
     315,    -1,   307,   140,   121,   139,   315,    -1,    -1,   309,
      -1,   311,    -1,   309,   139,   311,    -1,    -1,   309,    -1,
     220,    -1,   313,    -1,    67,   114,   146,   115,   137,    -1,
      -1,     5,    84,   312,   119,   310,   120,    -1,    43,   311,
      -1,   314,    -1,   329,   181,    -1,   333,   139,   215,   181,
      -1,   224,   181,    -1,   232,   329,   181,    -1,   235,   329,
     181,    -1,   239,   329,   181,    -1,   239,   235,   329,   181,
      -1,   232,   333,   139,   215,   181,    -1,   235,   333,   139,
     215,   181,    -1,   239,   333,   139,   215,   181,    -1,   239,
     235,   333,   139,   215,   181,    -1,   324,    -1,   337,    -1,
     329,    -1,   171,   127,   171,    -1,    -1,    67,   114,   146,
     115,   318,    -1,    -1,   319,    -1,   320,    -1,   319,   320,
      -1,    42,   114,   114,   321,   115,   115,    -1,   322,    -1,
     321,   121,   322,    -1,    -1,   323,    -1,   323,   114,   150,
     115,    -1,    75,    -1,    77,    -1,    78,    -1,    10,    -1,
     325,   318,    -1,   326,    -1,   327,   318,    -1,   328,   318,
      -1,   142,    -1,   114,   325,   115,    -1,   157,   324,    -1,
     157,   235,   324,    -1,   114,   326,   115,   318,    -1,   325,
     355,    -1,   114,   326,   115,   355,    -1,   114,   327,   115,
     356,    -1,   114,   327,   115,    -1,   114,   326,   115,   114,
     139,   270,   140,   115,    -1,   114,   328,   115,    -1,   330,
     318,    -1,   331,    -1,   332,   318,    -1,   325,   114,   139,
     270,   140,   115,    -1,   114,   331,   115,   114,   139,   270,
     140,   115,    -1,   114,   330,   115,    -1,   157,   329,    -1,
     157,   235,   329,    -1,   114,   331,   115,    -1,   114,   331,
     115,   355,    -1,   114,   332,   115,   356,    -1,   114,   332,
     115,    -1,   334,    -1,   335,    -1,   336,    -1,   325,   114,
     277,   115,    -1,   114,   335,   115,   114,   139,   270,   140,
     115,    -1,   114,   334,   115,    -1,   157,   333,    -1,   157,
     235,   333,    -1,   114,   335,   115,    -1,   114,   335,   115,
     355,    -1,   114,   336,   115,   356,    -1,   114,   336,   115,
      -1,   338,   318,    -1,   339,    -1,   340,   318,    -1,   341,
     318,    -1,   347,    -1,   114,   338,   115,    -1,   157,   337,
      -1,   157,   235,   337,    -1,   114,   339,   115,   318,    -1,
     338,   355,    -1,   114,   339,   115,   355,    -1,   114,   340,
     115,   356,    -1,   114,   340,   115,    -1,   338,   114,   139,
     270,   140,   115,    -1,   114,   339,   115,   114,   139,   270,
     140,   115,    -1,   114,   341,   115,    -1,   325,   318,    -1,
     343,    -1,   344,   318,    -1,   345,   318,    -1,   157,   342,
      -1,   157,   235,   342,    -1,   114,   343,   115,   318,    -1,
     325,   361,    -1,   114,   343,   115,   355,    -1,   114,   344,
     115,   356,    -1,   114,   344,   115,    -1,   325,   114,   139,
     270,   140,   115,    -1,   114,   343,   115,   114,   139,   270,
     140,   115,    -1,   114,   345,   115,    -1,   347,   318,    -1,
     348,    -1,   349,   318,    -1,   350,   318,    -1,    77,    -1,
      78,    -1,   157,   346,    -1,   157,   235,   346,    -1,   114,
     348,   115,   318,    -1,   347,   361,    -1,   114,   348,   115,
     361,    -1,   347,   114,   139,   270,   140,   115,    -1,   114,
     348,   115,   114,   139,   270,   140,   115,    -1,   352,    -1,
     353,   318,    -1,   354,   318,    -1,   157,    -1,   157,   235,
      -1,   157,   351,    -1,   157,   235,   351,    -1,   114,   352,
     115,   318,    -1,   355,    -1,   114,   352,   115,   355,    -1,
     114,   353,   115,   356,    -1,   114,   353,   115,    -1,   114,
     139,   270,   140,   115,    -1,   114,   352,   115,   114,   139,
     270,   140,   115,    -1,   114,   354,   115,    -1,   116,   117,
      -1,   116,   117,   356,    -1,   356,    -1,   116,   139,   172,
     140,   117,    -1,   116,   139,   122,   140,   117,    -1,   356,
     116,   139,   172,   140,   117,    -1,   356,   116,   139,   122,
     140,   117,    -1,   358,    -1,   359,   318,    -1,   360,   318,
      -1,   157,    -1,   157,   235,    -1,   157,   357,    -1,   157,
     235,   357,    -1,   114,   358,   115,   318,    -1,   361,    -1,
     114,   358,   115,   361,    -1,   114,   359,   115,   356,    -1,
     114,   359,   115,    -1,   114,   139,   270,   140,   115,    -1,
     114,   358,   115,   114,   139,   270,   140,   115,    -1,   114,
     360,   115,    -1,   362,    -1,   362,   356,    -1,   356,    -1,
     116,   117,    -1,   116,   139,   235,   122,   140,   117,    -1,
     116,   139,   235,   140,   117,    -1,   116,   139,   235,   172,
     140,   117,    -1,   116,   139,     7,   234,   172,   140,   117,
      -1,   116,   139,   235,     7,   172,   140,   117,    -1,   364,
      -1,   365,   318,    -1,   366,   318,    -1,   157,    -1,   157,
     235,    -1,   157,   363,    -1,   157,   235,   363,    -1,   114,
     364,   115,   318,    -1,   355,    -1,   114,   364,   115,   355,
      -1,   114,   365,   115,   356,    -1,   114,   365,   115,    -1,
     114,   364,   115,   114,   139,   270,   140,   115,    -1,   114,
     366,   115,    -1,   368,    -1,   376,    -1,   235,   376,    -1,
     369,    -1,   370,    -1,   157,   233,    -1,   235,   157,   233,
      -1,   157,   377,    -1,   235,   157,   377,    -1,   157,   367,
      -1,   235,   157,   367,    -1,   116,   117,   233,    -1,   371,
     233,    -1,   116,   117,   356,   233,    -1,   371,   356,   233,
      -1,   356,   233,    -1,   116,   117,   369,    -1,   371,   369,
      -1,   116,   117,   356,   369,    -1,   371,   356,   369,    -1,
     356,   369,    -1,   116,   139,   235,   122,   140,   117,    -1,
     116,   139,   235,   172,   140,   117,    -1,   116,   139,   239,
     172,   140,   117,    -1,   116,   139,   239,   235,   172,   140,
     117,    -1,   376,    -1,   235,   376,    -1,   373,    -1,   374,
      -1,   375,    -1,   157,   233,    -1,   235,   157,   233,    -1,
     157,   377,    -1,   235,   157,   377,    -1,   157,   372,    -1,
     235,   157,   372,    -1,   116,   117,   233,    -1,   116,   117,
     356,   233,    -1,   356,   233,    -1,   116,   117,   374,    -1,
     116,   117,   356,   374,    -1,   356,   374,    -1,   116,   139,
     269,   140,   117,    -1,   376,   114,   139,   266,   140,   115,
      -1,   226,   114,   139,   266,   140,   115,    -1,    -1,   121,
      -1,    -1,   136,   172,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   326,   326,   330,   337,   338,   339,   340,   341,   345,
     346,   347,   351,   352,   356,   357,   361,   362,   366,   370,
     371,   382,   384,   386,   387,   389,   394,   395,   401,   403,
     405,   407,   409,   411,   413,   415,   417,   419,   428,   429,
     435,   436,   440,   441,   445,   446,   448,   450,   452,   454,
     456,   461,   463,   465,   477,   478,   486,   489,   491,   493,
     498,   511,   513,   515,   517,   519,   521,   523,   525,   527,
     529,   531,   538,   539,   545,   546,   547,   548,   552,   553,
     560,   561,   563,   565,   570,   571,   573,   578,   579,   581,
     586,   587,   589,   591,   593,   598,   599,   601,   606,   607,
     612,   613,   618,   619,   624,   625,   630,   631,   636,   637,
     640,   647,   652,   653,   661,   662,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,   676,   677,   687,   689,
     694,   695,   700,   701,   707,   708,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   732,   739,   741,   752,   753,
     758,   760,   765,   767,   772,   776,   777,   782,   787,   790,
     792,   794,   804,   806,   817,   818,   820,   824,   826,   830,
     831,   836,   837,   841,   846,   847,   851,   853,   859,   860,
     864,   866,   868,   870,   876,   877,   881,   883,   888,   890,
     892,   897,   899,   904,   906,   910,   913,   917,   920,   924,
     926,   928,   930,   935,   937,   939,   944,   946,   948,   950,
     952,   957,   959,   961,   963,   968,   980,   981,   986,   988,
     993,   997,   999,  1001,  1003,  1005,  1011,  1012,  1018,  1019,
    1023,  1024,  1029,  1031,  1037,  1038,  1040,  1046,  1051,  1061,
    1063,  1067,  1068,  1073,  1075,  1079,  1080,  1084,  1086,  1090,
    1091,  1095,  1096,  1100,  1101,  1116,  1117,  1118,  1119,  1120,
    1124,  1129,  1136,  1146,  1151,  1156,  1164,  1169,  1174,  1179,
    1184,  1214,  1219,  1226,  1228,  1235,  1240,  1245,  1256,  1261,
    1266,  1271,  1276,  1285,  1290,  1320,  1324,  1325,  1326,  1332,
    1337,  1345,  1346,  1347,  1348,  1352,  1353,  1354,  1355,  1360,
    1361,  1370,  1371,  1376,  1377,  1381,  1383,  1385,  1387,  1389,
    1392,  1391,  1403,  1404,  1406,  1416,  1417,  1422,  1424,  1426,
    1428,  1430,  1433,  1435,  1438,  1443,  1445,  1447,  1449,  1451,
    1453,  1455,  1457,  1459,  1461,  1463,  1465,  1467,  1469,  1471,
    1477,  1478,  1480,  1482,  1484,  1489,  1490,  1496,  1497,  1499,
    1501,  1506,  1508,  1510,  1512,  1517,  1518,  1520,  1522,  1527,
    1528,  1530,  1535,  1536,  1538,  1540,  1545,  1547,  1549,  1554,
    1555,  1559,  1561,  1567,  1566,  1570,  1572,  1577,  1579,  1585,
    1586,  1591,  1592,  1597,  1600,  1608,  1609,  1611,  1613,  1618,
    1619,  1625,  1626,  1628,  1631,  1634,  1639,  1640,  1645,  1650,
    1652,  1658,  1657,  1664,  1666,  1672,  1673,  1681,  1682,  1686,
    1687,  1688,  1690,  1692,  1699,  1700,  1702,  1704,  1709,  1710,
    1716,  1717,  1721,  1722,  1727,  1728,  1729,  1731,  1739,  1740,
    1742,  1745,  1747,  1751,  1752,  1753,  1755,  1757,  1761,  1766,
    1774,  1776,  1785,  1787,  1792,  1793,  1794,  1798,  1799,  1800,
    1804,  1805,  1806,  1810,  1811,  1812,  1817,  1818,  1823,  1824,
    1826,  1831,  1832,  1837,  1838,  1839,  1840,  1841,  1856,  1857,
    1862,  1863,  1869,  1871,  1874,  1876,  1878,  1901,  1902,  1904,
    1906,  1911,  1912,  1914,  1919,  1924,  1925,  1931,  1930,  1934,
    1938,  1940,  1942,  1944,  1950,  1951,  1956,  1961,  1963,  1968,
    1970,  1971,  1973,  1978,  1980,  1982,  1987,  1989,  1994,  1999,
    2007,  2013,  2012,  2026,  2027,  2032,  2033,  2037,  2042,  2047,
    2055,  2060,  2071,  2072,  2077,  2078,  2084,  2085,  2089,  2090,
    2091,  2096,  2095,  2106,  2114,  2120,  2126,  2135,  2141,  2147,
    2153,  2159,  2167,  2173,  2181,  2187,  2196,  2197,  2198,  2202,
    2208,  2209,  2219,  2220,  2224,  2225,  2230,  2235,  2236,  2242,
    2243,  2245,  2250,  2251,  2252,  2253,  2288,  2290,  2291,  2293,
    2298,  2303,  2308,  2310,  2312,  2317,  2319,  2321,  2323,  2328,
    2330,  2339,  2341,  2342,  2347,  2349,  2351,  2356,  2358,  2360,
    2365,  2367,  2369,  2381,  2382,  2383,  2387,  2389,  2391,  2396,
    2398,  2400,  2405,  2407,  2409,  2424,  2426,  2427,  2429,  2434,
    2435,  2440,  2442,  2444,  2449,  2451,  2453,  2455,  2460,  2462,
    2464,  2474,  2476,  2477,  2479,  2484,  2486,  2488,  2493,  2495,
    2497,  2499,  2504,  2506,  2508,  2521,  2523,  2524,  2526,  2531,
    2536,  2544,  2546,  2548,  2553,  2555,  2560,  2562,  2579,  2580,
    2582,  2587,  2589,  2591,  2593,  2595,  2600,  2601,  2603,  2605,
    2610,  2612,  2614,  2620,  2622,  2624,  2628,  2630,  2632,  2634,
    2668,  2669,  2671,  2676,  2678,  2680,  2682,  2684,  2689,  2690,
    2692,  2694,  2699,  2701,  2703,  2709,  2710,  2712,  2721,  2724,
    2726,  2729,  2731,  2733,  2747,  2748,  2750,  2755,  2757,  2759,
    2761,  2763,  2768,  2769,  2771,  2773,  2778,  2780,  2788,  2789,
    2790,  2795,  2796,  2800,  2802,  2804,  2806,  2808,  2810,  2817,
    2819,  2821,  2823,  2825,  2828,  2830,  2832,  2834,  2836,  2841,
    2843,  2845,  2850,  2876,  2877,  2879,  2883,  2884,  2888,  2890,
    2892,  2894,  2896,  2898,  2905,  2907,  2909,  2911,  2913,  2915,
    2920,  2927,  2929,  2947,  2949,  2954,  2955
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TYPEDEF", "AUTO", "EXTERN", "REGISTER",
  "STATIC", "INLINE", "FORTRAN", "CONST", "VOLATILE", "RESTRICT", "FORALL",
  "LVALUE", "VOID", "CHAR", "SHORT", "INT", "LONG", "FLOAT", "DOUBLE",
  "SIGNED", "UNSIGNED", "ZERO_T", "ONE_T", "VALIST", "BOOL", "COMPLEX",
  "IMAGINARY", "TYPEOF", "LABEL", "ENUM", "STRUCT", "UNION", "OTYPE",
  "FTYPE", "DTYPE", "TTYPE", "TRAIT", "SIZEOF", "OFFSETOF", "ATTRIBUTE",
  "EXTENSION", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT", "DO", "WHILE",
  "FOR", "BREAK", "CONTINUE", "GOTO", "RETURN", "CHOOSE", "DISABLE",
  "ENABLE", "FALLTHRU", "TRY", "CATCH", "CATCHRESUME", "FINALLY", "THROW",
  "THROWRESUME", "AT", "ASM", "ALIGNAS", "ALIGNOF", "ATOMIC", "GENERIC",
  "NORETURN", "STATICASSERT", "THREADLOCAL", "IDENTIFIER",
  "QUOTED_IDENTIFIER", "TYPEDEFname", "TYPEGENname", "ATTR_IDENTIFIER",
  "ATTR_TYPEDEFname", "ATTR_TYPEGENname", "INTEGERconstant",
  "CHARACTERconstant", "STRINGliteral", "REALDECIMALconstant",
  "REALFRACTIONconstant", "FLOATINGconstant", "ZERO", "ONE", "ARROW",
  "ICR", "DECR", "LS", "RS", "LE", "GE", "EQ", "NE", "ANDAND", "OROR",
  "ELLIPSIS", "MULTassign", "DIVassign", "MODassign", "PLUSassign",
  "MINUSassign", "LSassign", "RSassign", "ANDassign", "ERassign",
  "ORassign", "ATassign", "THEN", "'('", "')'", "'['", "']'", "'.'", "'{'",
  "'}'", "','", "'*'", "'&'", "'+'", "'-'", "'!'", "'~'", "'/'", "'%'",
  "'<'", "'>'", "'^'", "'|'", "'?'", "':'", "'='", "';'", "$accept",
  "push", "pop", "constant", "identifier", "no_01_identifier",
  "no_attr_identifier", "zero_one", "string_literal",
  "string_literal_list", "primary_expression", "postfix_expression",
  "argument_expression_list", "argument_expression", "field_list", "field",
  "field_name", "fraction_constants", "unary_expression",
  "ptrref_operator", "unary_operator", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "AND_expression",
  "exclusive_OR_expression", "inclusive_OR_expression",
  "logical_AND_expression", "logical_OR_expression",
  "conditional_expression", "constant_expression", "assignment_expression",
  "assignment_expression_opt", "assignment_operator", "tuple",
  "tuple_expression_list", "comma_expression", "comma_expression_opt",
  "statement", "labeled_statement", "compound_statement",
  "block_item_list", "block_item", "statement_list",
  "expression_statement", "selection_statement", "case_value",
  "case_value_list", "case_label", "case_label_list", "case_clause",
  "switch_clause_list_opt", "switch_clause_list", "choose_clause_list_opt",
  "choose_clause_list", "fall_through_opt", "fall_through",
  "iteration_statement", "for_control_expression", "jump_statement",
  "exception_statement", "handler_list", "handler_clause",
  "finally_clause", "exception_declaration", "asm_statement",
  "asm_volatile_opt", "asm_operands_opt", "asm_operands_list",
  "asm_operand", "asm_clobbers_list_opt", "label_list",
  "declaration_list_opt", "declaration_list", "KR_declaration_list_opt",
  "KR_declaration_list", "local_label_declaration_opt",
  "local_label_declaration_list", "local_label_list", "declaration",
  "cfa_declaration", "cfa_variable_declaration", "cfa_variable_specifier",
  "cfa_function_declaration", "cfa_function_specifier",
  "cfa_function_return", "cfa_typedef_declaration", "typedef_declaration",
  "typedef_expression", "c_declaration", "declaring_list",
  "declaration_specifier", "type_specifier", "type_qualifier_list_opt",
  "type_qualifier_list", "type_qualifier", "type_qualifier_name", "$@1",
  "declaration_qualifier_list", "storage_class_list", "storage_class",
  "basic_type_name", "basic_declaration_specifier", "basic_type_specifier",
  "direct_type_name", "indirect_type_name", "sue_declaration_specifier",
  "sue_type_specifier", "typedef_declaration_specifier",
  "typedef_type_specifier", "elaborated_type", "aggregate_type", "$@2",
  "aggregate_key", "field_declaration_list", "field_declaration",
  "cfa_field_declaring_list", "field_declaring_list", "field_declarator",
  "bit_subrange_size_opt", "bit_subrange_size", "enum_type", "$@3",
  "enumerator_list", "enumerator_value_opt", "cfa_parameter_type_list_opt",
  "cfa_parameter_type_list", "cfa_parameter_list",
  "cfa_abstract_parameter_list", "parameter_type_list_opt",
  "parameter_type_list", "parameter_list", "cfa_parameter_declaration",
  "cfa_abstract_parameter_declaration", "parameter_declaration",
  "abstract_parameter_declaration", "identifier_list",
  "identifier_or_type_name", "no_01_identifier_or_type_name",
  "no_attr_identifier_or_type_name", "type_name_no_function", "type_name",
  "initializer_opt", "initializer", "initializer_list", "designation",
  "designator_list", "designator", "typegen_declaration_specifier",
  "typegen_type_specifier", "typegen_name", "type_parameter_list",
  "type_parameter", "$@4", "type_class", "assertion_list_opt", "assertion",
  "type_name_list", "type_declaring_list", "type_declarator",
  "type_declarator_name", "trait_specifier", "$@5",
  "trait_declaration_list", "trait_declaration",
  "cfa_trait_declaring_list", "trait_declaring_list", "translation_unit",
  "external_definition_list", "external_definition_list_opt",
  "external_definition", "$@6", "external_function_definition",
  "function_definition", "declarator", "subrange", "asm_name_opt",
  "attribute_list_opt", "attribute_list", "attribute",
  "attribute_name_list", "attribute_name", "attr_name",
  "variable_declarator", "paren_identifier", "variable_ptr",
  "variable_array", "variable_function", "function_declarator",
  "function_no_ptr", "function_ptr", "function_array",
  "KR_function_declarator", "KR_function_no_ptr", "KR_function_ptr",
  "KR_function_array", "variable_type_redeclarator", "paren_type",
  "type_ptr", "type_array", "type_function",
  "identifier_parameter_declarator", "identifier_parameter_ptr",
  "identifier_parameter_array", "identifier_parameter_function",
  "type_parameter_redeclarator", "typedef", "type_parameter_ptr",
  "type_parameter_array", "type_parameter_function", "abstract_declarator",
  "abstract_ptr", "abstract_array", "abstract_function", "array_dimension",
  "multi_array_dimension", "abstract_parameter_declarator",
  "abstract_parameter_ptr", "abstract_parameter_array",
  "abstract_parameter_function", "array_parameter_dimension",
  "array_parameter_1st_dimension", "variable_abstract_declarator",
  "variable_abstract_ptr", "variable_abstract_array",
  "variable_abstract_function",
  "cfa_identifier_parameter_declarator_tuple",
  "cfa_identifier_parameter_declarator_no_tuple",
  "cfa_identifier_parameter_ptr", "cfa_identifier_parameter_array",
  "cfa_array_parameter_1st_dimension", "cfa_abstract_declarator_tuple",
  "cfa_abstract_declarator_no_tuple", "cfa_abstract_ptr",
  "cfa_abstract_array", "cfa_abstract_tuple", "cfa_abstract_function",
  "comma_opt", "assignment_opt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    40,    41,    91,    93,    46,   123,
     125,    44,    42,    38,    43,    45,    33,   126,    47,    37,
      60,    62,    94,   124,    63,    58,    61,    59
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   138,   139,   140,   141,   141,   141,   141,   141,   142,
     142,   142,   143,   143,   144,   144,   145,   145,   146,   147,
     147,   148,   148,   148,   148,   148,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   150,   150,
     151,   151,   152,   152,   153,   153,   153,   153,   153,   153,
     153,   154,   154,   154,   155,   155,   156,   156,   156,   156,
     156,   156,   156,   156,   156,   156,   156,   156,   156,   156,
     156,   156,   157,   157,   158,   158,   158,   158,   159,   159,
     160,   160,   160,   160,   161,   161,   161,   162,   162,   162,
     163,   163,   163,   163,   163,   164,   164,   164,   165,   165,
     166,   166,   167,   167,   168,   168,   169,   169,   170,   170,
     170,   171,   172,   172,   173,   173,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   175,   175,
     176,   176,   177,   177,   178,   178,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   180,   181,   181,   182,   182,
     183,   183,   183,   183,   183,   184,   184,   185,   186,   186,
     186,   186,   186,   186,   187,   187,   187,   188,   188,   189,
     189,   190,   190,   191,   192,   192,   193,   193,   194,   194,
     195,   195,   195,   195,   196,   196,   197,   197,   198,   198,
     198,   199,   199,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   201,   201,   201,   202,   202,   202,   202,
     202,   203,   203,   203,   203,   204,   205,   205,   205,   205,
     205,   206,   206,   206,   206,   206,   207,   207,   208,   208,
     209,   209,   210,   210,   211,   211,   211,   212,   212,   213,
     213,   214,   214,   215,   215,   216,   216,   217,   217,   218,
     218,   219,   219,   220,   220,   221,   221,   221,   221,   221,
     222,   222,   222,   223,   223,   223,   224,   224,   224,   224,
     224,   225,   225,   226,   226,   227,   227,   227,   228,   228,
     228,   228,   228,   229,   229,   230,   230,   230,   230,   231,
     231,   232,   232,   232,   232,   233,   233,   233,   233,   234,
     234,   235,   235,   236,   236,   237,   237,   237,   237,   237,
     238,   237,   239,   239,   239,   240,   240,   241,   241,   241,
     241,   241,   241,   241,   241,   242,   242,   242,   242,   242,
     242,   242,   242,   242,   242,   242,   242,   242,   242,   242,
     243,   243,   243,   243,   243,   244,   244,   245,   245,   245,
     245,   246,   246,   246,   246,   247,   247,   247,   247,   248,
     248,   248,   249,   249,   249,   249,   250,   250,   250,   251,
     251,   252,   252,   253,   252,   252,   252,   254,   254,   255,
     255,   256,   256,   256,   256,   257,   257,   257,   257,   258,
     258,   259,   259,   259,   259,   259,   260,   260,   261,   262,
     262,   263,   262,   264,   264,   265,   265,   266,   266,   267,
     267,   267,   267,   267,   268,   268,   268,   268,   269,   269,
     270,   270,   271,   271,   272,   272,   272,   272,   273,   273,
     273,   273,   273,   274,   274,   274,   274,   274,   275,   275,
     276,   276,   277,   277,   278,   278,   278,   279,   279,   279,
     280,   280,   280,   281,   281,   281,   282,   282,   283,   283,
     283,   284,   284,   285,   285,   285,   285,   285,   286,   286,
     287,   287,   288,   288,   288,   288,   288,   289,   289,   289,
     289,   290,   290,   290,   291,   292,   292,   294,   293,   293,
     295,   295,   295,   295,   296,   296,   297,   297,   297,   298,
     298,   298,   298,   299,   299,   299,   300,   300,   301,   301,
     302,   303,   302,   304,   304,   305,   305,   306,   306,   306,
     307,   307,   308,   308,   309,   309,   310,   310,   311,   311,
     311,   312,   311,   311,   313,   313,   313,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   315,   315,   315,   316,
     317,   317,   318,   318,   319,   319,   320,   321,   321,   322,
     322,   322,   323,   323,   323,   323,   324,   324,   324,   324,
     325,   325,   326,   326,   326,   327,   327,   327,   327,   328,
     328,   329,   329,   329,   330,   330,   330,   331,   331,   331,
     332,   332,   332,   333,   333,   333,   334,   334,   334,   335,
     335,   335,   336,   336,   336,   337,   337,   337,   337,   338,
     338,   339,   339,   339,   340,   340,   340,   340,   341,   341,
     341,   342,   342,   342,   342,   343,   343,   343,   344,   344,
     344,   344,   345,   345,   345,   346,   346,   346,   346,   347,
     347,   348,   348,   348,   349,   349,   350,   350,   351,   351,
     351,   352,   352,   352,   352,   352,   353,   353,   353,   353,
     354,   354,   354,   355,   355,   355,   356,   356,   356,   356,
     357,   357,   357,   358,   358,   358,   358,   358,   359,   359,
     359,   359,   360,   360,   360,   361,   361,   361,   362,   362,
     362,   362,   362,   362,   363,   363,   363,   364,   364,   364,
     364,   364,   365,   365,   365,   365,   366,   366,   367,   367,
     367,   368,   368,   369,   369,   369,   369,   369,   369,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   371,
     371,   371,   371,   372,   372,   372,   373,   373,   374,   374,
     374,   374,   374,   374,   375,   375,   375,   375,   375,   375,
     376,   377,   377,   378,   378,   379,   379
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     3,     3,     1,     6,     4,     3,
       7,     2,     3,     7,     2,     2,     7,     4,     1,     3,
       0,     1,     1,     3,     1,     2,     6,     3,     7,     3,
       7,     2,     2,     2,     0,     2,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     4,     2,     4,     6,     1,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     5,
       4,     1,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     7,
       1,     3,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     4,     2,     7,     1,     3,
       1,     2,     1,     2,     2,     1,     2,     2,     5,     7,
       5,     9,     5,     9,     1,     3,     1,     1,     3,     3,
       2,     1,     2,     2,     0,     1,     2,     3,     0,     1,
       2,     3,     3,     4,     0,     1,     1,     2,     5,     7,
       6,     6,     4,     3,     4,     2,     3,     2,     3,     3,
       3,     3,     5,     3,     3,     4,     1,     5,     6,     5,
       6,     9,    10,     9,    10,     2,     1,     2,     2,     2,
       1,     6,     8,    10,    12,    14,     0,     1,     0,     1,
       1,     3,     4,     7,     0,     1,     3,     1,     3,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     3,
       4,     1,     3,     1,     1,     3,     3,     3,     3,     3,
       2,     3,     6,     3,     3,     4,     1,     2,     2,     3,
       5,     7,     7,     5,     9,     2,     2,     5,     3,     5,
       4,     3,     4,     4,     7,     4,     3,     3,     3,     3,
       6,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       0,     5,     1,     2,     3,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     3,     3,     1,     3,     1,     2,     2,
       2,     4,     4,     4,     4,     1,     2,     2,     3,     1,
       2,     2,     1,     2,     2,     3,     1,     2,     2,     1,
       1,     5,     3,     0,     7,     8,     3,     1,     1,     0,
       2,     2,     3,     3,     4,     1,     2,     3,     2,     1,
       4,     0,     1,     2,     2,     1,     0,     1,     2,     6,
       3,     0,     8,     2,     4,     0,     2,     0,     1,     1,
       1,     5,     5,     5,     1,     5,     5,     9,     1,     5,
       0,     1,     1,     5,     1,     1,     5,     5,     1,     3,
       3,     4,     1,     1,     1,     1,     2,     1,     3,     3,
       2,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     0,     2,
       2,     1,     4,     0,     1,     2,     3,     4,     2,     2,
       1,     2,     2,     5,     5,     7,     6,     1,     2,     2,
       3,     1,     2,     2,     4,     2,     4,     0,     4,     2,
       1,     1,     1,     1,     0,     2,     5,     5,    13,     1,
       1,     3,     3,     2,     3,     3,     2,     4,     1,     6,
       9,     0,    11,     1,     3,     3,     3,     1,     1,     5,
       2,     5,     0,     1,     1,     3,     0,     1,     1,     1,
       5,     0,     6,     2,     1,     2,     4,     2,     3,     3,
       3,     4,     5,     5,     5,     6,     1,     1,     1,     3,
       0,     5,     0,     1,     1,     2,     6,     1,     3,     0,
       1,     4,     1,     1,     1,     1,     2,     1,     2,     2,
       1,     3,     2,     3,     4,     2,     4,     4,     3,     8,
       3,     2,     1,     2,     6,     8,     3,     2,     3,     3,
       4,     4,     3,     1,     1,     1,     4,     8,     3,     2,
       3,     3,     4,     4,     3,     2,     1,     2,     2,     1,
       3,     2,     3,     4,     2,     4,     4,     3,     6,     8,
       3,     2,     1,     2,     2,     2,     3,     4,     2,     4,
       4,     3,     6,     8,     3,     2,     1,     2,     2,     1,
       1,     2,     3,     4,     2,     4,     6,     8,     1,     2,
       2,     1,     2,     2,     3,     4,     1,     4,     4,     3,
       5,     8,     3,     2,     3,     1,     5,     5,     6,     6,
       1,     2,     2,     1,     2,     2,     3,     4,     1,     4,
       4,     3,     5,     8,     3,     1,     2,     1,     2,     6,
       5,     6,     7,     7,     1,     2,     2,     1,     2,     2,
       3,     4,     1,     4,     4,     3,     8,     3,     1,     1,
       2,     1,     1,     2,     3,     2,     3,     2,     3,     3,
       2,     4,     3,     2,     3,     2,     4,     3,     2,     6,
       6,     6,     7,     1,     2,     1,     1,     1,     2,     3,
       2,     3,     2,     3,     3,     4,     2,     3,     4,     2,
       5,     6,     6,     0,     1,     0,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     299,   299,   319,   317,   320,   318,   321,   322,   305,   307,
     306,     0,   308,   333,   325,   330,   328,   329,   327,   326,
     331,   332,   338,   339,   337,   334,   335,   336,   552,   377,
     378,     0,     0,     0,   299,     0,   309,   323,   324,     9,
     366,     0,    10,    16,    17,     0,     2,    72,    73,   570,
      11,   299,   528,   253,     3,   458,     3,   266,     0,     3,
       3,     3,   254,     0,     0,     0,   300,   301,   303,   299,
     312,   315,   347,   291,   340,   345,   292,   355,   293,   362,
     359,   369,   552,   370,   294,   477,   481,     3,     3,     0,
       2,   524,   529,   534,   304,     0,     0,   552,   582,   552,
       2,   593,   594,   595,   299,     0,   736,   737,     0,    14,
       0,    15,   299,   275,   276,     0,   300,   295,   296,   297,
     298,   531,   310,     0,   553,   554,    14,   451,   452,    13,
     447,   450,     0,   508,   503,   494,   451,   452,     0,     0,
     533,     0,   299,     0,     0,     0,     0,     0,     0,     0,
       0,   299,   299,     0,   738,   300,   587,   599,   742,   735,
     733,   740,     0,     0,     0,   260,     2,     0,   537,   445,
     446,   444,     0,     0,     0,     0,   639,   640,     0,     0,
       3,   550,   546,   552,   567,   552,   552,   548,     2,   547,
     552,   606,   552,   552,   609,     0,     0,     0,   299,   299,
     317,   367,     2,   299,   267,   302,   313,   348,   360,   482,
       0,     2,     0,   458,   268,   300,   341,   356,   363,   478,
       0,     2,     0,   316,   342,   349,   350,     0,   357,   361,
     364,   368,     0,   479,   483,     0,     0,     0,     1,   299,
       2,   535,   581,   583,   299,     2,   746,   300,   749,   550,
     550,     0,   300,     0,     0,   278,   552,   548,     2,   299,
       0,     0,   299,     0,   400,   555,     2,   506,     2,   559,
      19,     0,    18,     0,     0,     0,     0,    21,    69,     4,
       8,     5,     6,     7,     0,     0,   299,     2,    74,    75,
      76,    77,    57,    22,    58,    26,    56,    78,   299,     0,
      80,    84,    87,    90,    95,    98,   100,   102,   104,   106,
     108,   112,   500,    23,   454,   456,   499,     0,   453,   457,
       0,   571,   586,   589,   592,   598,   601,   604,     2,   744,
     299,   747,     2,    72,   299,     3,   432,     0,   755,   300,
     299,   312,   340,   292,   355,   362,     3,     3,   414,   418,
     428,   433,   477,   299,   434,   711,   712,   299,   435,   437,
       2,   588,   600,   734,     2,     2,   255,     2,   463,     0,
     461,   460,   459,   146,     2,     2,   257,     2,     2,   256,
       2,   286,     2,   287,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   572,   611,   552,     0,     0,   458,     2,
     566,   575,   665,   568,   569,   538,   299,     2,   605,   614,
     607,   608,     0,   281,   299,   299,   346,   300,     0,   300,
     299,   739,   743,   741,   539,   299,   550,   261,   269,   314,
       0,     2,   540,   299,   504,   343,   344,   288,   358,   365,
     452,   299,   379,   372,   376,   480,   505,   258,   259,   525,
     299,   442,     0,   299,   243,     0,     2,   245,     0,   300,
       0,   263,     2,   264,   283,     0,     0,     2,   299,   550,
     299,   490,   492,   491,   493,     0,     0,   755,     0,   753,
     405,     0,   299,     0,   299,   495,   299,   565,   562,   563,
     564,     0,   557,   560,     0,    20,   299,    64,   299,    78,
      59,   299,    66,   299,   299,    62,    63,     2,   132,     0,
       0,     0,   733,   299,    31,     0,    34,    35,    40,     2,
       0,    40,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   117,   116,     0,    60,    61,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,   651,   455,   648,
     552,   552,   656,   484,   299,     2,   590,   591,     2,   602,
     603,     0,   745,   748,   299,   299,     0,   713,   300,   717,
     708,   709,   715,     0,     2,     2,     0,   673,   552,   755,
     622,   552,   552,   755,   552,   636,   552,   552,   687,   755,
     670,   552,   552,   678,   685,   440,   299,   436,   300,     0,
       0,   299,   723,   300,   728,   755,   720,   299,   725,   755,
     299,   299,     0,     0,    21,     2,     0,    22,     0,   464,
     753,     0,     0,   470,   247,     0,   299,     0,     0,     0,
     552,   578,   580,   610,   552,   617,   620,   573,   612,     0,
     285,     0,   289,   663,     0,   299,   282,     0,     0,     0,
       0,   280,     2,     0,   265,   541,   299,     0,     0,   299,
       0,   300,     3,   421,     3,   425,   424,   596,     0,   536,
     299,    72,     3,   299,   755,   300,     3,   434,   435,     2,
       0,     0,     0,   489,   311,   299,   485,   487,   754,     0,
       0,   403,     0,     3,     2,     2,     0,   507,     3,     0,
     559,    40,   530,     0,     2,     0,     0,     0,    41,     0,
       0,   299,    24,     0,    25,     0,   114,     3,     2,    32,
       0,    38,     0,     2,    29,     0,   113,    81,    82,    83,
      85,    86,    88,    89,    93,    94,    91,    92,    96,    97,
      99,   101,   103,   105,   107,     0,     0,   299,     0,     0,
       0,   652,   653,   649,   650,   502,   501,   299,   299,   719,
     299,   724,   300,   299,   667,   710,   666,     2,   299,     0,
       0,     0,     0,     0,     0,     0,     0,   688,     0,   756,
     674,   625,   641,   675,     2,   621,   628,   438,   623,   624,
     439,     2,   635,   644,   637,   638,   441,   671,   672,   686,
     714,   718,   716,   755,   273,     2,   750,     2,   429,   722,
     727,   430,     3,   408,     3,     3,     3,   458,     0,     0,
       2,   472,   469,   754,     0,   465,     2,   468,   471,     0,
     299,   248,   270,     3,   277,   279,     0,     2,   574,   576,
     577,     2,   613,   615,   616,   550,     0,   664,   542,     3,
     352,   351,   354,   353,   299,   543,     0,   544,     0,   299,
     371,   391,   380,     0,   385,   379,     0,     0,   443,   246,
       0,     0,     3,     2,   673,   436,     0,   532,     0,   755,
     494,   405,   399,   111,   406,   753,     0,   299,   299,   299,
       0,   556,   558,     0,    65,   299,     0,    67,    70,    71,
       0,   133,   463,    79,   115,   130,     3,   114,     0,    28,
      40,     3,     0,    37,   110,     0,     3,   552,   659,   662,
     654,     3,     3,   721,   726,     2,    72,   299,     3,     3,
     300,     0,     3,   552,   631,   634,   552,   552,   681,   684,
     299,     3,   626,   642,   676,   299,   299,   431,   299,   299,
       0,     0,     0,     0,   262,   111,     0,     3,     3,     0,
     466,     0,   462,     0,     0,   251,   299,     0,     0,   134,
       0,     0,     0,     0,     0,   134,     0,     0,   114,   114,
     226,    21,   366,   446,    69,     0,    22,   135,     0,     3,
     136,   137,     2,   148,   138,   139,   140,   141,   142,   143,
     150,     0,   152,     0,     0,     0,   299,   299,   458,   552,
       0,   545,   379,   391,     0,     0,     0,   697,     0,   389,
     392,   396,   552,   396,   702,   395,   694,   552,   552,   388,
     381,   386,   299,   584,     2,   669,   668,     0,   674,     2,
     486,   488,   404,     0,   509,     3,   517,   518,     0,     2,
     513,     3,     3,     0,     0,   561,     0,   753,   114,     0,
       3,    54,     0,    54,    54,     3,    42,    44,    39,     0,
       3,   109,     0,     2,   655,   657,   658,     0,     0,   299,
       0,     0,     0,     3,   552,     0,     2,   627,   629,   630,
       2,   643,   645,     2,   677,   679,   680,     0,     0,    72,
       0,     3,     3,     3,     3,   416,   415,   419,   752,     2,
       2,   751,     0,     0,     0,     0,     3,   467,     3,     0,
     249,   151,   153,     0,     0,     0,     0,     2,   197,     0,
     195,     0,     0,     0,     0,     0,     0,     0,     0,   227,
       0,     0,   157,   154,   299,     0,   552,     0,   272,   284,
       3,     3,   290,   551,   618,   299,     0,   382,     0,     0,
       0,     0,   398,   698,   699,   552,   383,   393,   397,   394,
     695,   696,   387,   374,   299,   271,   299,   402,     0,   520,
     497,   299,     0,     0,   496,   511,    68,     0,   131,   128,
       0,    51,     2,    45,    52,    53,     0,     0,     0,     0,
      27,     0,   660,   299,   585,   597,   729,   730,   731,     0,
     682,   299,   299,   299,     3,     3,     0,   690,     0,     0,
       0,     0,   299,   299,     3,   549,   473,   474,     0,   252,
       0,     0,     0,     0,   299,   198,   196,     0,   193,   199,
       0,     0,     0,     0,   203,   206,   204,   200,     0,   201,
       0,     0,    40,   149,   147,   134,   250,     0,     0,   375,
     384,   552,   705,   707,   700,   391,   423,   427,   426,     0,
     514,     2,   515,     2,   516,   510,   299,    36,   129,    55,
       0,    43,    33,     2,    49,     2,    47,    30,     3,   732,
       3,     3,     3,     0,     0,   689,   691,   632,   646,   274,
       2,   413,     3,   412,     0,   476,   134,     0,     0,   134,
       3,     0,   134,     3,   300,   299,   194,     0,     2,     2,
     215,   205,     0,     0,     0,     0,     0,     0,   145,   579,
     619,     2,   701,   703,   704,   390,     2,     0,     0,     2,
       3,     0,     0,     0,     0,     0,     0,   692,   693,   299,
       0,   475,   158,     0,     0,     2,   171,   134,   160,     0,
     188,     0,   134,     0,   300,     2,   162,     0,     2,     0,
       2,     2,     2,   202,     0,     0,   228,    37,   299,   299,
     519,   521,   512,     0,     3,     3,   661,   633,   647,   683,
     417,   134,   164,   167,     0,   166,   170,     3,   173,   172,
       0,   134,   190,   134,     3,     0,   299,     0,   299,     0,
       2,     0,     2,     0,   221,     0,     0,     0,   229,   230,
     144,     3,     2,    46,     0,     0,   159,     0,     0,   169,
     239,   174,     2,   241,   189,     0,   192,   178,   207,     3,
     216,   220,   209,     3,     0,   299,     0,   299,   228,     0,
       0,     0,   228,     0,     0,     0,    50,    48,   165,   168,
     134,     0,   175,   299,   134,   134,     0,   179,     0,     0,
     697,   217,   218,   219,     0,   208,     3,   210,     3,     0,
       0,     0,   222,     0,   231,   706,   299,   155,   176,   161,
     134,   242,   191,   186,   184,   180,   163,   134,     0,   698,
       0,     0,     0,   234,     0,   232,     0,   234,     0,   156,
     177,   187,   181,   185,   184,   182,     3,     3,     0,     0,
     235,     0,     0,   223,     0,   498,   183,   211,   213,     3,
       3,     0,     0,     0,     0,   212,   214,   236,   237,     0,
     233,   224,     0,     0,   225,   238
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   778,   454,   292,    49,   130,   131,   293,   294,   272,
     295,   296,   730,   731,  1075,  1076,  1077,  1201,   297,   369,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   966,   508,   915,   534,   313,   916,   997,
     998,  1497,  1000,  1001,  1002,  1003,  1498,  1004,  1005,  1403,
    1404,  1366,  1367,  1368,  1471,  1472,  1476,  1477,  1522,  1523,
    1006,  1321,  1007,  1008,  1254,  1255,  1256,  1449,  1009,  1150,
    1427,  1428,  1429,  1531,  1549,  1441,  1442,   455,   456,   840,
     841,   974,    52,    53,    54,    55,    56,   336,   153,    59,
      60,    61,    62,   180,   338,    64,    65,   252,    67,    68,
     262,   340,   341,    71,    72,    73,   117,    75,   198,   343,
     118,    78,   119,    80,    81,   670,    82,   669,   872,   873,
    1028,  1029,  1177,  1030,    83,   481,   479,   701,   822,   823,
     346,   347,   672,   673,   674,   348,   349,   675,   351,   452,
    1011,   132,   133,   315,   316,   165,   629,   630,   631,   632,
     633,    84,   120,    86,   476,   477,   890,   478,   267,   485,
     317,    87,   134,   135,    88,  1286,  1059,  1060,  1061,  1062,
      89,    90,   690,    91,   261,    92,    93,   181,   968,   664,
     400,   124,    94,   491,   492,   493,   182,   256,   184,   185,
     186,   257,    97,    98,    99,   100,   101,   102,   103,   189,
     190,   191,   192,   193,   791,   590,   591,   592,   593,   194,
     595,   596,   597,   558,   559,   560,   561,  1034,   104,   599,
     600,   601,   602,   603,   604,  1035,  1036,  1037,  1038,   579,
     354,   355,   356,   357,   318,   159,   106,   107,   108,   359,
     699,   605
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1330
static const yytype_int16 yypact[] =
{
    6225,  5848, -1330,    41, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330,    44, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,   160, -1330,
   -1330,  1888,  1143,   152,  7885,   161, -1330, -1330, -1330, -1330,
   -1330,   267, -1330, -1330, -1330,   930,   170, -1330, -1330, -1330,
   -1330,  3147, -1330, -1330, -1330,    75,   301, -1330,  1958, -1330,
   -1330, -1330, -1330,  1627,   423,    40,  8006, -1330, -1330,  3147,
     760, -1330, -1330,   725,   435,  4274,  1756,   809,   725,   987,
   -1330, -1330,   160, -1330,   725,  1086, -1330,   265, -1330,   447,
     450, -1330, -1330, -1330, -1330,   351,   301,   160, -1330,   160,
   -1330, -1330, -1330, -1330,  8356,  1958, -1330, -1330,  1958, -1330,
     337, -1330,  8476, -1330, -1330,  1743,  9451, -1330,  1134,  1134,
    1134, -1330, -1330,   862,   160, -1330,   432,   459,   482, -1330,
   -1330, -1330,   487, -1330, -1330, -1330, -1330, -1330,   511,   519,
   -1330,   413,  9017,  2489,   116,   434,   446,   525,   537,   556,
     561,  9526,  7391,   567, -1330,  3761, -1330, -1330, -1330, -1330,
     570, -1330,   105,  5159,  5159, -1330,   586,   266, -1330, -1330,
   -1330, -1330,   601,   369,   380,   402, -1330, -1330,  1627,  1992,
     603,   654, -1330,    56, -1330,   160,   160,   301, -1330, -1330,
      68, -1330,   160,   160, -1330,  2640,   630,   635,  1134,  6918,
   -1330, -1330, -1330,  3147, -1330, -1330,   725, -1330, -1330, -1330,
     301, -1330,  1958,    75, -1330,  8202, -1330,  1134,  1134,  1134,
     301, -1330,  1888, -1330,  3470, -1330, -1330,   610,  1134, -1330,
    1134, -1330,  1182,  1134, -1330,  1888,   619,   624, -1330,  7885,
     540, -1330, -1330, -1330,  9378, -1330, -1330,  3910, -1330,   654,
      53, 10308,  9451,  1743,  2640, -1330,    69, -1330, -1330,  8476,
    1958,   656, 10981,  1143,   666, -1330, -1330,   383, -1330,   453,
   -1330,   692,   757, 10367,   729, 10308, 10426, -1330,   743, -1330,
   -1330, -1330, -1330, -1330, 10485, 10485,  8781,   170, -1330, -1330,
   -1330, -1330, -1330, -1330, -1330, -1330,  1854,  1766,  9017, 10308,
   -1330,   571,   562,   733,   403,   661,   742,   720,   772,   811,
      80, -1330, -1330, -1330,   587, -1330, -1330,   242, -1330, -1330,
    2489, -1330, -1330,    52,   795, -1330,   295,   795, -1330, -1330,
    8356, -1330,   800,   803,  9135, -1330, -1330,  1159,  2129,  8562,
    6918,   725, -1330,   725,  1134,  1134, -1330, -1330, -1330, -1330,
   -1330, -1330,  1134,  8356,  1958, -1330, -1330,  9526,  1829, -1330,
   -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,  5097, 10308,
   -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330, -1330, -1330,   701,   806,   813,   817,   776,   819,
     827,   839,  1992, -1330, -1330,   160,   787,   812,    75,   849,
   -1330, -1330,   851, -1330, -1330, -1330,  9378, -1330, -1330, -1330,
   -1330, -1330,  2640, -1330,  9017,  9017, -1330,  1134,  1743,  7053,
    8637, -1330, -1330, -1330, -1330,  9378,    53, -1330, -1330,   725,
     301, -1330, -1330,  9378, -1330,  4136, -1330, -1330,  1134,  1134,
     267,  9017, -1330,   856, -1330,  1134, -1330, -1330, -1330, -1330,
    9719, -1330,   334, 10721, -1330,   301,   858, -1330,  1743, 10761,
   10544, -1330, -1330, -1330, -1330,   873,  2640, -1330,  8637,   654,
    7764, -1330, -1330, -1330, -1330,  1408,   393,   834,  1143,   864,
     855,   874, 10981,  1547,  8476, -1330, 10981, -1330, -1330, -1330,
   -1330,   596, -1330,   881,   859, -1330,  8781, -1330,  9566, -1330,
   -1330,  8781, -1330,  8899,  8781, -1330, -1330,   170, -1330,   598,
     889,   892, -1330,  7143, -1330,    85, -1330, -1330, 10308, -1330,
     542, 10308, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330, -1330, -1330, 10308, -1330, -1330, 10308, 10308, 10308,
   10308, 10308, 10308, 10308, 10308, 10308, 10308, 10308, 10308, 10308,
   10308, 10308, 10308, 10308, 10308,  3975,   587,   600, -1330, -1330,
     160,   160, -1330, -1330,  9017, -1330, -1330,   851, -1330, -1330,
     851, 10603, -1330, -1330,  9526,  7143,   893, -1330,  9451, -1330,
   -1330,   570, -1330,   895,   566,   904, 10308,  2075,    76,   834,
   -1330,   160,   160,   834,   202, -1330,   160,   160,   851,   834,
   -1330,   160,   160, -1330,   795, -1330,  9599,  1958, 10912,   173,
     526,  9599, -1330,  3910, -1330,   834, -1330,  8356, -1330,    55,
    6359,  6359,  1958, 10190,   891, -1330,   960,   896,   899, -1330,
     909,  5159,   408, -1330,  1005,  1958,  6359,   540,  1743,   540,
     209,   795, -1330, -1330,   275,   795, -1330, -1330, -1330,  1743,
   -1330,   413, -1330,   795,   301,  9719, -1330,   621,   926,   622,
     928, -1330,   800,   301, -1330, -1330,  9378,   301,   631,  2873,
     927, 10912, -1330, -1330,   935, -1330, -1330, -1330,   540, -1330,
   10837,   803, -1330,  6359,   543,  8562, -1330, -1330,   570,   925,
     934,  1408,  2646, -1330, -1330, 10981, -1330, -1330,  1143,   936,
   10308, -1330,  1143,   938, -1330, -1330,   946, -1330,   938,   947,
     453, 10308, -1330,   950,   170,   949,   952,   953, -1330,   959,
     963,  7143, -1330, 10308, -1330, 10249, 10308,   966, -1330, -1330,
     633, -1330, 10308, -1330, -1330,   683, -1330, -1330, -1330, -1330,
     571,   571,   562,   562,   733,   733,   733,   733,   403,   403,
     661,   742,   720,   772,   811, 10308,   164,  9719,   965,   976,
     977,   600, -1330, -1330, -1330, -1330, -1330,  9719,  9719, -1330,
    8356, -1330,  7515,  9253, -1330, -1330, -1330,   566,  9719,   901,
     979,   980,   986,   990,   996,  1001,  1004, -1330,  5001, -1330,
    2075, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,   851,
   -1330, -1330, -1330,   834, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330, -1330, -1330,  1008,  1010, -1330,    75,   966, 10190,
   -1330, -1330, -1330,  5097,   982, -1330, -1330, -1330, -1330,  1143,
    6749,  1096, -1330, -1330, -1330, -1330,   994, -1330, -1330, -1330,
     851, -1330, -1330, -1330,   851,   654,  1019,   851, -1330, -1330,
   -1330, -1330, -1330, -1330,  7391, -1330,   301, -1330,  1023,  9566,
   -1330,  1424, -1330,   421,  1143, -1330,  1035,  1030, -1330, -1330,
    1036,  1040, -1330,   822,  1684, -1330,   552, -1330,  2646,   834,
   -1330,   855, -1330, -1330, -1330,   864,  1046, 10981,  8476,  9017,
    1050, -1330, -1330,   665,  1039,  7391,   540,  1039, -1330, -1330,
    1039, -1330,  5097, -1330, -1330, -1330,  1045, 10308,  1051, -1330,
   10308, -1330,  1051, -1330, -1330, 10308, -1330,   305,   795, -1330,
   -1330, -1330, -1330, -1330, -1330, -1330,   803,  9135, -1330, -1330,
    7639,  1055, -1330,   308,   795, -1330,   311,   328,   795, -1330,
    1134,  6615, -1330, -1330, -1330,  9719,  9719, -1330,  8637,  8637,
    1062,  1058,  1060,  1067, -1330,   655,   304,   966, -1330,  1051,
   -1330,  5159, -1330, 10308,   426, -1330,  7019,  1057,  1073, 10131,
    1074,  1075,   885,  1043,   501, 10308,  1077,   301, 10308, 10308,
    1185,  1065,  1066,   267,   113,   637,  1068,  1072,  1082, -1330,
   -1330, -1330,  1085, -1330, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330,  1076, -1330,  1143,  1095, 10308,  9719,  9719,    75,   160,
    1097, -1330, -1330,  1424,   427,  2325, 10308,  2260,   431, -1330,
   -1330,  1079,    72,  1079, -1330, -1330, -1330,   160,   160,  1143,
   -1330, -1330,  3323, -1330, -1330, -1330, -1330,  1110,  1684, -1330,
   -1330,  1094, -1330,  1108, -1330,   938, -1330, -1330,  1743,  1109,
   -1330, -1330, -1330,   673,  1116, -1330,  1125,   909, 10308,  1126,
    1045, -1330,  1167, -1330, -1330,  1132, -1330,   146, -1330,  1127,
    1132, -1330,  1149, -1330, -1330, -1330,   851,  1152,  1161,  7267,
    1157,  1160,  1163, -1330,   160,  1169, -1330, -1330, -1330,   851,
   -1330, -1330, -1330, -1330, -1330, -1330,   851, 10308, 10308,   803,
    1165, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330, 10308, 10308,  1168,  1171,  1132, -1330, -1330,  1143,
   -1330, -1330, -1330, 10308, 10308,  1236, 10308, -1330, -1330,  1154,
   -1330,  1158, 10308,  1162,  1166, 10308,  1123,  1172,    38, -1330,
      82,  1907, -1330, -1330,  6749,  1174,   160,   448, -1330, -1330,
   -1330, -1330, -1330, -1330, -1330,  9411,   460, -1330,   762,  1183,
    1187,  1191, -1330,  2260, -1330,   160, -1330, -1330, -1330, -1330,
   -1330, -1330, -1330, -1330,  9947, -1330,  8637, -1330,  1195, -1330,
   -1330,  8476,   462,   471, -1330,  1192, -1330,  1193, -1330, -1330,
    1204,  1240, -1330, -1330,  1240,  1240,  1051,  1210,  1516,  1643,
   -1330,  1212, -1330,  9719, -1330, -1330, -1330, -1330, -1330,  1214,
   -1330,  9719,  9719,  9719, -1330, -1330,  1216, -1330,  1218,  1229,
    1230,   679,  8322,  8442, -1330, -1330, -1330, -1330,  1232, -1330,
     690,   693,  1239,   710,  6884, -1330, -1330,   513, -1330, -1330,
     723,  1241,  1243,   301,  1287,   825, -1330, -1330, 10308, -1330,
    1246,   413, 10308, -1330, -1330, 10131, -1330,  1247,  1251, -1330,
   -1330,   439,   795, -1330, -1330,  1424, -1330, -1330, -1330,  1235,
   -1330, -1330, -1330, -1330, -1330, -1330,  8476, -1330, -1330, -1330,
    1051, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330, -1330,  1244,  1253, -1330, -1330, -1330, -1330, -1330,
   -1330, -1330,  1256, -1330,  1257, -1330, 10131,   102, 10308, 10131,
   -1330,  1260, 10308, -1330,  6149,  8476, -1330,   386,  1275,  1280,
   -1330, -1330,  1268,  1269,  1252,   413,   197,   763, -1330, -1330,
   -1330, -1330, -1330, -1330,   851, -1330, -1330,  1958,  1743,  1264,
    1132,  1051,  1051,  1276,  1278,  1279,  1282, -1330, -1330,  8637,
    1274, -1330,  1354, 10308,  1267, -1330, -1330, 10041, -1330,   727,
   -1330,  1266, 10131,  1270,  8712, -1330, -1330,  1290, -1330,  1291,
   -1330,  1307,  1309, -1330,  1277,  1281,   195,  1283,  9719,  8476,
   -1330, -1330, -1330,  1294,  1132,  1132, -1330, -1330, -1330, -1330,
   -1330, 10131,   314, -1330,   327, -1330, -1330,  6528, -1330, -1330,
    1284, 10308, -1330, 10308,  6528,   301,  9566,   301,  9566,  1298,
   -1330,  1299, -1330,  1292, -1330, 10308,  1302,   237,  1305, -1330,
   -1330, -1330,  1310, -1330,  1312,  1314, -1330, 10308, 10308, -1330,
   -1330,   847,    86, -1330, -1330,  1296, -1330,   847, -1330, -1330,
    2447,   540, -1330, -1330,   301,  9566,   301,  9566,   195,  1318,
   10308,  1301,   195,   195,  1326,  1330, -1330, -1330, -1330, -1330,
   10041,  1334,   847,  8127, 10308,  9951,  1336,   847,  1331,  2447,
    2348, -1330, -1330, -1330,  1344, -1330, -1330, -1330, -1330,  1325,
     413,  1347, -1330,   273, -1330, -1330,  9017, -1330,  9813, -1330,
   10041, -1330, -1330,  1328,  9723, -1330, -1330,  9951,   301,  2348,
     301,  1348,  1352,   413,  1355, -1330,  1335,   413,   738, -1330,
    9813, -1330, -1330, -1330,  9723, -1330, -1330, -1330,   301,   301,
   -1330,   485, 10308, -1330,   740, -1330, -1330, -1330, -1330, -1330,
   -1330,   413,   540,  1353,  1337, -1330, -1330, -1330, -1330,   755,
   -1330, -1330,  1339,   540, -1330, -1330
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1330,  4602,  1553, -1330,  2208, -1330,     7,     0,   -94, -1330,
   -1330,   478,  -507,  -466,  -839,  -847, -1330,  -174,  5285,   694,
   -1330,    66,   362,   365,   538,   366,   931,   937,   940,   924,
     939, -1330,   320,  -636,  4424,  -882, -1330, -1330,   578,  -177,
    -942,  -361, -1330,   120, -1330,   354, -1077, -1330, -1330,    67,
   -1330, -1071, -1040,   183, -1330, -1330, -1330, -1330,    -9, -1090,
   -1330, -1330, -1330, -1330, -1330, -1330,   262, -1329, -1330, -1330,
    -798, -1330,    54,     4, -1330,   109, -1330,  -306, -1330, -1330,
   -1330,   512,  -805, -1330, -1330,     3, -1131,   270,   704, -1330,
   -1330, -1330,  -145, -1330,   250,  1286,  -188,  2355,  4289, -1330,
   -1330,    18,  1452,   993,  1681, -1330,  2638, -1330, -1330,   112,
    2990, -1330,  3232,  1709, -1330, -1330, -1330,  -833, -1330,   658,
     505,   257,   500,  -445, -1330, -1330,   837,   645,  -484, -1330,
    -489,  -339,  -560, -1330, -1330,  -919,  -900,  -129,  1056, -1330,
     240, -1330,   970,  -170,  -275,  -200,  -136,   629,   717, -1330,
     911, -1330,  3561,  1374,  -401,   857, -1330, -1330,   664, -1330,
    -432, -1330,   316, -1330, -1330, -1330, -1224,   360, -1330, -1330,
   -1330,  1091, -1330,    23, -1330, -1330,  -799,  -109, -1287,  -148,
    5540, -1330,  5415, -1330,   845, -1330,  -100,    90,  -175,  -171,
    -162,     2,   -40,   -34,   -30,   493,    15,    22,    32,   -92,
    -161,  -159,  -157,  -156,  -314,  -467,  -462,  -442,  -512,  -313,
    -534, -1330, -1330,  -503,  1006,  1011,  1014,  1751,  5167,  -538,
    -510,  -504,  -500,  -533, -1330,  -939, -1005,  -999,  -995,  -568,
    -305,  -309, -1330, -1330,   392,   502,   -58, -1330,  3974,   -39,
    -574,  -222
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -528
static const yytype_int16 yytable[] =
{
      50,   111,    96,   385,   113,   145,   255,   386,   110,   668,
     416,   146,   161,   427,   735,   147,   387,   388,    69,   389,
    1169,   390,   391,   350,   589,   594,  1170,   371,   372,   580,
    1171,   111,   111,   398,    50,  1010,    96,   717,   811,  1115,
    1116,  1012,  1042,  1144,   614,    50,   248,   271,   618,   793,
     783,    50,    69,   156,   762,   796,   834,   140,    50,  1117,
     148,   803,  1349,    50,   894,   187,    50,   149,   210,    50,
     196,   220,   213,   161,   784,   792,  1405,   150,   385,   393,
     785,   703,   386,  1080,   786,   708,   413,   394,  1174,  1453,
      95,   387,   388,   331,   389,   859,   390,   391,    33,   457,
     654,   461,   463,   319,  1258,    50,  1147,  1148,    50,   509,
      33,    33,    76,  1323,    33,    50,   511,   780,    33,   663,
     397,   197,   781,   111,    95,   121,  1486,   667,  1488,   686,
    1126,   824,   824,  -240,  -240,   144,  1260,   826,   145,   658,
     660,    95,   782,    50,   146,   156,    76,   824,   147,  1363,
    1364,  1405,   843,   183,   393,    50,    95,   361,   122,    95,
     109,   693,   394,   687,   423,  1432,   565,   462,   399,   462,
     240,  1131,   399,    43,    44,  1259,   168,  1132,    50,    50,
     554,   156,   407,   467,   399,   399,  1198,   163,   399,  1165,
     794,   586,   585,   148,   824,    50,  1261,   926,   652,   882,
     149,   728,    33,    50,   903,   156,  -240,   931,   932,   707,
     150,   164,    50,   145,   555,    50,   241,   430,   942,   146,
     423,  1365,   111,   147,   780,  1203,   365,   503,   719,   781,
     240,   321,   111,    95,  1274,   111,  1208,   657,   659,    50,
     111,    96,   366,   941,    33,    95,   796,   451,   -10,   782,
      63,    33,   954,    50,    50,   696,   156,    69,   930,   161,
      50,   457,   449,   111,  1209,   771,   139,   784,   384,   183,
      57,   114,   573,   785,   594,   141,  1323,   786,   953,   270,
     457,   825,   825,  1323,    63,   723,  1117,   151,   457,   766,
     814,   350,   647,    95,   815,   582,  1409,   825,   172,   925,
     648,   580,  1320,   656,    57,    95,   580,   405,   820,   661,
     780,  1425,  1385,  1115,  1116,   781,   801,    33,   585,   509,
      50,  1053,   361,   847,   509,   399,   713,   509,   715,    95,
     424,   716,  1386,  1117,   720,   782,   204,    50,    50,   214,
     432,   500,  1323,   465,   825,   249,   793,    33,   250,  1010,
      33,    76,  1461,    33,    50,  1012,    76,   563,    50,  1291,
     866,  1294,  1296,   564,   535,   536,   647,   797,   627,   811,
      33,   800,  1462,   784,   648,   319,   319,   806,   756,   785,
    1373,   142,   686,   786,   350,  1505,   235,   375,  1516,   851,
    1172,   399,    50,   818,   361,  1112,  1113,   821,  1504,  1409,
     535,  1470,   319,   376,  1409,  1122,   510,  1475,  1517,   568,
      95,   399,    50,  1102,  1105,  1437,   687,  1525,    50,  1083,
     166,   399,  1096,  1520,   399,  1100,   195,   585,   588,  1409,
    1524,  1123,  1500,  1363,  1364,   535,  1409,  1507,  -295,  1322,
    1400,  1123,  1103,   158,   585,   319,   350,   238,  1438,   677,
    -523,  1350,   426,   111,  1078,   678,  1160,  1161,    50,  1117,
     110,   934,  1439,   487,   319,   240,    50,  1063,   361,  1445,
      50,  1446,    96,   251,  1169,    50,   952,   594,   111,   999,
    1170,    33,   183,   111,  1171,   428,  1234,  1235,    69,    63,
     378,   350,   350,  1197,   458,   835,  1055,   270,   544,   545,
     469,   380,   105,   105,   158,  1375,   379,   350,   694,    57,
     954,  1482,  1394,  1395,   695,   111,   483,   381,    76,   484,
     111,   457,   729,   382,   836,   319,   626,   734,   488,   845,
     489,   490,  1502,   546,   547,   879,   105,    76,   434,   383,
     855,  1174,  1039,   837,   157,    76,   -12,  1129,  1039,   322,
     665,   446,  1175,  1341,   350,   399,   188,   856,  1040,   211,
      95,   323,   221,  1130,  1167,   588,   686,   812,  1176,  1129,
    1274,   105,   582,  -448,   952,   679,    39,   172,   169,   170,
      42,  1175,    76,  1281,    50,  1266,  1178,    50,  1178,    43,
      44,   957,  1283,   773,   615,   422,  -449,  1270,   619,  1282,
     687,   266,  1443,   737,   738,   739,  1541,    50,  1284,  1443,
       8,     9,    10,    11,    12,   109,   510,   109,  1135,  1114,
    1542,   510,    50,  1142,   510,   268,   111,   964,    43,    44,
      43,    44,   580,   269,   723,    50,   157,   111,    50,   111,
     324,    39,    33,   816,   844,    42,   846,   817,   362,    50,
    1326,   422,   325,  1298,    43,    44,   458,   883,   733,   585,
    1489,  1300,  1301,  1302,  1493,    47,    48,  1050,  1501,   816,
      36,   326,   157,  1049,   779,   458,   327,   588,   111,   586,
     777,   360,   585,   458,   364,   878,   540,   541,    47,    48,
     158,    50,    50,   537,    51,   112,   157,   970,   111,   538,
     539,   556,   111,   399,    58,    58,   373,  1018,   431,    47,
      48,   709,   277,   722,   556,   377,   399,   710,   684,   723,
      63,   397,    47,    48,   395,    43,    44,  1402,    51,     2,
     200,     4,     5,     6,     7,   350,   860,   862,    58,   143,
      57,   105,   723,   723,   414,    51,   868,   437,   919,   415,
     686,   504,   564,   367,   920,  1337,   447,   179,   548,   549,
     203,   448,  1107,    51,     2,   200,     4,     5,     6,     7,
      58,  1031,  -112,    58,   858,   470,  -112,    50,    76,  1033,
    1065,   779,   588,   865,   687,  -401,   920,   867,  1194,  1459,
      50,   913,    76,   999,   564,   222,  1309,    37,   112,    38,
    1310,  1468,  1402,   923,   920,  1316,   112,   494,  1317,   254,
     259,   723,  -296,   362,   723,   240,   321,   399,  1162,     8,
       9,    10,    11,    12,  1491,  1319,   542,   543,  1431,   350,
     350,   723,    37,   627,    38,  1127,   298,   143,  1327,   111,
     996,   495,  1410,   498,   723,   112,   334,   813,   723,   203,
     385,    33,   551,  1535,   386,  1544,   337,   503,    69,   564,
     319,  1541,   827,   387,   388,   550,   389,   779,   390,   391,
    1552,    50,   179,   179,   111,   842,  1553,   321,   399,    36,
     588,   687,   773,  1387,   920,   362,  1332,  1333,    50,   254,
     407,   643,   399,  1312,  1363,  1364,  1543,    51,   812,  1204,
    1205,  1056,   740,   741,  1338,   552,   111,   742,   743,   203,
     553,   328,   627,  1066,   748,   749,   458,   574,   111,    58,
      -3,   640,   111,  1031,   650,  1074,   651,   393,   641,  1074,
     458,  1033,   642,    51,   644,   394,   883,   109,   585,   136,
     137,   259,   645,    58,    47,    48,   259,   254,   254,  1189,
      43,    44,    76,   112,   646,  1362,  1240,  1241,  1370,  1243,
      39,  1032,   169,   170,    42,  1247,   653,   245,  1250,   111,
     586,   684,   105,    43,    44,  -373,  1074,  -244,   588,   996,
     298,   263,    50,    50,    50,   698,  1021,   467,   321,   399,
    -297,   700,   298,   702,    69,   711,   712,     8,     9,    10,
      11,    12,   138,   535,   724,    39,  1408,   725,   557,    42,
     774,  1412,   776,   111,   143,   794,   321,   585,    43,    44,
     893,   787,  1138,    50,   112,    50,   -14,    50,   334,    33,
     833,   -15,   587,   606,   832,   109,   839,   136,   137,   111,
    1436,   861,   500,   863,    45,  -527,   875,   611,    43,    44,
    -422,   611,    47,    48,   887,  1277,   892,    36,    50,   695,
     899,   874,   901,   223,  1518,   904,   224,   907,   908,   228,
     906,   230,   111,   647,   909,   924,   830,   233,   910,  1074,
     927,   648,   744,   745,   746,   747,   179,   917,    76,  -298,
      63,   928,   929,   264,   943,   944,     8,     9,    10,    11,
      12,   945,   972,   350,   350,   946,   254,  1146,   298,   298,
      57,   947,   254,  1032,   611,  1168,   948,  1032,    39,   949,
     169,   170,    42,  -410,   337,  -409,   109,  1013,    33,   111,
    1015,    43,    44,  1071,  1019,   298,  1072,  1519,  1073,    43,
      44,  1369,  1022,  1519,     8,     9,    10,    11,    12,   965,
    1043,  1044,   254,  1045,   996,   684,    36,  1046,   912,  1519,
     254,  1054,   611,  1519,    51,  1064,  1068,  1336,  1057,   692,
    1094,  1133,    69,    50,    58,  1031,    33,  1118,   112,  1119,
    1140,  1120,  1121,  1033,  1251,  1252,  1253,  1134,  1136,  1137,
     298,  1145,   112,   723,  1056,   298,  1149,   298,   298,   223,
      -9,  -445,   443,   -11,    36,    -3,   111,   334,   111,   111,
    1158,  1156,  1164,  1074,  1026,  1074,  1074,   337,   109,  1152,
     136,   137,  1139,  1141,  1143,  1185,    63,   483,  1187,  1190,
     350,    43,    44,   480,    39,  1195,   169,   170,    42,  1391,
    1196,  1384,   109,  1199,  1210,  1081,    57,    43,    44,  1071,
     557,   557,  1072,  1206,  1073,    43,    44,   109,   298,   136,
     440,   874,  1325,  1032,  1212,   996,    76,  1214,   611,   334,
      43,    44,   606,   360,  1216,    50,  1215,  1217,   587,   337,
    1218,   587,  1227,  1202,  1220,  1236,  1242,   115,  1237,  1056,
     111,  1245,  1426,   965,  1264,  1246,   441,  1074,  1271,  1248,
     611,   442,  1272,  1249,   385,   611,  1273,   606,   386,  1257,
    1279,   611,  1285,  1287,   611,   611,   996,   387,   388,   996,
     389,  1288,   390,   391,   337,   337,  1289,  1292,   213,  1297,
     611,  1299,   254,  1305,   223,  1306,   228,   154,   628,   684,
     337,  1481,   105,   254,  1307,  1308,   893,    50,    50,  1315,
    1253,   111,   111,  1318,  1346,  1328,    76,  1329,  1074,  1074,
    1335,  1357,  1339,   112,  1426,  1032,  1340,   996,  1426,  1426,
    1358,  -411,   996,  1330,  1361,  1372,  1377,   611,   884,   606,
     393,  1379,  1381,  1382,  1392,   692,   692,   337,   394,  1383,
     246,  1396,  1056,  1397,  1398,  1310,  1514,  1399,   154,  1401,
     105,   996,  1406,  1411,    63,  1415,  1417,  1413,  1419,   647,
    1421,  1433,  1423,  1454,  1456,   334,  1460,   648,  1424,  1530,
    1430,  1444,   223,  1530,    57,  1325,  1463,  1458,   314,  1466,
    1465,  1467,  1325,  1474,   874,  1490,   684,   329,  1492,   145,
     209,  1495,   893,   893,  1496,   146,  1508,  1547,   697,   147,
      50,   111,    70,   706,  1499,   557,  1506,   319,  1483,  1510,
    1513,  1057,  1515,  1528,   611,  1521,   937,  1529,  1550,  1532,
     996,   587,  1533,  1151,  1551,   996,  1554,   753,   105,    50,
      50,   750,   156,    39,   587,   418,    70,    42,   751,   421,
     209,  1325,   752,   754,   458,  1070,    43,    44,   996,    39,
     996,   176,   177,    42,   996,  1469,   676,   996,  1263,    50,
    1376,   361,    43,    44,    57,  1536,  1331,  1494,   206,    76,
     996,  1534,   691,  1447,   996,  1157,    76,  1024,  1166,   209,
      47,    48,  1345,  1179,   298,  1448,  1052,  1452,  1025,   895,
     399,  1067,   111,   838,    58,   421,    47,    48,   475,  1548,
     971,  1280,   889,   111,  1051,   902,  1057,   874,   334,  1026,
    1555,   689,   758,   112,     0,  1027,     0,   759,   337,   465,
     760,     0,   314,     0,  1485,     0,  1487,   884,   884,     0,
       0,     0,   692,     0,   154,    76,     0,  1390,     0,   209,
       0,   109,   112,   298,   204,   214,   831,     0,  1071,   334,
       0,  1072,    58,  1073,    43,    44,   444,   162,     0,   167,
       0,     0,   173,   174,   175,     0,   572,     0,     0,     0,
     577,   209,   109,     0,   136,   137,   209,     0,  1526,   227,
    1527,   334,  1293,     0,     0,    43,    44,     0,     0,   612,
     236,   237,     0,   616,   428,     0,     0,     0,  1539,  1540,
       0,     0,   611,   611,     0,     0,   105,   458,     0,  1057,
       0,   704,   337,   337,   458,     0,   705,   429,   891,     0,
     298,     0,   480,     0,     0,     0,     0,    57,     0,     0,
      58,     0,     0,   893,    57,     0,     0,     0,     0,     0,
       0,    70,     0,   105,     8,     9,    10,    11,    12,     0,
     314,   314,    39,     0,   176,   177,    42,     0,     0,     0,
       0,   676,     0,   209,     0,    43,    44,  1027,   109,  1027,
       0,  1027,     0,   458,     0,  1071,    33,   314,  1072,     0,
    1073,    43,    44,   396,     0,     0,   112,     0,     0,   115,
       0,   178,   884,    57,     0,   893,   105,   207,     0,    47,
      48,     0,   254,     0,    36,     0,   226,   893,   893,  1295,
       2,   200,     4,     5,     6,     7,     0,     0,   475,     0,
     314,     0,   475,     0,     0,   208,     0,     0,     0,     0,
     893,     0,   314,   334,   314,     0,     0,   314,   105,   314,
     314,   206,     0,   209,     0,     0,     0,   207,   883,     0,
     585,     0,     0,   628,     0,     0,    47,    48,  1451,   975,
    1451,     0,     0,   676,     0,     0,     0,     0,    39,     0,
     176,   177,    42,   676,   676,   208,     0,   105,    37,     0,
      38,    43,    44,   209,   676,     0,   207,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1451,   298,  1451,
     314,     0,   893,     0,     0,     0,     0,   253,    58,   112,
     769,     0,     0,     0,   208,    47,    48,  1027,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,     0,
     611,     0,   628,     0,     0,   112,   576,     0,   583,     0,
       0,   105,   810,    -3,     0,    58,   207,   577,     0,   609,
     610,     0,   533,   819,    39,     0,   169,   170,    42,   105,
       0,   206,     0,     0,     0,     0,   105,    43,    44,     0,
       0,     0,    70,     0,   208,     0,   611,   611,   207,     0,
       0,     0,     0,   207,   401,     0,   337,   337,   298,     0,
     514,   409,     0,   364,   515,   516,   517,     0,    58,     0,
       0,     0,   209,     0,     0,   871,   208,     0,     0,     0,
       0,   208,     0,   126,     0,   127,   128,   129,   518,  1027,
     519,     0,   520,   521,     0,   105,    43,    44,     0,     0,
     112,   475,   209,   975,     0,     0,     0,   209,     0,     0,
      58,     0,     0,   514,     0,     0,     0,   515,   516,   517,
       0,     0,     8,     9,    10,    11,    12,   401,     0,  1182,
       0,   676,   676,     0,     0,     0,     0,     0,   259,   112,
     207,   518,     0,   519,     0,   520,  1262,     0,    58,    58,
       0,     0,     0,    39,    33,   169,   170,    42,     0,     0,
       0,     0,   254,     0,     0,   209,    43,    44,   208,     0,
       0,     0,     0,   611,     0,     0,   933,     0,     0,   209,
     429,     0,    36,   337,     0,   562,     0,    39,   259,   176,
     177,    42,   676,   676,   566,     0,     0,   569,    58,     0,
      43,    44,     0,   112,     0,     8,     9,    10,    11,    12,
       0,     0,     0,    58,     0,     0,     0,     0,     0,  1239,
     207,   112,     0,     0,     0,     0,   178,     0,   112,     0,
     112,    58,   112,     0,    47,    48,   207,    33,    58,     0,
       0,     0,     0,   206,     0,     0,     0,     0,   208,     0,
       0,     0,     0,     0,     0,   401,     0,   206,     0,   409,
     207,     0,     0,     0,  1480,    36,   209,     0,     0,   112,
      39,   112,   176,   177,    42,  1023,     0,     0,     0,     0,
       0,     0,     0,    43,    44,     0,     0,   112,   208,     0,
       0,     0,     0,  1480,  1480,     0,     0,    58,     0,     0,
       0,     0,     0,   475,  1058,   314,     0,     0,     0,   584,
     298,   585,     0,     0,     0,     0,     0,    47,    48,     0,
       0,     0,     0,  1480,    39,     0,   176,   177,    42,     0,
       0,     0,     0,     0,     0,     0,   401,    43,    44,     0,
       0,     0,     0,   810,   206,   876,     0,   877,     0,     0,
       0,     0,     0,     0,   880,   881,     0,     0,     0,   886,
    1278,     0,     0,   584,     0,   585,     0,     0,     0,     0,
       0,    47,    48,     0,     0,     0,   896,     0,     0,   207,
       0,   900,     0,     0,     0,   586,   171,     0,     0,   676,
       8,     9,    10,    11,    12,     0,     0,   676,   676,   676,
     583,     0,     0,     0,     0,     0,     0,   208,     0,   207,
       0,     0,    70,     0,   207,     0,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     0,     0,   562,   562,     0,
       0,     0,     0,   171,   209,     0,   171,   208,     0,     0,
       0,     0,   208,     0,     0,     0,     0,     0,   871,     0,
      36,     0,     0,     0,     0,    39,     0,   176,   177,    42,
       0,     0,     0,     0,     0,     0,     0,     0,    43,    44,
       0,     0,   207,     0,     0,    66,   116,     0,     8,     9,
      10,    11,    12,     0,     0,     0,   207,     0,     0,     0,
       0,     0,     0,     0,  1025,   960,   399,   961,   962,   963,
     208,     0,    47,    48,     0,     0,     0,     0,     0,    66,
      33,   849,   429,     0,   208,   853,  1014,     0,     0,     0,
      39,     0,   176,   177,    42,     0,   155,     0,     0,     0,
       0,     0,  1020,    43,    44,     0,     0,     0,    36,     0,
     171,     0,     0,    39,   215,   176,   177,    42,    70,     0,
       0,     0,     0,     0,     0,  1047,    43,    44,     0,  1025,
       0,   399,     0,     0,   676,     0,     0,    47,    48,     0,
       0,   871,     0,   207,     0,     0,     0,     0,     0,   247,
       0,     0,  1479,     0,   399,     0,     0,     0,   171,  1069,
      47,    48,     0,     0,  1079,     0,     0,  1058,     0,  1082,
       0,   208,     0,     0,  1087,  1088,     0,     0,     0,  1090,
       0,  1091,  1092,     0,     0,  1095,     0,     0,   320,     8,
       9,    10,    11,    12,  1110,     0,   247,   339,     0,     0,
       0,     0,   562,     0,     0,     0,     0,     0,     0,     0,
    1124,  1125,    39,     0,   176,   177,    42,     0,     0,     0,
       0,    33,     0,     0,   392,    43,    44,     0,     0,     0,
       0,     0,     0,     0,     0,   171,     0,     0,     0,     0,
     412,     0,  1153,   417,   419,  1155,     0,     0,   155,    36,
       0,  1479,   171,   399,    39,     0,   171,     0,    42,    47,
      48,     0,  1058,     0,     0,     0,     0,    43,    44,   435,
       0,     0,     0,   438,     0,   439,     0,     0,   445,     0,
       0,     0,     0,     0,    66,     0,     0,     0,     0,   459,
       0,     0,     0,    45,     0,     0,    70,     0,  1188,   466,
       0,    47,    48,     0,  1192,  1193,     0,   419,     0,     0,
       0,   207,     0,  1200,     0,     0,     0,     0,  1207,     0,
       0,     0,     0,  1211,     0,     0,     0,     0,    74,     0,
       0,     0,     0,     0,     0,     0,  1219,     0,     0,   208,
       8,     9,    10,    11,    12,     0,     8,     9,    10,    11,
      12,     0,  1226,     0,  1228,  1229,  1230,  1231,     0,     0,
       0,     0,    74,     0,     0,  1058,     0,     0,  1085,  1238,
       0,  1124,    33,     0,     0,   247,     0,     0,    33,   578,
       0,     0,     0,     0,  1098,   608,    70,     0,   209,     0,
       0,     0,  1450,     0,  1450,     0,     0,   216,   613,     0,
      36,     0,   613,  1267,  1268,    39,    36,   176,   177,    42,
       0,    39,     0,     0,     0,    42,     0,     0,    43,    44,
       0,     0,     0,     0,    43,    44,     0,     0,     0,     0,
       0,  1450,     0,  1450,     0,     0,     0,     0,   209,     0,
       0,     0,     0,     0,   253,     0,     0,     0,     0,     0,
     691,   459,    47,    48,     0,     0,     0,     0,    47,    48,
       0,     0,     0,     0,     0,   339,   206,  1303,  1304,     0,
     459,     0,   314,   401,     0,     0,     0,  1314,   459,     0,
     342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   671,     0,     0,   419,     0,
       0,     0,     0,     0,     0,   171,     0,     0,     0,     0,
       0,     0,     0,   685,     0,    66,   429,     0,     0,     0,
     171,     0,     0,     0,     0,     0,     0,   419,     0,     0,
       0,   419,     0,   171,     0,     0,     0,     0,     0,     0,
       0,  1353,     0,  1354,  1355,  1356,     0,     0,     0,    70,
       0,     0,   436,     0,     0,  1360,    70,     0,   339,     0,
       0,     0,     0,  1371,     0,     0,   167,    74,     0,     0,
       0,     0,    74,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,  1393,     0,    28,    29,    30,     0,     0,
       0,     0,   761,     0,     0,    33,   869,     0,     0,   401,
       0,     0,     0,     0,     0,    70,     0,     0,     0,   613,
     772,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   790,    36,     0,     0,     0,  1434,  1435,     0,
      40,    41,     0,     0,     0,     0,     0,     0,     0,     0,
    1440,   578,     0,     0,     0,     0,   578,  1440,     0,     0,
       0,     0,   613,     0,     0,   339,   339,     0,   216,     0,
       0,     0,     0,     0,  1464,     0,     0,     0,     0,   714,
      77,   339,     0,   870,     0,    47,    48,     0,     0,     0,
       0,     0,  1478,     0,     0,   207,  1484,     0,     0,     0,
     671,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   459,  1343,     0,    77,     0,     0,     0,     0,     0,
       0,     0,     0,   208,     0,   459,     0,     0,   339,  1511,
       0,  1512,     0,     0,    74,     0,     0,   888,   171,     0,
     419,     0,     0,     0,     0,   207,     0,     0,   342,   217,
       0,     0,     0,    74,     0,     0,     0,     0,     0,     0,
       0,    74,     0,     0,     0,     0,   685,     0,     0,  1537,
    1538,     0,     0,   208,     0,     0,     0,     0,   342,     0,
       0,     0,  1545,  1546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   342,     0,    74,     0,
       0,     0,   671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   671,   671,     0,   613,     0,     0,   940,     0,
       0,     0,     0,   671,     0,     0,     0,     0,     0,     0,
       0,     0,   344,   951,     0,     0,     0,     0,     0,     0,
       0,   342,     0,     0,     0,     0,     0,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,     0,     0,     0,     0,     0,   171,     0,    33,
     171,   171,   171,     0,     0,    66,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   342,     0,     0,     0,    36,     0,   772,
       0,     0,    39,     0,    40,    41,    42,     0,     0,    77,
       0,     0,    79,     0,    77,    43,    44,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   419,   116,     0,     0,     0,     0,   342,   342,
     685,    45,     0,    46,     0,     0,    79,     0,     0,    47,
      48,     0,     0,     0,   342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   578,   342,     0,     0,     0,     0,     0,     0,
       0,   218,     0,     0,    74,   417,     0,     0,     0,     0,
     671,   671,     0,   339,   339,     0,     0,     0,    74,     0,
       0,   342,     0,     0,     0,     0,     0,     0,     0,     0,
     217,    66,     0,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,    28,    29,    30,     0,   342,
       0,     0,   171,     0,     0,    33,   869,     0,     0,     0,
       0,   671,   671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1173,     0,   345,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,   342,    77,     0,     0,     0,
      40,    41,     0,     0,     0,   342,   342,     0,     0,     0,
     344,   216,     0,     0,     0,    77,   342,     0,     0,     0,
       0,     0,     0,    77,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   714,
     344,     0,     0,  1183,   685,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   344,     0,
      77,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    79,     0,   171,     0,     0,    79,     0,    74,     0,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    -299,     0,   342,   344,     0,     0,     0,     0,     0,    66,
       0,     0,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   171,     0,     0,   171,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   671,
      36,   685,     0,   342,     0,     0,   116,     0,     0,     0,
       0,  -299,     0,     0,     0,   171,     0,     0,     0,     0,
       0,    85,     0,     0,     0,   344,     0,     0,   671,     0,
       0,     0,   218,     0,     0,   171,   671,   671,   671,     0,
     171,     0,     0,     0,     0,     0,     0,   339,   339,     0,
       0,     0,     0,   342,   342,    85,   342,   342,     0,  1324,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     344,   344,     0,     0,    74,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   344,     0,     0,     0,
     219,     0,     0,     0,     0,     0,     0,     0,    79,     0,
       0,   116,     0,     0,     0,   344,     0,     0,     0,     0,
       0,     0,   345,     0,   342,   342,    77,    79,     0,     0,
       0,     0,     0,     0,     0,    79,     0,     0,     0,     0,
      77,     0,     0,   344,     0,     0,     0,     0,   171,     0,
    1374,     0,   345,   171,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     345,     0,    79,     0,     0,     0,   171,     0,   171,     0,
       0,   344,   171,   352,   339,   171,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   342,   171,     0,
       0,     0,   171,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   671,   116,   345,     0,   344,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   344,   344,     0,
       0,     0,  1324,   217,     0,     0,     0,     0,   344,  1324,
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,    74,    28,    29,    30,     0,     0,     0,     0,
      85,     0,     0,    33,     0,    85,     0,   345,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   342,     0,   342,     0,     0,     0,  1324,     0,
      77,    36,     0,     0,     0,  1509,    39,     0,   201,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,    43,
      44,   342,   345,   345,   344,     0,     0,     0,     0,   342,
     342,   342,     0,     0,     0,     0,     0,     0,   345,     0,
     342,   342,     0,     0,     0,    45,     0,   258,     0,     0,
       0,     0,    74,    47,    48,     0,     0,   345,     0,     0,
       0,     0,     0,     0,     0,   344,     0,     0,    79,     0,
       0,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    79,     0,     0,   345,     0,     0,     0,     0,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,    28,    29,    30,   344,   344,     0,   344,   344,
       0,     0,    33,   345,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   216,     0,     0,    77,    85,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      36,   352,     0,     0,     0,     0,    85,   201,    41,   345,
       0,     0,     0,     0,    85,     0,     0,   342,     0,   345,
     345,     0,     0,     0,     0,   218,   344,   344,     0,     0,
     345,   352,     0,     0,     0,   273,   274,     0,   275,     0,
       0,     0,     0,     0,     0,   160,   342,     0,     0,   352,
       0,    85,    47,    48,     0,     0,     0,     0,     0,     0,
     212,     0,     0,     0,   276,    74,     0,     0,     0,     0,
     277,     0,    74,     0,   278,     0,     0,   279,   280,   270,
     281,   282,   283,    43,    44,     0,   284,   285,     0,     0,
       0,     0,    79,     0,   352,     0,     0,     0,     0,   344,
       0,     0,     0,     0,     0,     0,   160,     0,     0,   286,
     260,   367,     0,     0,     0,     0,   345,    47,    48,   288,
     289,   290,   291,     0,     0,     0,     0,     0,     0,     0,
     755,    74,     0,     0,     0,     0,   160,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   358,     0,     0,   363,
       0,     0,     0,     0,     0,     0,   352,   345,     0,     0,
       0,     0,     0,     0,    77,     0,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,  -300,     0,     0,     0,
       0,     0,     0,     0,   344,     0,   344,   160,    33,     0,
       0,   352,   352,     0,     0,     0,     0,   345,   345,   212,
     345,   345,     0,     0,     0,     0,     0,   352,     0,     0,
       0,     0,     0,   344,     0,     0,    36,     0,    79,     0,
       0,   344,   344,   344,     0,     0,   352,  -300,     0,     0,
       0,     0,   344,   344,     0,     0,   363,    85,     0,     0,
       0,     0,     0,   160,    77,     0,     0,     0,     0,     0,
       0,    85,     0,     0,   352,     0,     0,     0,   345,   345,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     512,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   352,     0,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,     0,     0,     0,   581,     0,
       0,     0,     0,   607,     0,   217,    33,     0,   352,     0,
       0,   345,     0,     0,     0,     0,     0,     0,   352,   352,
       0,     0,     0,     0,   219,     0,     0,     0,     0,   352,
       0,     0,     0,     0,    36,     0,     0,     0,     0,   344,
       0,     0,     0,     0,     0,   205,     0,     0,     0,     0,
       0,     0,     0,     0,   225,     0,   229,     0,   231,     0,
       0,     0,     0,     0,   234,     0,     0,     0,   344,     0,
       0,     0,     0,     0,     0,     0,    79,     0,   160,   160,
       0,     0,     0,     0,   358,     0,     0,    77,     0,     0,
       0,    85,     0,     0,    77,   205,     0,   229,   231,   234,
       0,     0,     0,     0,     0,   160,   345,     0,   345,     0,
       0,     0,     0,     0,     0,   352,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   688,     0,   205,   345,     0,     0,     0,     0,
       0,     0,     0,   345,   345,   345,     0,     0,   160,     0,
       0,     0,     0,    77,   345,   345,   352,     0,     0,     0,
     512,     0,   512,     0,     0,   512,    79,   160,   512,     0,
       0,     0,     0,     0,     0,     0,     0,   358,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   205,     0,   229,   231,   234,     0,
       0,     0,     0,     0,     0,     0,   352,   352,     0,   352,
     352,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   205,    85,   160,     0,
       0,   205,     0,     0,     0,     0,     0,     0,     0,   358,
       0,     0,   775,     0,     0,     0,     0,   218,     0,     0,
       0,     0,     0,     0,     0,     0,   312,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,   352,   352,     0,
     581,     0,     0,     0,     0,   581,     0,   370,   370,     0,
       0,   345,     0,     0,   358,   358,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   205,
     358,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     345,     0,     0,     0,     0,     0,     0,     0,   205,     0,
       0,     0,     0,   229,   231,     0,     0,     0,     0,    79,
       0,   234,     0,   512,     0,     0,    79,     0,   152,     0,
     352,     0,     0,     0,     0,     0,     0,   358,     0,   885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   464,     0,     0,     0,     0,
       0,   205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   239,     0,     0,   688,     0,     0,     0,     0,
       0,   205,   244,     0,     0,    79,   205,     0,   205,     0,
       0,     0,     0,     0,     0,    85,     0,     0,     0,     0,
       0,     0,     0,     0,   205,     0,     0,   205,   205,     0,
       0,     0,     0,     0,   205,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   352,   607,   352,   205,     0,
       0,     0,     0,     0,     0,   205,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   374,     0,
       0,     0,     0,     0,   352,     0,     0,     0,     0,     0,
       0,     0,   352,   352,   352,     0,     0,     0,     0,     0,
     406,     0,   370,   352,   352,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   420,    85,     0,     0,     0,     0,
       0,     0,     0,   425,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   358,     0,
       0,     0,   450,   512,     0,     0,     0,   460,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     468,     0,     0,     0,     0,   312,     0,   205,   482,     0,
     486,     0,     0,   160,     0,     0,     0,     0,     0,   688,
       0,     0,     0,     0,   682,     0,   219,     0,     0,   513,
       0,     0,     0,     0,     0,     0,     0,   205,     0,     0,
       0,     0,   205,     0,     0,     0,     0,     0,     0,     0,
       0,   581,     0,     0,     0,     0,     0,     0,     0,     0,
     352,     0,     0,     0,     0,     0,     0,   718,     0,     0,
     571,     0,   358,   358,   575,     0,     0,   727,     0,     0,
       0,     0,   718,     0,     0,   718,     0,     0,     0,   352,
       0,     0,     0,     0,     0,     0,     0,     0,   736,     0,
     205,     0,   620,     0,     0,     0,   621,   622,    85,   623,
       0,     0,     0,     0,   205,    85,   634,   635,     0,   636,
     637,     0,   638,     0,   639,     0,     0,     0,   765,     0,
       0,     0,     0,     0,     0,   335,     0,     0,     0,   727,
       0,   571,     0,     0,     0,     0,     0,     0,   950,   655,
     789,     8,     9,    10,    11,    12,   512,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   666,    85,     0,     0,     0,     0,     0,
       0,   273,   274,    33,   275,     0,     0,   828,     0,     0,
     205,     0,     0,     0,     0,   370,     0,     0,   680,     0,
       0,   205,     0,   688,   683,     0,     0,     0,     0,   450,
     276,    36,     0,     0,     0,     0,   277,     0,     0,   205,
     278,     0,     0,   279,   280,   270,   281,   282,   283,    43,
      44,     0,   284,   285,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   721,
       0,     0,     0,     0,     0,   286,     0,   367,     0,     0,
       0,   732,     0,   333,    48,   288,   289,   290,   291,     0,
       0,     0,     0,     0,     0,   718,     0,   273,   274,   512,
     275,     0,     0,     0,     0,   727,     0,   911,     0,     0,
     914,     0,     0,     0,     0,     0,   921,     0,   757,     0,
     688,     0,     0,     0,     0,     0,   276,   767,     0,     0,
     768,     0,   624,     0,   136,   137,   278,   205,     0,   279,
     280,   270,   281,   282,   283,    43,    44,   788,   284,   285,
       0,     0,     0,     0,     0,     0,   938,   939,     0,   273,
     274,     0,   275,     0,     0,     0,   358,   358,     0,     0,
       0,   286,   335,   625,     0,   626,   368,     0,     0,    47,
      48,   288,   289,   290,   291,     0,     0,   829,   276,   205,
       0,     0,     0,     0,   277,     0,     0,     0,   278,     0,
     205,   279,   280,   270,   281,   282,   283,    43,    44,     0,
     284,   285,     0,   967,     0,     0,     0,   370,     0,     0,
       0,     0,     0,     0,   864,     0,     0,     0,     0,     0,
       0,     0,     0,   286,     0,   367,     0,     0,   368,     0,
       0,    47,    48,   288,   289,   290,   291,     0,   335,     0,
       0,   239,     0,     0,     0,     0,     0,     0,   212,     0,
       0,     0,     0,     0,     0,     0,   897,   898,     0,     0,
       0,     0,     0,     0,     0,     0,   905,     0,   330,   353,
       0,     0,     0,   312,     0,     0,     0,     0,     0,   335,
     918,     0,     0,   358,     0,   922,   370,   205,     0,     0,
       0,   914,     0,     0,   718,     0,     0,     0,   212,     0,
     402,     0,     0,     0,     0,     0,     0,   402,     0,     0,
       0,     0,     0,     0,  1093,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     512,     0,   512,     0,     0,   370,   955,  1128,     0,     0,
       0,     0,     0,   956,     0,     0,     0,     0,     0,     0,
       0,     0,   914,   914,     0,     0,     0,   958,     0,   959,
       0,     0,     0,   402,     0,     0,     0,     0,     0,   512,
       0,   512,   969,     0,     0,     0,     0,     0,   973,  1159,
       0,     0,     0,   125,     0,     0,     0,     0,     0,  1016,
       0,     0,     0,  1017,     0,     0,     0,     0,     0,     0,
       0,     0,   205,     0,     0,     0,     0,     0,     0,     0,
     160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   402,     0,     0,     0,     0,     0,     0,     0,     0,
     402,   567,   914,   402,   570,     0,     0,   125,     0,     0,
       0,   353,     0,     0,     0,   598,     0,     0,     0,     0,
       0,     0,   125,   828,   125,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   617,     0,     0,     0,     0,     0,
       0,  1224,  1225,     0,     0,     0,     0,  1089,     0,   265,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   402,     0,     0,     0,   402,     0,     0,   497,     0,
     499,   502,     0,     0,     0,     0,     0,     0,   123,   505,
     506,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   499,   499,     0,     0,   353,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   125,     0,
     125,   125,     0,     0,  1154,   125,     0,   125,   125,     0,
       0,     0,     0,   205,     0,     0,     0,     0,     0,   499,
       0,     0,   232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   402,     0,     0,   353,     0,   242,     0,   243,
       0,     0,     0,     0,     0,     0,  1184,     0,     0,     0,
       0,  1186,     0,     0,   499,     0,     0,     0,     0,     0,
       0,  1191,     0,   205,     0,     0,     0,     0,     0,     0,
       0,   125,     0,     0,     0,     0,     0,     0,     0,     0,
     353,     0,  1334,     0,     0,  1213,   718,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1221,     0,
       0,     0,  1222,     0,     0,  1223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1232,  1233,   402,   402,   403,   404,     0,     0,     0,
     408,     0,   410,   411,     0,     0,     0,     0,     0,  1244,
       0,   770,   353,     0,     0,     0,     0,     0,     0,     0,
       0,   598,     0,     0,   598,   598,     0,     0,     0,     0,
       0,   598,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   809,     0,   353,     0,     0,     0,     0,   353,     0,
       0,     0,     0,     0,     0,     0,     0,   353,   353,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   205,     0,
       0,     0,     0,   353,  1290,     0,     0,   402,   850,     0,
     125,   402,   854,     0,     0,     0,     0,     0,     0,     0,
     857,     0,   499,   499,   499,   499,   499,   499,   499,   499,
     499,   499,   499,   499,   499,   499,   499,   499,   499,   499,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     353,   598,     0,     0,     0,     0,     0,     0,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
      28,    29,    30,  1347,     0,  1348,     0,     0,   353,     0,
      33,     0,     0,     0,     0,  1351,     0,  1352,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1359,     0,     0,     0,     0,     0,    36,     0,
     312,     0,     0,   109,     0,    40,    41,     0,   402,     0,
    1378,  1380,     0,     0,     0,   649,    43,    44,     0,     0,
       0,     0,     0,  1388,   598,     0,   598,     0,  1389,     0,
       0,  1191,     0,     0,     0,     0,     0,   598,     0,     0,
       0,     0,     0,     0,    46,     0,     0,  1407,     0,     0,
      47,    48,     0,     0,     0,   125,   125,  1414,     0,     0,
    1416,     0,  1418,  1420,  1422,   499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   125,     0,     0,   125,   125,     0,   125,
     499,   125,   125,     0,     0,     0,   125,   125,     0,     0,
       0,     0,  1455,     0,  1457,     0,     0,     0,     0,     0,
       0,   353,     0,     0,  1191,     0,     0,     0,   402,     0,
     499,     0,     0,     0,  1473,     0,     0,     0,     0,     0,
     598,   598,     0,     0,     0,   125,     0,     0,     0,   125,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   353,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   402,  1086,     0,     0,     0,     0,
     763,   764,     0,     0,   353,     0,     0,     0,     0,     0,
     402,  1099,     0,   598,   598,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   353,   353,     0,   795,     0,
       0,   798,   799,     0,   802,     0,   804,   805,     0,     0,
       0,   807,   808,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   199,     2,   200,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
     848,    28,    29,    30,   852,     0,     0,     0,     0,     0,
     402,    33,   402,     0,   402,     0,     0,     0,     0,   402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     499,     0,     0,     0,     0,   598,     0,     0,     0,    36,
       0,    37,   499,    38,     0,  -522,   201,    41,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,   353,    28,    29,    30,
      31,   499,     0,     0,    32,   202,     0,    33,    34,     0,
       0,    47,    48,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,     0,    36,     0,    37,     0,    38,
      39,     0,    40,    41,    42,     0,     0,     0,     0,     0,
       0,   499,     0,    43,    44,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   402,     0,     0,     0,    45,
     402,    46,   125,     0,     0,     0,     0,    47,    48,     0,
       0,     0,     0,   353,     0,     0,     0,     0,   125,     0,
       0,   125,   125,     2,   200,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,     0,     0,     0,     0,     0,   353,
     353,    33,     0,     0,     0,     0,     0,   499,   499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
       0,    37,     0,    38,   125,     0,    40,    41,   402,  1344,
       0,     0,   402,     0,     0,     0,     0,   125,     0,     0,
       0,     0,   125,   125,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1084,     0,     0,
       0,     0,     0,     0,  -407,   662,     0,     0,     0,     0,
       0,    47,    48,  1097,     0,     0,  1101,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   125,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   353,     0,     0,     0,
       0,     1,     2,   200,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,  -299,  1163,
      28,    29,    30,    31,     0,     0,     0,    32,     0,     0,
      33,   125,     0,     0,     0,     0,     0,  1180,  1181,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     125,     0,     0,     0,     0,     0,     0,     0,    36,     0,
      37,     0,    38,     0,     0,    40,    41,     0,     0,  -299,
       0,     0,     0,     0,     0,     0,     0,   402,     0,     0,
       0,     0,  1108,     0,     0,     8,     9,    10,    11,    12,
       0,     0,     0,     0,  1101,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,     0,   402,   402,   499,     0,
      47,    48,     0,     0,     0,   273,   274,    33,   275,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   402,     0,     0,     0,
       0,     0,     0,     0,   276,    36,   125,     0,     0,     0,
     277,     0,     0,     0,   278,     0,  1265,   279,   280,   270,
     281,   282,   283,    43,    44,     0,   284,   285,     0,     0,
     499,     0,     0,     0,     0,  1275,     0,     0,     0,     0,
       0,     0,   499,   499,     0,     0,     0,     0,     0,   286,
       0,   367,     0,     0,     0,     0,     0,  1109,    48,   288,
     289,   290,   291,     0,     0,   499,     0,     0,     0,     0,
       0,     0,     1,     2,   200,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,    31,     0,     0,     0,    32,   273,
     274,    33,   976,   977,     0,   978,     0,     0,   979,   980,
     981,   982,   983,   984,   985,   986,     0,     0,     0,   987,
       0,  1342,     0,   988,   989,     0,   990,   499,   276,    36,
       0,    37,     0,    38,   991,     0,   992,   993,   994,     0,
       0,   279,   280,   270,   281,   282,   283,    43,    44,     0,
     284,   285,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   286,     0,   287,     0,     0,   166,     0,
       0,    47,    48,   288,   289,   290,   291,     0,     0,     0,
       0,   995,     0,     0,     0,     0,  -134,     1,     2,   200,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,     0,    28,    29,    30,    31,
       0,     0,     0,    32,   273,   274,    33,   275,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
      28,    29,    30,   276,    36,     0,    37,     0,    38,   277,
      33,    40,    41,   278,     0,     0,   279,   280,   270,   281,
     282,   283,    43,    44,     0,   284,   285,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
       0,     0,     0,     0,     0,    40,    41,     0,   286,     0,
     287,     0,     0,     0,     0,     0,    47,    48,   288,   289,
     290,   291,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -134,     1,     2,   200,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,    31,     0,     0,     0,    32,   273,
     274,    33,   275,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,    28,    29,    30,   276,    36,
       0,    37,     0,    38,   277,    33,    40,    41,   278,     0,
       0,   279,   280,   270,   281,   282,   283,    43,    44,     0,
     284,   285,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
     201,    41,     0,   286,     0,   287,     0,     0,     0,     0,
       0,    47,    48,   288,   289,   290,   291,     2,   200,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,    28,    29,    30,     0,     0,
       0,     0,     0,   273,   274,    33,   275,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   276,    36,     0,    37,     0,    38,   277,     0,
      40,    41,   278,     0,     0,   279,   280,   270,   281,   282,
     283,    43,    44,     0,   284,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   286,     0,   332,
       0,     0,     0,     0,   726,   333,    48,   288,   289,   290,
     291,     2,   200,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,     0,     0,     0,     0,     0,   273,   274,    33,
     275,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   276,    36,     0,    37,
       0,    38,   277,     0,    40,    41,   278,     0,     0,   279,
     280,   270,   281,   282,   283,    43,    44,     0,   284,   285,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   286,     0,   332,     0,     0,     0,     0,   726,    47,
      48,   288,   289,   290,   291,     2,   200,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,     0,     0,     0,     0,
       0,   273,   274,    33,   275,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     276,    36,     0,    37,     0,    38,   277,     0,    40,    41,
     278,     0,     0,   279,   280,   270,   281,   282,   283,    43,
      44,     0,   284,   285,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   286,     0,   332,     0,     0,
       0,     0,     0,   333,    48,   288,   289,   290,   291,     2,
     200,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,     0,    28,    29,    30,
       0,     0,     0,     0,     0,   273,   274,    33,   275,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   276,    36,     0,    37,     0,    38,
     277,     0,   201,    41,   278,     0,     0,   279,   280,   270,
     281,   282,   283,    43,    44,     0,   284,   285,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   286,
       0,   935,     0,     0,     0,     0,     0,   936,    48,   288,
     289,   290,   291,     2,   200,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,     0,     0,     0,     0,     0,   273,
     274,    33,   275,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   276,    36,
       0,    37,     0,    38,   277,     0,   201,    41,   278,     0,
       0,   279,   280,   270,   281,   282,   283,    43,    44,     0,
     284,   285,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   286,     0,   367,     0,     0,     0,     0,
       0,    47,    48,   288,   289,   290,   291,     1,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,     0,    28,    29,    30,    31,
       0,     0,     0,    32,     0,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    35,     0,     0,    36,     0,    37,     0,    38,    39,
       0,    40,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,    43,    44,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,     0,
      46,     0,     0,     0,  -526,     0,    47,    48,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,     0,    28,    29,    30,
      31,     0,     0,     0,    32,     0,     0,    33,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,     0,    36,     0,    37,     0,    38,
      39,     0,    40,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,    43,    44,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
       0,    46,     0,     0,     0,     0,     0,    47,    48,   199,
       2,   200,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,    28,    29,
      30,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,    37,     0,
      38,    39,     0,   201,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,    43,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,     0,   202,     0,     0,     0,     0,     0,    47,    48,
       1,     2,   200,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,    31,     0,     0,     0,    32,     0,     0,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,    37,
       0,    38,     0,     0,    40,    41,     2,   200,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,     0,     0,     0,
       0,     0,     0,    46,    33,     0,     0,     0,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,    37,     0,    38,    39,     0,   201,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
      43,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,     0,   202,     0,
       0,     0,     0,     0,    47,    48,     2,   200,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,     0,     0,     0,
       0,     0,     0,     0,    33,     0,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,    28,    29,
      30,     0,    36,     0,    37,     0,    38,     0,    33,    40,
      41,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1311,     0,     0,    36,     0,     0,     0,
       0,     0,     0,    40,    41,     0,     0,     0,   662,     0,
       0,     0,     0,     0,    47,    48,     2,   200,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,   245,     0,    28,    29,    30,     0,    47,    48,
       0,     0,     0,     0,    33,     0,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,    28,    29,
      30,     0,    36,     0,    37,     0,    38,     0,    33,    40,
      41,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1313,     0,     0,    36,     0,     0,     0,
       0,     0,     0,    40,    41,     0,     0,     0,   662,     0,
       0,     0,     0,     0,    47,    48,     2,   200,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    46,     0,    28,    29,    30,     0,    47,    48,
       0,     0,     0,     0,    33,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,    37,     0,    38,     0,     0,   201,
      41,     2,   200,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,     0,     0,     0,     0,     0,     0,   258,    33,
       0,     0,     0,     0,    47,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,    37,
       0,    38,     0,     0,    40,    41,     2,   200,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,     0,     0,     0,
       0,     0,     0,   662,    33,     0,     0,     0,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,    37,     0,    38,     0,     0,   201,
      41,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,     0,     0,     0,     0,
       0,   273,   274,    33,   275,     0,     0,     0,   202,     0,
       0,     0,     0,     0,    47,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     276,    36,     0,     0,     0,     0,   277,     0,    40,    41,
     278,     0,     0,   279,   280,   270,   281,   282,   283,    43,
      44,     0,   284,   285,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   286,     0,   507,     0,     0,
     166,     0,     0,    47,    48,   288,   289,   290,   291,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,     0,     0,     0,     0,     0,   273,
     274,    33,   275,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   276,    36,
       0,     0,     0,     0,   277,     0,    40,    41,   278,     0,
       0,   279,   280,   270,   281,   282,   283,    43,    44,     0,
     284,   285,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   286,   -40,   287,     0,     0,     0,     0,
       0,    47,    48,   288,   289,   290,   291,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,     0,     0,     0,     0,     0,   273,   274,    33,
     275,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   276,    36,     0,     0,
       0,     0,   277,     0,    40,    41,   278,     0,     0,   279,
     280,   270,   281,   282,   283,    43,    44,     0,   284,   285,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   286,     0,   287,     0,     0,     0,     0,     0,    47,
      48,   288,   289,   290,   291,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,     0,    28,    29,    30,
       0,     0,     0,     0,     0,   273,   274,    33,   275,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   276,    36,     0,     0,     0,     0,
     277,     0,    40,    41,   278,     0,     0,   279,   280,   270,
     281,   282,   283,    43,    44,     0,   284,   285,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   286,
       0,   332,     0,     0,     0,     0,     0,    47,    48,   288,
     289,   290,   291,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,    28,    29,    30,     0,     0,
       0,     0,     0,   273,   274,    33,   275,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   276,    36,     0,     0,     0,     0,   277,     0,
      40,    41,   278,     0,     0,   279,   280,   270,   281,   282,
     283,    43,    44,     0,   284,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   286,     0,   367,
       0,     0,     0,     0,     0,    47,    48,   288,   289,   290,
     291,   453,     2,   200,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
      28,    29,    30,     0,     0,     0,     0,     0,     0,     0,
      33,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,     0,     0,    36,     0,
      37,     0,    38,    33,   869,    40,    41,     0,     0,     0,
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    36,     0,    28,    29,    30,     0,     0,    40,    41,
       0,     0,     0,    33,     0,     0,     0,    -3,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,     0,     0,     0,     0,   714,   201,    41,
       0,  1269,     0,    47,    48,     0,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,    28,    29,
      30,     0,     0,     0,     0,     0,     0,   258,    33,     0,
       0,     0,     0,    47,    48,     0,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    36,     0,    28,    29,
      30,     0,     0,    40,    41,     0,     0,     0,    33,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,     0,     0,    36,     0,     0,     0,
       0,    33,   328,    40,    41,     0,     0,     0,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
       0,     0,     0,     0,     0,     0,    40,    41,     0,     0,
       0,     0,   714,     0,     0,     0,     0,     0,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   662,     0,     0,     0,     0,
       0,    47,    48,     2,   200,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,     0,     0,     0,     0,     0,     0,
       0,    33,     0,   273,   274,     0,   275,   977,     0,   978,
       0,     0,   979,   980,   981,   982,   983,   984,   985,   986,
       0,     0,  1503,   987,     0,     0,     0,   988,   989,    36,
     990,    37,   276,    38,     0,     0,    40,    41,   991,     0,
     169,   170,   994,     0,     0,   279,   280,   270,   281,   282,
     283,    43,    44,     0,   284,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -420,     0,     0,   286,     0,   367,
       0,     0,   166,     0,     0,    47,    48,   288,   289,   290,
     291,     0,     0,   273,   274,   995,   275,   977,     0,   978,
    -134,     0,   979,   980,   981,   982,   983,   984,   985,   986,
       0,     0,     0,   987,     0,     0,     0,   988,   989,     0,
     990,     0,   276,     0,     0,     0,     0,     0,   991,     0,
     169,   170,   994,     0,     0,   279,   280,   270,   281,   282,
     283,    43,    44,     0,   284,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   286,     0,   367,
       0,     0,   166,     0,     0,    47,    48,   288,   289,   290,
     291,     0,     0,     0,     0,   995,     0,     0,     0,     0,
    -134,     2,   200,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,     0,     0,     0,     0,     0,     0,     0,    33,
       0,   273,   274,     0,   275,   977,     0,   978,  1363,  1364,
     979,   980,   981,   982,   983,   984,   985,   986,     0,     0,
    1503,   987,     0,     0,     0,   988,   989,    36,   990,    37,
     276,    38,     0,     0,    40,    41,   991,     0,   169,   170,
     994,     0,     0,   279,   280,   270,   281,   282,   283,    43,
      44,     0,   284,   285,     0,     0,     0,     0,  1276,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   286,     0,   367,     0,     0,
     166,     0,     0,    47,    48,   288,   289,   290,   291,     0,
       0,   273,   274,   995,   275,   977,     0,   978,  1363,  1364,
     979,   980,   981,   982,   983,   984,   985,   986,     0,     0,
       0,   987,     0,     0,     0,   988,   989,     0,   990,     0,
     276,     0,     0,     0,     0,     0,   991,     0,   169,   170,
     994,     0,     0,   279,   280,   270,   281,   282,   283,    43,
      44,     0,   284,   285,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   286,     0,   367,     0,     0,
     166,     0,     0,    47,    48,   288,   289,   290,   291,     0,
       0,   273,   274,   995,   275,   977,     0,   978,     0,     0,
     979,   980,   981,   982,   983,   984,   985,   986,     0,     0,
       0,   987,     0,     0,     0,   988,   989,     0,   990,     0,
     276,     0,     0,     0,     0,     0,   991,     0,   169,   170,
     994,     0,     0,   279,   280,   270,   281,   282,   283,    43,
      44,     0,   284,   285,     0,     0,     0,     0,     0,     0,
     273,   274,     0,   275,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   286,     0,   367,     0,     0,
     166,     0,     0,    47,    48,   288,   289,   290,   291,   276,
       0,     0,     0,   995,     0,   277,     0,     0,     0,   278,
       0,     0,   279,   280,   270,   281,   282,   283,    43,    44,
       0,   284,   285,     0,     0,     0,     0,     0,     0,   273,
     274,     0,   275,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   286,     0,   367,     0,     0,     0,
       0,   726,    47,    48,   288,   289,   290,   291,   276,     0,
       0,     0,     0,     0,   277,     0,     0,     0,   278,     0,
       0,   279,   280,   270,   281,   282,   283,    43,    44,     0,
     284,   285,     0,     0,     0,     0,     0,     0,   273,   274,
       0,   275,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   286,     0,   367,     0,     0,   912,     0,
       0,    47,    48,   288,   289,   290,   291,   276,     0,     0,
       0,     0,     0,   277,     0,     0,     0,   278,     0,     0,
     279,   280,   270,   281,   282,   283,    43,    44,     0,   284,
     285,     0,     0,     0,     0,     0,     0,   273,   274,     0,
     275,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   286,     0,   367,     0,     0,     0,     0,     0,
      47,    48,   288,   289,   290,   291,   276,     0,     0,     0,
       0,     0,   277,     0,     0,     0,   278,     0,     0,   279,
     280,   270,   281,   282,   283,    43,    44,     0,   284,   285,
       0,     0,     0,     0,     0,     0,   273,   274,     0,   275,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   496,     0,   367,     0,     0,     0,     0,     0,    47,
      48,   288,   289,   290,   291,   276,     0,     0,     0,     0,
       0,   277,     0,     0,     0,   278,     0,     0,   279,   280,
     270,   281,   282,   283,    43,    44,     0,   284,   285,     0,
       0,     0,     0,     0,     0,   273,   274,     0,   275,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     501,     0,   367,     0,     0,     0,     0,     0,    47,    48,
     288,   289,   290,   291,   276,     0,     0,     0,     0,     0,
     277,     0,     0,     0,   278,     0,     0,   279,   280,   270,
     281,   282,   283,    43,    44,     0,   284,   285,     0,     0,
       0,     0,     0,     0,   273,   274,     0,   275,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   504,
       0,   367,     0,     0,     0,     0,     0,    47,    48,   288,
     289,   290,   291,   276,     0,     0,     0,     0,     0,   277,
       0,     0,     0,   278,     0,     0,   279,   280,   270,   281,
     282,   283,    43,    44,     0,   284,   285,     0,     0,     0,
       0,     0,     0,   273,   274,     0,   275,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   286,     0,
     367,     0,     0,     0,     0,     0,   681,    48,   288,   289,
     290,   291,   276,     0,     0,     0,     0,     0,   277,     0,
       0,     0,   278,     0,     0,   279,   280,   270,   281,   282,
     283,    43,    44,     0,   284,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   286,     0,   367,
       0,     0,     0,     0,     0,   333,    48,   288,   289,   290,
     291,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,     0,     0,     0,     0,
       0,     0,     0,    33,   199,     2,   200,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    36,     0,    28,    29,    30,   109,     0,    40,    41,
       0,     0,     0,    33,     0,     0,     0,     0,     0,    43,
      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,    37,     0,    38,     0,     0,   201,    41,
     453,     2,   200,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,     0,     0,     0,     0,     0,     0,     0,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,    37,
       0,    38,     0,     0,    40,    41,     2,   200,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,     0,     0,     0,
       0,     0,     0,     0,    33,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,    37,     0,    38,     0,     0,   201,
      41,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,   471,   472,   473,   474,
       0,     0,     0,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,     0,     0,     0,     0,     0,    40,    41
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1330))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       0,     1,     0,   178,     1,    45,   115,   178,     1,   441,
     198,    45,    51,   213,   521,    45,   178,   178,     0,   178,
    1025,   178,   178,   152,   338,   338,  1025,   163,   164,   334,
    1025,    31,    32,   181,    34,   840,    34,   503,   606,   958,
     959,   840,   875,   985,   353,    45,   104,   141,   357,   587,
     584,    51,    34,    51,   557,   588,   630,    34,    58,   959,
      45,   594,  1286,    63,   700,    63,    66,    45,    66,    69,
      30,    69,    69,   112,   584,   587,  1363,    45,   253,   179,
     584,   482,   253,   922,   584,   486,   195,   179,  1027,  1418,
       0,   253,   253,   151,   253,   655,   253,   253,    42,   244,
     406,   249,   250,   142,    66,   105,   988,   989,   108,   286,
      42,    42,     0,  1244,    42,   115,   286,   584,    42,   425,
      67,    81,   584,   123,    34,    84,  1455,   433,  1457,   468,
     969,   620,   621,    47,    48,    45,    54,   621,   178,   414,
     415,    51,   584,   143,   178,   143,    34,   636,   178,    47,
      48,  1438,   636,    63,   254,   155,    66,   155,   114,    69,
      75,   475,   254,   468,   203,  1389,   114,   114,   116,   114,
     114,   976,   116,    88,    89,   137,    56,   976,   178,   179,
     100,   179,   114,   114,   116,   116,  1068,   112,   116,  1022,
     114,   136,   116,   178,   683,   195,   114,   757,   398,   683,
     178,   116,    42,   203,   711,   203,   120,   767,   768,   484,
     178,   136,   212,   253,   134,   215,    96,   215,   778,   253,
     259,   119,   222,   253,   691,  1072,   121,   114,   503,   691,
     114,   115,   232,   143,  1173,   235,    90,   414,   415,   239,
     240,   239,   137,   777,    42,   155,   779,   240,   135,   691,
       0,    42,   790,   253,   254,   477,   254,   239,   761,   298,
     260,   406,   239,   263,   118,   574,   114,   777,   178,   179,
       0,     1,   330,   777,   587,   114,  1407,   777,   790,    84,
     425,   620,   621,  1414,    34,   121,  1186,   117,   433,   564,
     117,   420,   392,   203,   121,   334,  1367,   636,    58,   135,
     392,   606,  1244,   412,    34,   215,   611,   187,   617,   418,
     777,   116,   115,  1232,  1233,   777,   114,    42,   116,   496,
     320,   895,   320,   114,   501,   116,   496,   504,   498,   239,
     210,   501,   135,  1233,   504,   777,    66,   337,   338,    69,
     220,   275,  1473,   253,   683,   105,   884,    42,   108,  1154,
      42,   239,   115,    42,   354,  1154,   244,   115,   358,  1206,
     666,  1208,  1209,   121,   298,   299,   466,   589,   368,   937,
      42,   593,   135,   883,   466,   414,   415,   599,   555,   883,
    1322,   114,   721,   883,   513,  1475,   121,   121,   115,   114,
    1026,   116,   392,   615,   392,   955,   956,   619,  1475,  1470,
     334,  1441,   441,   137,  1475,   101,   286,  1447,   135,   114,
     320,   116,   412,   946,   947,   101,   721,  1507,   418,   114,
     119,   116,   114,  1500,   116,   114,     3,   116,   338,  1500,
    1507,   127,  1472,    47,    48,   369,  1507,  1477,     3,  1244,
    1359,   127,   114,    51,   116,   484,   575,     0,   121,   115,
       0,  1290,   212,   453,   920,   121,  1016,  1017,   458,  1359,
     453,   770,   135,    10,   503,   114,   466,   899,   466,  1411,
     470,  1413,   470,   136,  1479,   475,   790,   790,   478,   840,
    1479,    42,   392,   483,  1479,   215,  1122,  1123,   470,   239,
     121,   620,   621,  1067,   244,   631,   897,    84,    95,    96,
     260,   121,     0,     1,   112,   119,   137,   636,   115,   239,
    1048,  1450,  1351,  1352,   121,   515,   133,   137,   406,   136,
     520,   666,   515,   121,   116,   564,   118,   520,    75,   638,
      77,    78,  1474,   130,   131,   680,    34,   425,   222,   137,
     649,  1480,   121,   135,    51,   433,   114,   121,   121,   115,
     430,   235,   121,   114,   683,   116,    63,   651,   137,    66,
     470,   115,    69,   137,   137,   475,   905,   606,   137,   121,
    1509,    69,   611,   114,   888,   455,    75,   337,    77,    78,
      79,   121,   470,   121,   584,   137,  1031,   587,  1033,    88,
      89,   813,   121,   575,   354,   203,   114,   137,   358,   137,
     905,   114,  1407,   537,   538,   539,   121,   607,   137,  1414,
      10,    11,    12,    13,    14,    75,   496,    75,   979,   958,
     135,   501,   622,   122,   504,   114,   626,   827,    88,    89,
      88,    89,   937,   114,   121,   635,   143,   637,   638,   639,
     115,    75,    42,   117,   637,    79,   639,   121,   155,   649,
     137,   259,   115,  1213,    88,    89,   406,   114,   116,   116,
    1458,  1221,  1222,  1223,  1462,   122,   123,   889,  1473,   117,
      70,   115,   179,   121,   584,   425,   115,   587,   678,   136,
     114,   114,   116,   433,   114,   678,   124,   125,   122,   123,
     298,   691,   692,   122,     0,     1,   203,   833,   698,   128,
     129,   114,   702,   116,     0,     1,   120,   855,   215,   122,
     123,   115,    75,   115,   114,   114,   116,   121,   468,   121,
     470,    67,   122,   123,   121,    88,    89,  1363,    34,     4,
       5,     6,     7,     8,     9,   864,   115,   115,    34,    45,
     470,   239,   121,   121,   114,    51,   115,   137,   115,   114,
    1089,   114,   121,   116,   121,  1262,   137,    63,    97,    98,
      66,   137,   950,    69,     4,     5,     6,     7,     8,     9,
      66,   871,   117,    69,   654,   119,   121,   777,   666,   871,
     115,   691,   692,   663,  1089,   119,   121,   667,   115,  1425,
     790,   725,   680,  1154,   121,    35,   117,    72,   104,    74,
     121,  1437,  1438,   120,   121,   115,   112,   115,   115,   115,
     116,   121,     3,   320,   121,   114,   115,   116,  1018,    10,
      11,    12,    13,    14,  1460,   115,    93,    94,  1388,   958,
     959,   121,    72,   833,    74,   971,   142,   143,   115,   839,
     840,    84,   115,   114,   121,   151,   152,   607,   121,   155,
    1025,    42,   132,   115,  1025,   115,   152,   114,   840,   121,
     899,   121,   622,  1025,  1025,   123,  1025,   777,  1025,  1025,
     115,   871,   178,   179,   874,   635,   121,   115,   116,    70,
     790,  1186,   864,   120,   121,   392,    61,    62,   888,   195,
     114,   115,   116,  1232,    47,    48,  1532,   203,   937,  1073,
    1074,   898,   540,   541,  1265,   133,   906,   542,   543,   215,
      99,   116,   912,   906,   548,   549,   666,   117,   918,   215,
     117,   115,   922,  1023,   137,   918,   114,  1027,   115,   922,
     680,  1023,   115,   239,   115,  1027,   114,    75,   116,    77,
      78,   247,   115,   239,   122,   123,   252,   253,   254,  1058,
      88,    89,   840,   259,   115,  1316,  1133,  1134,  1319,  1136,
      75,   871,    77,    78,    79,  1142,   117,   116,  1145,   969,
     136,   721,   470,    88,    89,   119,   969,   119,   888,   979,
     286,   119,   982,   983,   984,   121,   866,   114,   115,   116,
       3,   136,   298,   119,   976,   114,   137,    10,    11,    12,
      13,    14,    32,   937,   115,    75,  1367,   115,   314,    79,
     117,  1372,   117,  1013,   320,   114,   115,   116,    88,    89,
     700,   117,   137,  1023,   330,  1025,   135,  1027,   334,    42,
     121,   135,   338,   339,   135,    75,    31,    77,    78,  1039,
    1401,   115,   976,   115,   114,   120,   119,   353,    88,    89,
     115,   357,   122,   123,   120,  1184,   120,    70,  1058,   121,
     114,   669,   115,    70,  1496,   115,    73,   115,   115,    76,
     121,    78,  1072,  1173,   115,   755,   116,    84,   115,  1072,
     115,  1173,   544,   545,   546,   547,   392,   121,   976,     3,
     840,   115,   115,   123,   115,   115,    10,    11,    12,    13,
      14,   115,   120,  1232,  1233,   115,   412,   987,   414,   415,
     840,   115,   418,  1023,   420,  1025,   115,  1027,    75,   115,
      77,    78,    79,   115,   420,   115,    75,    31,    42,  1129,
     136,    88,    89,    82,   115,   441,    85,  1498,    87,    88,
      89,  1318,   119,  1504,    10,    11,    12,    13,    14,   829,
     115,   121,   458,   117,  1154,   905,    70,   117,   119,  1520,
     466,   115,   468,  1524,   470,   115,   121,  1261,   898,   475,
     115,   114,  1154,  1173,   470,  1275,    42,   115,   484,   121,
     137,   121,   115,  1275,    61,    62,    63,   114,   114,   114,
     496,   114,   498,   121,  1191,   501,    11,   503,   504,   206,
     135,   135,   232,   135,    70,   120,  1206,   513,  1208,  1209,
     115,   135,   115,  1206,   135,  1208,  1209,   513,    75,   137,
      77,    78,   982,   983,   984,   115,   976,   133,   120,   120,
    1359,    88,    89,   263,    75,   119,    77,    78,    79,  1348,
     115,  1335,    75,   117,   117,   925,   976,    88,    89,    82,
     556,   557,    85,   121,    87,    88,    89,    75,   564,    77,
      78,   869,  1244,  1173,   115,  1265,  1154,   115,   574,   575,
      88,    89,   578,   114,   117,  1275,   115,   117,   584,   575,
     117,   587,   117,   116,   115,   117,    50,     1,   117,  1286,
    1290,   137,  1386,   973,   120,   137,   114,  1290,   115,   137,
     606,   119,   115,   137,  1479,   611,   115,   613,  1479,   137,
     115,   617,   120,   120,   620,   621,  1316,  1479,  1479,  1319,
    1479,   117,  1479,  1479,   620,   621,    86,   117,  1325,   117,
     636,   117,   638,   117,   341,   117,   343,    51,   368,  1089,
     636,  1450,   840,   649,   115,   115,  1026,  1347,  1348,   117,
      63,  1351,  1352,   114,   119,   114,  1244,   114,  1351,  1352,
     114,   117,   115,   669,  1458,  1275,   115,  1367,  1462,  1463,
     117,   115,  1372,  1253,   117,   115,   101,   683,   684,   685,
    1480,   101,   114,   114,   120,   691,   692,   683,  1480,   137,
     104,   115,  1389,   115,   115,   121,  1490,   115,   112,    45,
     898,  1401,   135,   137,  1154,   115,   115,   137,   101,  1509,
     101,   117,   135,   115,   115,   721,   114,  1509,   137,  1513,
     137,   137,   429,  1517,  1154,  1407,   121,   135,   142,   117,
     120,   117,  1414,   137,  1042,   117,  1186,   151,   137,  1479,
      66,   115,  1122,  1123,   114,  1479,   115,  1541,   478,  1479,
    1450,  1451,     0,   483,   120,   761,   120,  1496,  1451,   115,
     135,  1191,   115,   115,   770,   137,   772,   115,   115,   114,
    1470,   777,   137,   995,   137,  1475,   137,   553,   976,  1479,
    1480,   550,  1480,    75,   790,   199,    34,    79,   551,   203,
     116,  1473,   552,   554,  1244,   917,    88,    89,  1498,    75,
    1500,    77,    78,    79,  1504,  1438,   450,  1507,  1154,  1509,
    1327,  1509,    88,    89,  1244,  1524,  1254,  1463,    66,  1407,
    1520,  1517,   114,  1414,  1524,  1013,  1414,   869,  1023,   155,
     122,   123,  1275,  1033,   840,  1415,   891,  1417,   114,   702,
     116,   912,  1542,   632,   840,   259,   122,   123,   262,  1542,
     833,  1191,   695,  1553,   890,   710,  1286,  1165,   864,   135,
    1553,   470,   556,   869,    -1,   871,    -1,   556,   864,  1479,
     556,    -1,   286,    -1,  1454,    -1,  1456,   883,   884,    -1,
      -1,    -1,   888,    -1,   298,  1473,    -1,  1347,    -1,   215,
      -1,    75,   898,   899,  1324,  1325,   626,    -1,    82,   905,
      -1,    85,   898,    87,    88,    89,   232,    54,    -1,    56,
      -1,    -1,    59,    60,    61,    -1,   330,    -1,    -1,    -1,
     334,   247,    75,    -1,    77,    78,   252,    -1,  1508,    76,
    1510,   937,   116,    -1,    -1,    88,    89,    -1,    -1,   353,
      87,    88,    -1,   357,  1374,    -1,    -1,    -1,  1528,  1529,
      -1,    -1,   958,   959,    -1,    -1,  1154,  1407,    -1,  1389,
      -1,   114,   958,   959,  1414,    -1,   119,   215,   698,    -1,
     976,    -1,   702,    -1,    -1,    -1,    -1,  1407,    -1,    -1,
     976,    -1,    -1,  1363,  1414,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,  1191,    10,    11,    12,    13,    14,    -1,
     414,   415,    75,    -1,    77,    78,    79,    -1,    -1,    -1,
      -1,   655,    -1,   339,    -1,    88,    89,  1023,    75,  1025,
      -1,  1027,    -1,  1473,    -1,    82,    42,   441,    85,    -1,
      87,    88,    89,   180,    -1,    -1,  1042,    -1,    -1,   453,
      -1,   114,  1048,  1473,    -1,  1425,  1244,    66,    -1,   122,
     123,    -1,  1058,    -1,    70,    -1,    75,  1437,  1438,   116,
       4,     5,     6,     7,     8,     9,    -1,    -1,   482,    -1,
     484,    -1,   486,    -1,    -1,    66,    -1,    -1,    -1,    -1,
    1460,    -1,   496,  1089,   498,    -1,    -1,   501,  1286,   503,
     504,   339,    -1,   419,    -1,    -1,    -1,   116,   114,    -1,
     116,    -1,    -1,   833,    -1,    -1,   122,   123,  1416,   839,
    1418,    -1,    -1,   757,    -1,    -1,    -1,    -1,    75,    -1,
      77,    78,    79,   767,   768,   116,    -1,  1325,    72,    -1,
      74,    88,    89,   459,   778,    -1,   155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   874,    -1,    -1,  1455,  1154,  1457,
     564,    -1,  1532,    -1,    -1,    -1,    -1,   114,  1154,  1165,
     574,    -1,    -1,    -1,   155,   122,   123,  1173,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,    -1,
    1186,    -1,   912,    -1,    -1,  1191,   333,    -1,   335,    -1,
      -1,  1389,   606,   137,    -1,  1191,   215,   611,    -1,   346,
     347,    -1,   136,   617,    75,    -1,    77,    78,    79,  1407,
      -1,   459,    -1,    -1,    -1,    -1,  1414,    88,    89,    -1,
      -1,    -1,   470,    -1,   215,    -1,  1232,  1233,   247,    -1,
      -1,    -1,    -1,   252,   183,    -1,  1232,  1233,  1244,    -1,
      86,   190,    -1,   114,    90,    91,    92,    -1,  1244,    -1,
      -1,    -1,   578,    -1,    -1,   669,   247,    -1,    -1,    -1,
      -1,   252,    -1,    75,    -1,    77,    78,    79,   114,  1275,
     116,    -1,   118,   119,    -1,  1473,    88,    89,    -1,    -1,
    1286,   695,   608,  1013,    -1,    -1,    -1,   613,    -1,    -1,
    1286,    -1,    -1,    86,    -1,    -1,    -1,    90,    91,    92,
      -1,    -1,    10,    11,    12,    13,    14,   256,    -1,  1039,
      -1,   955,   956,    -1,    -1,    -1,    -1,    -1,  1324,  1325,
     339,   114,    -1,   116,    -1,   118,   119,    -1,  1324,  1325,
      -1,    -1,    -1,    75,    42,    77,    78,    79,    -1,    -1,
      -1,    -1,  1348,    -1,    -1,   671,    88,    89,   339,    -1,
      -1,    -1,    -1,  1359,    -1,    -1,   770,    -1,    -1,   685,
     608,    -1,    70,  1359,    -1,   314,    -1,    75,  1374,    77,
      78,    79,  1016,  1017,   323,    -1,    -1,   326,  1374,    -1,
      88,    89,    -1,  1389,    -1,    10,    11,    12,    13,    14,
      -1,    -1,    -1,  1389,    -1,    -1,    -1,    -1,    -1,  1129,
     419,  1407,    -1,    -1,    -1,    -1,   114,    -1,  1414,    -1,
    1416,  1407,  1418,    -1,   122,   123,   435,    42,  1414,    -1,
      -1,    -1,    -1,   671,    -1,    -1,    -1,    -1,   419,    -1,
      -1,    -1,    -1,    -1,    -1,   384,    -1,   685,    -1,   388,
     459,    -1,    -1,    -1,  1450,    70,   772,    -1,    -1,  1455,
      75,  1457,    77,    78,    79,   869,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,  1473,   459,    -1,
      -1,    -1,    -1,  1479,  1480,    -1,    -1,  1473,    -1,    -1,
      -1,    -1,    -1,   897,   898,   899,    -1,    -1,    -1,   114,
    1496,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,    -1,
      -1,    -1,    -1,  1509,    75,    -1,    77,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   465,    88,    89,    -1,
      -1,    -1,    -1,   937,   772,   672,    -1,   674,    -1,    -1,
      -1,    -1,    -1,    -1,   681,   682,    -1,    -1,    -1,   686,
    1184,    -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,    -1,    -1,    -1,   703,    -1,    -1,   578,
      -1,   708,    -1,    -1,    -1,   136,    58,    -1,    -1,  1213,
      10,    11,    12,    13,    14,    -1,    -1,  1221,  1222,  1223,
     727,    -1,    -1,    -1,    -1,    -1,    -1,   578,    -1,   608,
      -1,    -1,   840,    -1,   613,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    -1,    -1,    -1,    -1,   556,   557,    -1,
      -1,    -1,    -1,   105,   940,    -1,   108,   608,    -1,    -1,
      -1,    -1,   613,    -1,    -1,    -1,    -1,    -1,  1042,    -1,
      70,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,
      -1,    -1,   671,    -1,    -1,     0,     1,    -1,    10,    11,
      12,    13,    14,    -1,    -1,    -1,   685,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   822,   116,   824,   825,   826,
     671,    -1,   122,   123,    -1,    -1,    -1,    -1,    -1,    34,
      42,   640,   940,    -1,   685,   644,   843,    -1,    -1,    -1,
      75,    -1,    77,    78,    79,    -1,    51,    -1,    -1,    -1,
      -1,    -1,   859,    88,    89,    -1,    -1,    -1,    70,    -1,
     212,    -1,    -1,    75,    69,    77,    78,    79,   976,    -1,
      -1,    -1,    -1,    -1,    -1,   882,    88,    89,    -1,   114,
      -1,   116,    -1,    -1,  1388,    -1,    -1,   122,   123,    -1,
      -1,  1165,    -1,   772,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,   260,   916,
     122,   123,    -1,    -1,   921,    -1,    -1,  1191,    -1,   926,
      -1,   772,    -1,    -1,   931,   932,    -1,    -1,    -1,   936,
      -1,   938,   939,    -1,    -1,   942,    -1,    -1,   143,    10,
      11,    12,    13,    14,   951,    -1,   151,   152,    -1,    -1,
      -1,    -1,   761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     967,   968,    75,    -1,    77,    78,    79,    -1,    -1,    -1,
      -1,    42,    -1,    -1,   179,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,    -1,
     195,    -1,   999,   198,   199,  1002,    -1,    -1,   203,    70,
      -1,   114,   354,   116,    75,    -1,   358,    -1,    79,   122,
     123,    -1,  1286,    -1,    -1,    -1,    -1,    88,    89,   224,
      -1,    -1,    -1,   228,    -1,   230,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,   244,
      -1,    -1,    -1,   114,    -1,    -1,  1154,    -1,  1055,   254,
      -1,   122,   123,    -1,  1061,  1062,    -1,   262,    -1,    -1,
      -1,   940,    -1,  1070,    -1,    -1,    -1,    -1,  1075,    -1,
      -1,    -1,    -1,  1080,    -1,    -1,    -1,    -1,     0,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1093,    -1,    -1,   940,
      10,    11,    12,    13,    14,    -1,    10,    11,    12,    13,
      14,    -1,  1109,    -1,  1111,  1112,  1113,  1114,    -1,    -1,
      -1,    -1,    34,    -1,    -1,  1389,    -1,    -1,   927,  1126,
      -1,  1128,    42,    -1,    -1,   330,    -1,    -1,    42,   334,
      -1,    -1,    -1,    -1,   943,   340,  1244,    -1,  1324,    -1,
      -1,    -1,  1416,    -1,  1418,    -1,    -1,    69,   353,    -1,
      70,    -1,   357,  1160,  1161,    75,    70,    77,    78,    79,
      -1,    75,    -1,    -1,    -1,    79,    -1,    -1,    88,    89,
      -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,  1455,    -1,  1457,    -1,    -1,    -1,    -1,  1374,    -1,
      -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,
     114,   406,   122,   123,    -1,    -1,    -1,    -1,   122,   123,
      -1,    -1,    -1,    -1,    -1,   420,  1324,  1224,  1225,    -1,
     425,    -1,  1496,  1032,    -1,    -1,    -1,  1234,   433,    -1,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    -1,    -1,   453,    -1,
      -1,    -1,    -1,    -1,    -1,   607,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   468,    -1,   470,  1374,    -1,    -1,    -1,
     622,    -1,    -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,
      -1,   486,    -1,   635,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1298,    -1,  1300,  1301,  1302,    -1,    -1,    -1,  1407,
      -1,    -1,   224,    -1,    -1,  1312,  1414,    -1,   513,    -1,
      -1,    -1,    -1,  1320,    -1,    -1,  1323,   239,    -1,    -1,
      -1,    -1,   244,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,  1350,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,   557,    -1,    -1,    42,    43,    -1,    -1,  1168,
      -1,    -1,    -1,    -1,    -1,  1473,    -1,    -1,    -1,   574,
     575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   587,    70,    -1,    -1,    -1,  1394,  1395,    -1,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1407,   606,    -1,    -1,    -1,    -1,   611,  1414,    -1,    -1,
      -1,    -1,   617,    -1,    -1,   620,   621,    -1,   340,    -1,
      -1,    -1,    -1,    -1,  1431,    -1,    -1,    -1,    -1,   116,
       0,   636,    -1,   120,    -1,   122,   123,    -1,    -1,    -1,
      -1,    -1,  1449,    -1,    -1,  1324,  1453,    -1,    -1,    -1,
     655,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   666,  1271,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1324,    -1,   680,    -1,    -1,   683,  1486,
      -1,  1488,    -1,    -1,   406,    -1,    -1,   692,   840,    -1,
     695,    -1,    -1,    -1,    -1,  1374,    -1,    -1,   420,    69,
      -1,    -1,    -1,   425,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   433,    -1,    -1,    -1,    -1,   721,    -1,    -1,  1526,
    1527,    -1,    -1,  1374,    -1,    -1,    -1,    -1,   450,    -1,
      -1,    -1,  1539,  1540,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   468,    -1,   470,    -1,
      -1,    -1,   757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   767,   768,    -1,   770,    -1,    -1,   773,    -1,
      -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   152,   788,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,   979,    -1,    42,
     982,   983,   984,    -1,    -1,   840,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   575,    -1,    -1,    -1,    70,    -1,   864,
      -1,    -1,    75,    -1,    77,    78,    79,    -1,    -1,   239,
      -1,    -1,     0,    -1,   244,    88,    89,    -1,    -1,   884,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   897,   898,    -1,    -1,    -1,    -1,   620,   621,
     905,   114,    -1,   116,    -1,    -1,    34,    -1,    -1,   122,
     123,    -1,    -1,    -1,   636,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   937,   655,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    -1,   666,   950,    -1,    -1,    -1,    -1,
     955,   956,    -1,   958,   959,    -1,    -1,    -1,   680,    -1,
      -1,   683,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     340,   976,    -1,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,   721,
      -1,    -1,  1154,    -1,    -1,    42,    43,    -1,    -1,    -1,
      -1,  1016,  1017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1027,    -1,   152,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,   757,   406,    -1,    -1,    -1,
      77,    78,    -1,    -1,    -1,   767,   768,    -1,    -1,    -1,
     420,   773,    -1,    -1,    -1,   425,   778,    -1,    -1,    -1,
      -1,    -1,    -1,   433,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
     450,    -1,    -1,   120,  1089,   122,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,    -1,
     470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,  1265,    -1,    -1,   244,    -1,   840,    -1,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,   864,   513,    -1,    -1,    -1,    -1,    -1,  1154,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1316,    -1,    -1,  1319,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1184,
      70,  1186,    -1,   905,    -1,    -1,  1191,    -1,    -1,    -1,
      -1,    81,    -1,    -1,    -1,  1347,    -1,    -1,    -1,    -1,
      -1,     0,    -1,    -1,    -1,   575,    -1,    -1,  1213,    -1,
      -1,    -1,   340,    -1,    -1,  1367,  1221,  1222,  1223,    -1,
    1372,    -1,    -1,    -1,    -1,    -1,    -1,  1232,  1233,    -1,
      -1,    -1,    -1,   955,   956,    34,   958,   959,    -1,  1244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1401,
     620,   621,    -1,    -1,   976,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   636,    -1,    -1,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,    -1,
      -1,  1286,    -1,    -1,    -1,   655,    -1,    -1,    -1,    -1,
      -1,    -1,   420,    -1,  1016,  1017,   666,   425,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   433,    -1,    -1,    -1,    -1,
     680,    -1,    -1,   683,    -1,    -1,    -1,    -1,  1470,    -1,
    1325,    -1,   450,  1475,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     468,    -1,   470,    -1,    -1,    -1,  1498,    -1,  1500,    -1,
      -1,   721,  1504,   152,  1359,  1507,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1089,  1520,    -1,
      -1,    -1,  1524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1388,  1389,   513,    -1,   757,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   767,   768,    -1,
      -1,    -1,  1407,   773,    -1,    -1,    -1,    -1,   778,  1414,
      -1,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,  1154,    32,    33,    34,    -1,    -1,    -1,    -1,
     239,    -1,    -1,    42,    -1,   244,    -1,   575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1184,    -1,  1186,    -1,    -1,    -1,  1473,    -1,
     840,    70,    -1,    -1,    -1,  1480,    75,    -1,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,  1213,   620,   621,   864,    -1,    -1,    -1,    -1,  1221,
    1222,  1223,    -1,    -1,    -1,    -1,    -1,    -1,   636,    -1,
    1232,  1233,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,
      -1,    -1,  1244,   122,   123,    -1,    -1,   655,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   905,    -1,    -1,   666,    -1,
      -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   680,    -1,    -1,   683,    -1,    -1,    -1,    -1,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    33,    34,   955,   956,    -1,   958,   959,
      -1,    -1,    42,   721,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1325,    -1,    -1,   976,   406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,   420,    -1,    -1,    -1,    -1,   425,    77,    78,   757,
      -1,    -1,    -1,    -1,   433,    -1,    -1,  1359,    -1,   767,
     768,    -1,    -1,    -1,    -1,   773,  1016,  1017,    -1,    -1,
     778,   450,    -1,    -1,    -1,    40,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    51,  1388,    -1,    -1,   468,
      -1,   470,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    -1,    -1,    -1,    69,  1407,    -1,    -1,    -1,    -1,
      75,    -1,  1414,    -1,    79,    -1,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    -1,    -1,
      -1,    -1,   840,    -1,   513,    -1,    -1,    -1,    -1,  1089,
      -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   114,
     116,   116,    -1,    -1,    -1,    -1,   864,   122,   123,   124,
     125,   126,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,  1473,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,   155,
      -1,    -1,    -1,    -1,    -1,    -1,   575,   905,    -1,    -1,
      -1,    -1,    -1,    -1,  1154,    -1,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1184,    -1,  1186,   203,    42,    -1,
      -1,   620,   621,    -1,    -1,    -1,    -1,   955,   956,   215,
     958,   959,    -1,    -1,    -1,    -1,    -1,   636,    -1,    -1,
      -1,    -1,    -1,  1213,    -1,    -1,    70,    -1,   976,    -1,
      -1,  1221,  1222,  1223,    -1,    -1,   655,    81,    -1,    -1,
      -1,    -1,  1232,  1233,    -1,    -1,   252,   666,    -1,    -1,
      -1,    -1,    -1,   259,  1244,    -1,    -1,    -1,    -1,    -1,
      -1,   680,    -1,    -1,   683,    -1,    -1,    -1,  1016,  1017,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   721,    -1,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,   334,    -1,
      -1,    -1,    -1,   339,    -1,  1325,    42,    -1,   757,    -1,
      -1,  1089,    -1,    -1,    -1,    -1,    -1,    -1,   767,   768,
      -1,    -1,    -1,    -1,   773,    -1,    -1,    -1,    -1,   778,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,  1359,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    -1,    77,    -1,    79,    -1,
      -1,    -1,    -1,    -1,    85,    -1,    -1,    -1,  1388,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1154,    -1,   414,   415,
      -1,    -1,    -1,    -1,   420,    -1,    -1,  1407,    -1,    -1,
      -1,   840,    -1,    -1,  1414,   116,    -1,   118,   119,   120,
      -1,    -1,    -1,    -1,    -1,   441,  1184,    -1,  1186,    -1,
      -1,    -1,    -1,    -1,    -1,   864,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   468,    -1,   155,  1213,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1221,  1222,  1223,    -1,    -1,   484,    -1,
      -1,    -1,    -1,  1473,  1232,  1233,   905,    -1,    -1,    -1,
     496,    -1,   498,    -1,    -1,   501,  1244,   503,   504,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   215,    -1,   217,   218,   219,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   955,   956,    -1,   958,
     959,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   247,   976,   564,    -1,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   575,
      -1,    -1,   578,    -1,    -1,    -1,    -1,  1325,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   152,  1016,  1017,    -1,
     606,    -1,    -1,    -1,    -1,   611,    -1,   163,   164,    -1,
      -1,  1359,    -1,    -1,   620,   621,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,
     636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,
      -1,    -1,    -1,   344,   345,    -1,    -1,    -1,    -1,  1407,
      -1,   352,    -1,   669,    -1,    -1,  1414,    -1,    46,    -1,
    1089,    -1,    -1,    -1,    -1,    -1,    -1,   683,    -1,   685,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    -1,    -1,   721,    -1,    -1,    -1,    -1,
      -1,   412,   100,    -1,    -1,  1473,   417,    -1,   419,    -1,
      -1,    -1,    -1,    -1,    -1,  1154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   435,    -1,    -1,   438,   439,    -1,
      -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1184,   772,  1186,   459,    -1,
      -1,    -1,    -1,    -1,    -1,   466,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,    -1,    -1,  1213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1221,  1222,  1223,    -1,    -1,    -1,    -1,    -1,
     188,    -1,   368,  1232,  1233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   202,  1244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   864,    -1,
      -1,    -1,   240,   869,    -1,    -1,    -1,   245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     258,    -1,    -1,    -1,    -1,   441,    -1,   578,   266,    -1,
     268,    -1,    -1,   899,    -1,    -1,    -1,    -1,    -1,   905,
      -1,    -1,    -1,    -1,   460,    -1,  1325,    -1,    -1,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   608,    -1,    -1,
      -1,    -1,   613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1359,    -1,    -1,    -1,    -1,    -1,    -1,   503,    -1,    -1,
     328,    -1,   958,   959,   332,    -1,    -1,   513,    -1,    -1,
      -1,    -1,   518,    -1,    -1,   521,    -1,    -1,    -1,  1388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    -1,
     671,    -1,   360,    -1,    -1,    -1,   364,   365,  1407,   367,
      -1,    -1,    -1,    -1,   685,  1414,   374,   375,    -1,   377,
     378,    -1,   380,    -1,   382,    -1,    -1,    -1,   564,    -1,
      -1,    -1,    -1,    -1,    -1,   571,    -1,    -1,    -1,   575,
      -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,     7,   407,
     586,    10,    11,    12,    13,    14,  1042,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,  1473,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    43,    -1,    -1,   623,    -1,    -1,
     761,    -1,    -1,    -1,    -1,   631,    -1,    -1,   456,    -1,
      -1,   772,    -1,  1089,   462,    -1,    -1,    -1,    -1,   467,
      69,    70,    -1,    -1,    -1,    -1,    75,    -1,    -1,   790,
      79,    -1,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,
      -1,   519,    -1,   122,   123,   124,   125,   126,   127,    -1,
      -1,    -1,    -1,    -1,    -1,   711,    -1,    40,    41,  1165,
      43,    -1,    -1,    -1,    -1,   721,    -1,   723,    -1,    -1,
     726,    -1,    -1,    -1,    -1,    -1,   732,    -1,   556,    -1,
    1186,    -1,    -1,    -1,    -1,    -1,    69,   565,    -1,    -1,
     568,    -1,    75,    -1,    77,    78,    79,   888,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,   585,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,   772,   773,    -1,    40,
      41,    -1,    43,    -1,    -1,    -1,  1232,  1233,    -1,    -1,
      -1,   114,   788,   116,    -1,   118,   119,    -1,    -1,   122,
     123,   124,   125,   126,   127,    -1,    -1,   625,    69,   940,
      -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    79,    -1,
     951,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    -1,   829,    -1,    -1,    -1,   833,    -1,    -1,
      -1,    -1,    -1,    -1,   662,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    -1,   119,    -1,
      -1,   122,   123,   124,   125,   126,   127,    -1,   864,    -1,
      -1,   689,    -1,    -1,    -1,    -1,    -1,    -1,  1324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   704,   705,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   714,    -1,   151,   152,
      -1,    -1,    -1,   899,    -1,    -1,    -1,    -1,    -1,   905,
     728,    -1,    -1,  1359,    -1,   733,   912,  1048,    -1,    -1,
      -1,   917,    -1,    -1,   920,    -1,    -1,    -1,  1374,    -1,
     183,    -1,    -1,    -1,    -1,    -1,    -1,   190,    -1,    -1,
      -1,    -1,    -1,    -1,   940,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   951,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1416,    -1,  1418,    -1,    -1,   971,   794,   973,    -1,    -1,
      -1,    -1,    -1,   801,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   988,   989,    -1,    -1,    -1,   815,    -1,   817,
      -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,  1455,
      -1,  1457,   830,    -1,    -1,    -1,    -1,    -1,   836,  1015,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,   847,
      -1,    -1,    -1,   851,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,  1068,   326,   327,    -1,    -1,    82,    -1,    -1,
      -1,   334,    -1,    -1,    -1,   338,    -1,    -1,    -1,    -1,
      -1,    -1,    97,  1089,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   357,    -1,    -1,    -1,    -1,    -1,
      -1,  1107,  1108,    -1,    -1,    -1,    -1,   935,    -1,   124,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   384,    -1,    -1,    -1,   388,    -1,    -1,   273,    -1,
     275,   276,    -1,    -1,    -1,    -1,    -1,    -1,    28,   284,
     285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   298,   299,    -1,    -1,   420,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,
     185,   186,    -1,    -1,  1002,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,  1324,    -1,    -1,    -1,    -1,    -1,   334,
      -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   465,    -1,    -1,   468,    -1,    97,    -1,    99,
      -1,    -1,    -1,    -1,    -1,    -1,  1044,    -1,    -1,    -1,
      -1,  1049,    -1,    -1,   369,    -1,    -1,    -1,    -1,    -1,
      -1,  1059,    -1,  1374,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     513,    -1,  1258,    -1,    -1,  1083,  1262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1096,    -1,
      -1,    -1,  1100,    -1,    -1,  1103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1119,  1120,   556,   557,   185,   186,    -1,    -1,    -1,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,  1137,
      -1,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   584,    -1,    -1,   587,   588,    -1,    -1,    -1,    -1,
      -1,   594,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   604,    -1,   606,    -1,    -1,    -1,    -1,   611,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   620,   621,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1509,    -1,
      -1,    -1,    -1,   636,  1202,    -1,    -1,   640,   641,    -1,
     395,   644,   645,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     653,    -1,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,    -1,    -1,    -1,    -1,    -1,    -1,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,  1281,    -1,  1283,    -1,    -1,   721,    -1,
      42,    -1,    -1,    -1,    -1,  1293,    -1,  1295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1310,    -1,    -1,    -1,    -1,    -1,    70,    -1,
    1496,    -1,    -1,    75,    -1,    77,    78,    -1,   761,    -1,
    1328,  1329,    -1,    -1,    -1,   395,    88,    89,    -1,    -1,
      -1,    -1,    -1,  1341,   777,    -1,   779,    -1,  1346,    -1,
      -1,  1349,    -1,    -1,    -1,    -1,    -1,   790,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,  1365,    -1,    -1,
     122,   123,    -1,    -1,    -1,   560,   561,  1375,    -1,    -1,
    1378,    -1,  1380,  1381,  1382,   700,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   588,    -1,    -1,   591,   592,    -1,   594,
     725,   596,   597,    -1,    -1,    -1,   601,   602,    -1,    -1,
      -1,    -1,  1420,    -1,  1422,    -1,    -1,    -1,    -1,    -1,
      -1,   864,    -1,    -1,  1432,    -1,    -1,    -1,   871,    -1,
     755,    -1,    -1,    -1,  1442,    -1,    -1,    -1,    -1,    -1,
     883,   884,    -1,    -1,    -1,   640,    -1,    -1,    -1,   644,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   927,   928,    -1,    -1,    -1,    -1,
     560,   561,    -1,    -1,   937,    -1,    -1,    -1,    -1,    -1,
     943,   944,    -1,   946,   947,   948,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   958,   959,    -1,   588,    -1,
      -1,   591,   592,    -1,   594,    -1,   596,   597,    -1,    -1,
      -1,   601,   602,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
     640,    32,    33,    34,   644,    -1,    -1,    -1,    -1,    -1,
    1023,    42,  1025,    -1,  1027,    -1,    -1,    -1,    -1,  1032,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     925,    -1,    -1,    -1,    -1,  1048,    -1,    -1,    -1,    70,
      -1,    72,   937,    74,    -1,     0,    77,    78,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,  1089,    32,    33,    34,
      35,   976,    -1,    -1,    39,   116,    -1,    42,    43,    -1,
      -1,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    70,    -1,    72,    -1,    74,
      75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,  1026,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1168,    -1,    -1,    -1,   114,
    1173,   116,   927,    -1,    -1,    -1,    -1,   122,   123,    -1,
      -1,    -1,    -1,  1186,    -1,    -1,    -1,    -1,   943,    -1,
      -1,   946,   947,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,  1232,
    1233,    42,    -1,    -1,    -1,    -1,    -1,  1122,  1123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    72,    -1,    74,  1019,    -1,    77,    78,  1271,  1272,
      -1,    -1,  1275,    -1,    -1,    -1,    -1,  1032,    -1,    -1,
      -1,    -1,  1037,  1038,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   927,    -1,    -1,
      -1,    -1,    -1,    -1,   115,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,   943,    -1,    -1,   946,   947,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1094,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1359,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,  1019,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    -1,    -1,
      42,  1156,    -1,    -1,    -1,    -1,    -1,  1037,  1038,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      72,    -1,    74,    -1,    -1,    77,    78,    -1,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1450,    -1,    -1,
      -1,    -1,     7,    -1,    -1,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,  1094,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,  1479,  1480,  1363,    -1,
     122,   123,    -1,    -1,    -1,    40,    41,    42,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1509,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,  1271,    -1,    -1,    -1,
      75,    -1,    -1,    -1,    79,    -1,  1156,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    -1,    -1,
    1425,    -1,    -1,    -1,    -1,  1175,    -1,    -1,    -1,    -1,
      -1,    -1,  1437,  1438,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,
     125,   126,   127,    -1,    -1,  1460,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    35,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    -1,    46,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    60,
      -1,  1271,    -1,    64,    65,    -1,    67,  1532,    69,    70,
      -1,    72,    -1,    74,    75,    -1,    77,    78,    79,    -1,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    -1,   119,    -1,
      -1,   122,   123,   124,   125,   126,   127,    -1,    -1,    -1,
      -1,   132,    -1,    -1,    -1,    -1,   137,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    69,    70,    -1,    72,    -1,    74,    75,
      42,    77,    78,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,   114,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,   125,
     126,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   137,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    35,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    69,    70,
      -1,    72,    -1,    74,    75,    42,    77,    78,    79,    -1,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    78,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,   124,   125,   126,   127,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    43,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    -1,    72,    -1,    74,    75,    -1,
      77,    78,    79,    -1,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
      -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,   126,
     127,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    -1,    72,
      -1,    74,    75,    -1,    77,    78,    79,    -1,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,    -1,    -1,    -1,    -1,   121,   122,
     123,   124,   125,   126,   127,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    70,    -1,    72,    -1,    74,    75,    -1,    77,    78,
      79,    -1,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,   123,   124,   125,   126,   127,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    -1,    72,    -1,    74,
      75,    -1,    77,    78,    79,    -1,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,
     125,   126,   127,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      -1,    72,    -1,    74,    75,    -1,    77,    78,    79,    -1,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,   124,   125,   126,   127,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    -1,    -1,    42,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    70,    -1,    72,    -1,    74,    75,
      -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    -1,    -1,    -1,   120,    -1,   122,   123,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    33,    34,
      35,    -1,    -1,    -1,    39,    -1,    -1,    42,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    70,    -1,    72,    -1,    74,
      75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    72,    -1,
      74,    75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    35,    -1,    -1,    -1,    39,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    72,
      -1,    74,    -1,    -1,    77,    78,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    42,    -1,    -1,    -1,    -1,   122,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    72,    -1,    74,    75,    -1,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,   123,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    70,    -1,    72,    -1,    74,    -1,    42,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,   123,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,   116,    -1,    32,    33,    34,    -1,   122,   123,
      -1,    -1,    -1,    -1,    42,    -1,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    70,    -1,    72,    -1,    74,    -1,    42,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,   123,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,   116,    -1,    32,    33,    34,    -1,   122,   123,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,    77,
      78,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,   116,    42,
      -1,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    72,
      -1,    74,    -1,    -1,    77,    78,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    42,    -1,    -1,    -1,    -1,   122,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,    77,
      78,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    43,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    70,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,
      79,    -1,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,   125,   126,   127,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,   124,   125,   126,   127,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    -1,    -1,
      -1,    -1,    75,    -1,    77,    78,    79,    -1,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
     123,   124,   125,   126,   127,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    -1,    -1,    -1,    -1,
      75,    -1,    77,    78,    79,    -1,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,
     125,   126,   127,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    43,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    -1,    -1,    -1,    -1,    75,    -1,
      77,    78,    79,    -1,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,   123,   124,   125,   126,
     127,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,    70,    -1,
      72,    -1,    74,    42,    43,    77,    78,    -1,    -1,    -1,
      -1,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    70,    -1,    32,    33,    34,    -1,    -1,    77,    78,
      -1,    -1,    -1,    42,    -1,    -1,    -1,   119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,   116,    77,    78,
      -1,   120,    -1,   122,   123,    -1,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,   116,    42,    -1,
      -1,    -1,    -1,   122,   123,    -1,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    70,    -1,    32,    33,
      34,    -1,    -1,    77,    78,    -1,    -1,    -1,    42,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    42,   116,    77,    78,    -1,    -1,    -1,   122,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    40,    41,    -1,    43,    44,    -1,    46,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    70,
      67,    72,    69,    74,    -1,    -1,    77,    78,    75,    -1,
      77,    78,    79,    -1,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   115,    -1,    -1,   114,    -1,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,   126,
     127,    -1,    -1,    40,    41,   132,    43,    44,    -1,    46,
     137,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    60,    -1,    -1,    -1,    64,    65,    -1,
      67,    -1,    69,    -1,    -1,    -1,    -1,    -1,    75,    -1,
      77,    78,    79,    -1,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,   126,
     127,    -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,
     137,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    40,    41,    -1,    43,    44,    -1,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    70,    67,    72,
      69,    74,    -1,    -1,    77,    78,    75,    -1,    77,    78,
      79,    -1,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    -1,    -1,    -1,    -1,   101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,   125,   126,   127,    -1,
      -1,    40,    41,   132,    43,    44,    -1,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    60,    -1,    -1,    -1,    64,    65,    -1,    67,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,
      79,    -1,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,   125,   126,   127,    -1,
      -1,    40,    41,   132,    43,    44,    -1,    46,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    60,    -1,    -1,    -1,    64,    65,    -1,    67,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,
      79,    -1,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,   125,   126,   127,    69,
      -1,    -1,    -1,   132,    -1,    75,    -1,    -1,    -1,    79,
      -1,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    69,    -1,
      -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    79,    -1,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    -1,   119,    -1,
      -1,   122,   123,   124,   125,   126,   127,    69,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,   123,   124,   125,   126,   127,    69,    -1,    -1,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
     123,   124,   125,   126,   127,    69,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    79,    -1,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,
     124,   125,   126,   127,    69,    -1,    -1,    -1,    -1,    -1,
      75,    -1,    -1,    -1,    79,    -1,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,
     125,   126,   127,    69,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,   125,
     126,   127,    69,    -1,    -1,    -1,    -1,    -1,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,   123,   124,   125,   126,
     127,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    70,    -1,    32,    33,    34,    75,    -1,    77,    78,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    72,    -1,    74,    -1,    -1,    77,    78,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    72,
      -1,    74,    -1,    -1,    77,    78,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,    77,
      78,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    35,    36,    37,    38,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    32,    33,
      34,    35,    39,    42,    43,    67,    70,    72,    74,    75,
      77,    78,    79,    88,    89,   114,   116,   122,   123,   142,
     145,   157,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   232,   233,   234,   235,   236,   237,   239,
     240,   241,   242,   243,   244,   245,   247,   248,   249,   250,
     251,   252,   254,   262,   289,   290,   291,   299,   302,   308,
     309,   311,   313,   314,   320,   325,   329,   330,   331,   332,
     333,   334,   335,   336,   356,   373,   374,   375,   376,    75,
     144,   145,   157,   223,   225,   233,   235,   244,   248,   250,
     290,    84,   114,   318,   319,   320,    75,    77,    78,    79,
     143,   144,   279,   280,   300,   301,    77,    78,   280,   114,
     311,   114,   114,   157,   325,   330,   331,   332,   334,   335,
     336,   117,   139,   226,   233,   235,   329,   333,   372,   373,
     376,   377,   140,   112,   136,   283,   119,   140,   181,    77,
      78,   142,   278,   140,   140,   140,    77,    78,   114,   157,
     231,   315,   324,   325,   326,   327,   328,   329,   333,   337,
     338,   339,   340,   341,   347,     3,    30,    81,   246,     3,
       5,    77,   116,   157,   225,   236,   240,   242,   251,   291,
     329,   333,   376,   223,   225,   235,   244,   248,   250,   290,
     329,   333,    35,   241,   241,   236,   242,   140,   241,   236,
     241,   236,   318,   241,   236,   121,   140,   140,     0,   139,
     114,   181,   318,   318,   139,   116,   233,   235,   374,   278,
     278,   136,   235,   114,   157,   315,   325,   329,   116,   157,
     376,   312,   238,   119,   280,   320,   114,   296,   114,   114,
      84,   146,   147,    40,    41,    43,    69,    75,    79,    82,
      83,    85,    86,    87,    91,    92,   114,   116,   124,   125,
     126,   127,   141,   145,   146,   148,   149,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   172,   175,   233,   281,   282,   298,   372,   377,
     235,   115,   115,   115,   115,   115,   115,   115,   116,   233,
     356,   374,   116,   122,   157,   172,   225,   226,   232,   235,
     239,   240,   244,   247,   248,   250,   268,   269,   273,   274,
     275,   276,   290,   356,   368,   369,   370,   371,   376,   377,
     114,   329,   333,   376,   114,   121,   137,   116,   119,   157,
     172,   284,   284,   120,   139,   121,   137,   114,   121,   137,
     121,   137,   121,   137,   325,   326,   327,   328,   338,   339,
     340,   341,   235,   324,   337,   121,   140,    67,   317,   116,
     318,   355,   356,   318,   318,   181,   139,   114,   318,   355,
     318,   318,   235,   315,   114,   114,   234,   235,   233,   235,
     139,   233,   372,   377,   181,   139,   278,   283,   225,   240,
     329,   333,   181,   139,   300,   235,   244,   137,   235,   235,
      78,   114,   119,   280,   291,   235,   300,   137,   137,   311,
     139,   144,   277,     3,   140,   215,   216,   230,   232,   235,
     139,   317,   114,   317,   172,   325,   235,   114,   139,   278,
     119,    35,    36,    37,    38,   233,   292,   293,   295,   264,
     280,   263,   139,   133,   136,   297,   139,    10,    75,    77,
      78,   321,   322,   323,   115,    84,   114,   156,   114,   156,
     159,   114,   156,   114,   114,   156,   156,   116,   172,   177,
     181,   281,   376,   139,    86,    90,    91,    92,   114,   116,
     118,   119,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   136,   174,   159,   159,   122,   128,   129,
     124,   125,    93,    94,    95,    96,   130,   131,    97,    98,
     123,   132,   133,    99,   100,   134,   114,   157,   351,   352,
     353,   354,   355,   115,   121,   114,   355,   356,   114,   355,
     356,   139,   233,   374,   117,   139,   140,   233,   235,   367,
     368,   376,   377,   140,   114,   116,   136,   157,   325,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   356,   357,
     358,   359,   360,   361,   362,   379,   157,   376,   235,   140,
     140,   157,   233,   235,   369,   278,   233,   356,   369,   278,
     139,   139,   139,   139,    75,   116,   118,   145,   280,   284,
     285,   286,   287,   288,   139,   139,   139,   139,   139,   139,
     115,   115,   115,   115,   115,   115,   115,   324,   337,   318,
     137,   114,   283,   117,   215,   139,   315,   177,   282,   177,
     282,   315,   116,   215,   317,   181,   139,   215,   298,   255,
     253,   235,   270,   271,   272,   275,   276,   115,   121,   181,
     139,   122,   172,   139,   232,   235,   269,   368,   376,   309,
     310,   114,   157,   342,   115,   121,   379,   280,   121,   378,
     136,   265,   119,   292,   114,   119,   280,   282,   292,   115,
     121,   114,   137,   281,   116,   281,   281,   151,   172,   282,
     281,   139,   115,   121,   115,   115,   121,   172,   116,   144,
     150,   151,   139,   116,   144,   150,   172,   159,   159,   159,
     160,   160,   161,   161,   162,   162,   162,   162,   163,   163,
     164,   165,   166,   167,   168,   135,   177,   139,   352,   353,
     354,   235,   351,   318,   318,   172,   282,   139,   139,   233,
     356,   369,   235,   239,   117,   376,   117,   114,   139,   325,
     343,   344,   345,   348,   358,   359,   360,   117,   139,   172,
     235,   342,   346,   357,   114,   318,   361,   379,   318,   318,
     379,   114,   318,   361,   318,   318,   379,   318,   318,   356,
     233,   367,   377,   278,   117,   121,   117,   121,   379,   233,
     369,   379,   266,   267,   268,   269,   266,   278,   172,   139,
     116,   280,   135,   121,   378,   284,   116,   135,   288,    31,
     217,   218,   278,   266,   144,   315,   144,   114,   318,   355,
     356,   114,   318,   355,   356,   315,   146,   356,   181,   270,
     115,   115,   115,   115,   139,   181,   215,   181,   115,    43,
     120,   233,   256,   257,   372,   119,   140,   140,   144,   230,
     140,   140,   266,   114,   157,   376,   140,   120,   235,   293,
     294,   280,   120,   170,   171,   264,   140,   139,   139,   114,
     140,   115,   322,   150,   115,   139,   121,   115,   115,   115,
     115,   172,   119,   159,   172,   173,   176,   121,   139,   115,
     121,   172,   139,   120,   170,   135,   270,   115,   115,   115,
     351,   270,   270,   233,   369,   116,   122,   157,   172,   172,
     235,   348,   270,   115,   115,   115,   115,   115,   115,   115,
       7,   235,   342,   346,   357,   139,   139,   379,   139,   139,
     140,   140,   140,   140,   283,   170,   171,   172,   316,   139,
     284,   286,   120,   139,   219,   280,    43,    44,    46,    49,
      50,    51,    52,    53,    54,    55,    56,    60,    64,    65,
      67,    75,    77,    78,    79,   132,   145,   177,   178,   179,
     180,   181,   182,   183,   185,   186,   198,   200,   201,   206,
     220,   278,   314,    31,   140,   136,   139,   139,   317,   115,
     140,   181,   119,   233,   257,   114,   135,   157,   258,   259,
     261,   324,   325,   337,   355,   363,   364,   365,   366,   121,
     137,   280,   255,   115,   121,   117,   117,   140,   235,   121,
     379,   296,   265,   378,   115,   292,   223,   225,   233,   304,
     305,   306,   307,   298,   115,   115,   144,   285,   121,   140,
     176,    82,    85,    87,   144,   152,   153,   154,   151,   140,
     152,   170,   140,   114,   318,   355,   356,   140,   140,   139,
     140,   140,   140,   172,   115,   140,   114,   318,   355,   356,
     114,   318,   361,   114,   318,   361,   356,   234,     7,   122,
     140,   172,   270,   270,   269,   273,   273,   274,   115,   121,
     121,   115,   101,   127,   140,   140,   152,   284,   172,   121,
     137,   220,   314,   114,   114,   179,   114,   114,   137,   278,
     137,   278,   122,   278,   178,   114,   181,   173,   173,    11,
     207,   149,   137,   140,   139,   140,   135,   219,   115,   172,
     270,   270,   283,   318,   115,   255,   258,   137,   325,   364,
     365,   366,   171,   235,   363,   121,   137,   260,   261,   260,
     318,   318,   280,   120,   139,   115,   139,   120,   140,   315,
     120,   139,   140,   140,   115,   119,   115,   378,   173,   117,
     140,   155,   116,   153,   155,   155,   121,   140,    90,   118,
     117,   140,   115,   139,   115,   115,   117,   117,   117,   140,
     115,   139,   139,   139,   172,   172,   140,   117,   140,   140,
     140,   140,   139,   139,   171,   171,   117,   117,   140,   280,
     177,   177,    50,   177,   139,   137,   137,   177,   137,   137,
     177,    61,    62,    63,   202,   203,   204,   137,    66,   137,
      54,   114,   119,   183,   120,   318,   137,   140,   140,   120,
     137,   115,   115,   115,   363,   318,   101,   275,   276,   115,
     305,   121,   137,   121,   137,   120,   303,   120,   117,    86,
     139,   153,   117,   116,   153,   116,   153,   117,   270,   117,
     270,   270,   270,   140,   140,   117,   117,   115,   115,   117,
     121,   101,   269,   101,   140,   117,   115,   115,   114,   115,
     178,   199,   220,   224,   235,   239,   137,   115,   114,   114,
     181,   204,    61,    62,   172,   114,   146,   150,   179,   115,
     115,   114,   318,   355,   356,   259,   119,   139,   139,   304,
     152,   139,   139,   140,   140,   140,   140,   117,   117,   139,
     140,   117,   179,    47,    48,   119,   189,   190,   191,   177,
     179,   140,   115,   178,   235,   119,   191,   101,   139,   101,
     139,   114,   114,   137,   146,   115,   135,   120,   139,   139,
     278,   315,   120,   140,   152,   152,   115,   115,   115,   115,
     273,    45,   171,   187,   188,   316,   135,   139,   179,   189,
     115,   137,   179,   137,   139,   115,   139,   115,   139,   101,
     139,   101,   139,   135,   137,   116,   146,   208,   209,   210,
     137,   270,   304,   117,   140,   140,   179,   101,   121,   135,
     140,   213,   214,   220,   137,   178,   178,   213,   181,   205,
     233,   372,   181,   205,   115,   139,   115,   139,   135,   171,
     114,   115,   135,   121,   140,   120,   117,   117,   171,   187,
     190,   192,   193,   139,   137,   190,   194,   195,   140,   114,
     157,   315,   363,   144,   140,   181,   205,   181,   205,   208,
     117,   171,   137,   208,   210,   115,   114,   179,   184,   120,
     190,   220,   178,    59,   184,   197,   120,   190,   115,   235,
     115,   140,   140,   135,   146,   115,   115,   135,   298,   179,
     184,   137,   196,   197,   184,   197,   181,   181,   115,   115,
     146,   211,   114,   137,   211,   115,   196,   140,   140,   181,
     181,   121,   135,   171,   115,   140,   140,   146,   144,   212,
     115,   137,   115,   121,   137,   144
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 326 "parser.yy"
    { typedefTable.enterScope(); }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 330 "parser.yy"
    { typedefTable.leaveScope(); }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 337 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantInteger( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 338 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantFloat( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 339 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantFloat( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 340 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantFloat( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 341 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantChar( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 366 "parser.yy"
    { (yyval.constant) = build_constantStr( *(yyvsp[(1) - (1)].str) ); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 370 "parser.yy"
    { (yyval.str) = (yyvsp[(1) - (1)].tok); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 372 "parser.yy"
    {
			appendStr( (yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].tok) );						// append 2nd juxtaposed string to 1st
			delete (yyvsp[(2) - (2)].tok);									// allocated by lexer
			(yyval.str) = (yyvsp[(1) - (2)].str);									// conversion from tok to str
		}
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 383 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_varref( (yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 385 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantZeroOne( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 388 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (3)].en); }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 390 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_valexpr( (yyvsp[(2) - (3)].sn) ) ); }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 400 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Index, (yyvsp[(1) - (6)].en), (yyvsp[(4) - (6)].en) ) ); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 402 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_func( (yyvsp[(1) - (4)].en), (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 404 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (3)].en), build_varref( (yyvsp[(3) - (3)].tok) ) ) ); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 406 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 408 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (2)].en), build_field_name_REALFRACTIONconstant( *(yyvsp[(2) - (2)].tok) ) ) ); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 410 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (3)].en), build_varref( (yyvsp[(3) - (3)].tok) ) ) ); }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 412 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 414 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::IncrPost, (yyvsp[(1) - (2)].en) ) ); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 416 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::DecrPost, (yyvsp[(1) - (2)].en) ) ); }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 418 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_compoundLiteral( (yyvsp[(2) - (7)].decl), new InitializerNode( (yyvsp[(5) - (7)].in), true ) ) ); }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 420 "parser.yy"
    {
			Token fn;
			fn.str = new std::string( "?{}" );			// location undefined - use location of '{'?
			(yyval.en) = new ExpressionNode( new ConstructorExpr( build_func( new ExpressionNode( build_varref( fn ) ), (ExpressionNode *)( (yyvsp[(1) - (4)].en) )->set_last( (yyvsp[(3) - (4)].en) ) ) ) );
		}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 430 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) )); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 435 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 441 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) ); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 447 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( new ExpressionNode( build_field_name_REALDECIMALconstant( *(yyvsp[(1) - (2)].tok) ) ), maybeMoveBuild<Expression>( (yyvsp[(2) - (2)].en) ) ) ); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 449 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( new ExpressionNode( build_field_name_REALDECIMALconstant( *(yyvsp[(1) - (6)].tok) ) ), build_tuple( (yyvsp[(4) - (6)].en) ) ) ); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 451 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (3)].en), maybeMoveBuild<Expression>( (yyvsp[(3) - (3)].en) ) ) ); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 453 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 455 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (3)].en), maybeMoveBuild<Expression>( (yyvsp[(3) - (3)].en) ) ) ); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 457 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 462 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_constantInteger( *(yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 464 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_field_name_FLOATINGconstant( *(yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 466 "parser.yy"
    {
			if( (*(yyvsp[(1) - (2)].tok)) == "0" || (*(yyvsp[(1) - (2)].tok)) == "1" ) {
				(yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_constantZeroOne( *(yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) );
			} else {
				(yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_varref( (yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) );
			}
		}
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 477 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 479 "parser.yy"
    {
			Expression * constant = build_field_name_REALFRACTIONconstant( *(yyvsp[(2) - (2)].tok) );
			(yyval.en) = (yyvsp[(1) - (2)].en) != nullptr ? new ExpressionNode( build_fieldSel( (yyvsp[(1) - (2)].en),  constant ) ) : new ExpressionNode( constant );
		}
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 490 "parser.yy"
    { (yyval.en) = (yyvsp[(1) - (1)].en); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 492 "parser.yy"
    { (yyval.en) = new ExpressionNode( (yyvsp[(1) - (1)].constant) ); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 494 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en)->set_extension( true ); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 499 "parser.yy"
    {
			switch ( (yyvsp[(1) - (2)].op) ) {
			  case OperKinds::AddressOf:
				(yyval.en) = new ExpressionNode( build_addressOf( (yyvsp[(2) - (2)].en) ) );
				break;
			  case OperKinds::PointTo:
				(yyval.en) = new ExpressionNode( build_unary_val( (yyvsp[(1) - (2)].op), (yyvsp[(2) - (2)].en) ) );
				break;
			  default:
				assert( false );
			}
		}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 512 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_val( (yyvsp[(1) - (2)].op), (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 514 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::Incr, (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 516 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::Decr, (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 518 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_sizeOfexpr( (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 520 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_sizeOftype( (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 522 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_alignOfexpr( (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 524 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_alignOftype( (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 526 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_offsetOf( (yyvsp[(3) - (6)].decl), build_varref( (yyvsp[(5) - (6)].tok) ) ) ); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 528 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_attrexpr( build_varref( (yyvsp[(1) - (1)].tok) ), nullptr ) ); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 530 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_attrexpr( build_varref( (yyvsp[(1) - (4)].tok) ), (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 532 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_attrtype( build_varref( (yyvsp[(1) - (4)].tok) ), (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 538 "parser.yy"
    { (yyval.op) = OperKinds::PointTo; }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 539 "parser.yy"
    { (yyval.op) = OperKinds::AddressOf; }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 545 "parser.yy"
    { (yyval.op) = OperKinds::UnPlus; }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 546 "parser.yy"
    { (yyval.op) = OperKinds::UnMinus; }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 547 "parser.yy"
    { (yyval.op) = OperKinds::Neg; }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 548 "parser.yy"
    { (yyval.op) = OperKinds::BitNeg; }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 554 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_cast( (yyvsp[(2) - (4)].decl), (yyvsp[(4) - (4)].en) ) ); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 562 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Mul, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 564 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Div, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 566 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Mod, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 572 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Plus, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 574 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Minus, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 580 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::LShift, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 582 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::RShift, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 588 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::LThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 590 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::GThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 592 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::LEThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 594 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::GEThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 600 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Eq, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 602 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Neq, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 608 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::BitAnd, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 614 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Xor, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 620 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::BitOr, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 626 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_and_or( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en), true ) ); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 632 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_and_or( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en), false ) ); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 638 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_cond( (yyvsp[(1) - (5)].en), (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].en) ) ); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 641 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_cond( (yyvsp[(1) - (4)].en), (yyvsp[(1) - (4)].en), (yyvsp[(4) - (4)].en) ) ); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 654 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_ptr( (yyvsp[(2) - (3)].op), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 661 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 666 "parser.yy"
    { (yyval.op) = OperKinds::Assign; }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 667 "parser.yy"
    { (yyval.op) = OperKinds::AtAssn; }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 668 "parser.yy"
    { (yyval.op) = OperKinds::MulAssn; }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 669 "parser.yy"
    { (yyval.op) = OperKinds::DivAssn; }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 670 "parser.yy"
    { (yyval.op) = OperKinds::ModAssn; }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 671 "parser.yy"
    { (yyval.op) = OperKinds::PlusAssn; }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 672 "parser.yy"
    { (yyval.op) = OperKinds::MinusAssn; }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 673 "parser.yy"
    { (yyval.op) = OperKinds::LSAssn; }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 674 "parser.yy"
    { (yyval.op) = OperKinds::RSAssn; }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 675 "parser.yy"
    { (yyval.op) = OperKinds::AndAssn; }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 676 "parser.yy"
    { (yyval.op) = OperKinds::ERAssn; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 677 "parser.yy"
    { (yyval.op) = OperKinds::OrAssn; }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 688 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_tuple( (ExpressionNode *)(new ExpressionNode( nullptr ) )->set_last( (yyvsp[(4) - (6)].en) ) ) ); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 690 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_tuple( (ExpressionNode *)(yyvsp[(3) - (7)].en)->set_last( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 696 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) ); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 702 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_comma( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 707 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 716 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (1)].sn); }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 723 "parser.yy"
    {
			Token fn;
			fn.str = new string( "^?{}" );				// location undefined
			(yyval.sn) = new StatementNode( build_expr( new ExpressionNode( build_func( new ExpressionNode( build_varref( fn ) ), (ExpressionNode *)( (yyvsp[(2) - (6)].en) )->set_last( (yyvsp[(4) - (6)].en) ) ) ) ) );
		}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 733 "parser.yy"
    {
			(yyval.sn) = (yyvsp[(4) - (4)].sn)->add_label( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].decl) );
		}
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 740 "parser.yy"
    { (yyval.sn) = new StatementNode( build_compound( (StatementNode *)0 ) ); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 748 "parser.yy"
    { (yyval.sn) = new StatementNode( build_compound( (yyvsp[(5) - (7)].sn) ) ); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 754 "parser.yy"
    { if ( (yyvsp[(1) - (3)].sn) != 0 ) { (yyvsp[(1) - (3)].sn)->set_last( (yyvsp[(3) - (3)].sn) ); (yyval.sn) = (yyvsp[(1) - (3)].sn); } }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 759 "parser.yy"
    { (yyval.sn) = new StatementNode( (yyvsp[(1) - (1)].decl) ); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 761 "parser.yy"
    {
			distExt( (yyvsp[(2) - (2)].decl) );
			(yyval.sn) = new StatementNode( (yyvsp[(2) - (2)].decl) );
		}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 766 "parser.yy"
    { (yyval.sn) = new StatementNode( (yyvsp[(1) - (1)].decl) ); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 768 "parser.yy"
    {
			distExt( (yyvsp[(2) - (2)].decl) );
			(yyval.sn) = new StatementNode( (yyvsp[(2) - (2)].decl) );
		}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 778 "parser.yy"
    { if ( (yyvsp[(1) - (2)].sn) != 0 ) { (yyvsp[(1) - (2)].sn)->set_last( (yyvsp[(2) - (2)].sn) ); (yyval.sn) = (yyvsp[(1) - (2)].sn); } }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 783 "parser.yy"
    { (yyval.sn) = new StatementNode( build_expr( (yyvsp[(1) - (2)].en) ) ); }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 789 "parser.yy"
    { (yyval.sn) = new StatementNode( build_if( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn), nullptr ) ); }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 791 "parser.yy"
    { (yyval.sn) = new StatementNode( build_if( (yyvsp[(3) - (7)].en), (yyvsp[(5) - (7)].sn), (yyvsp[(7) - (7)].sn) ) ); }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 793 "parser.yy"
    { (yyval.sn) = new StatementNode( build_switch( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn) ) ); }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 795 "parser.yy"
    {
			StatementNode *sw = new StatementNode( build_switch( (yyvsp[(3) - (9)].en), (yyvsp[(8) - (9)].sn) ) );
			// The semantics of the declaration list is changed to include associated initialization, which is performed
			// *before* the transfer to the appropriate case clause by hoisting the declarations into a compound
			// statement around the switch.  Statements after the initial declaration list can never be executed, and
			// therefore, are removed from the grammar even though C allows it. The change also applies to choose
			// statement.
			(yyval.sn) = (yyvsp[(7) - (9)].decl) ? new StatementNode( build_compound( (StatementNode *)((new StatementNode( (yyvsp[(7) - (9)].decl) ))->set_last( sw )) ) ) : sw;
		}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 805 "parser.yy"
    { (yyval.sn) = new StatementNode( build_switch( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn) ) ); }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 807 "parser.yy"
    {
			StatementNode *sw = new StatementNode( build_switch( (yyvsp[(3) - (9)].en), (yyvsp[(8) - (9)].sn) ) );
			(yyval.sn) = (yyvsp[(7) - (9)].decl) ? new StatementNode( build_compound( (StatementNode *)((new StatementNode( (yyvsp[(7) - (9)].decl) ))->set_last( sw )) ) ) : sw;
		}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 817 "parser.yy"
    { (yyval.en) = (yyvsp[(1) - (1)].en); }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 819 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_range( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 824 "parser.yy"
    { (yyval.sn) = new StatementNode( build_case( (yyvsp[(1) - (1)].en) ) ); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 826 "parser.yy"
    { (yyval.sn) = (StatementNode *)((yyvsp[(1) - (3)].sn)->set_last( new StatementNode( build_case( (yyvsp[(3) - (3)].en) ) ) ) ); }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 830 "parser.yy"
    { (yyval.sn) = (yyvsp[(2) - (3)].sn); }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 831 "parser.yy"
    { (yyval.sn) = new StatementNode( build_default() ); }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 837 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (2)].sn)->set_last( (yyvsp[(2) - (2)].sn) )); }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 841 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (2)].sn)->append_last_case( new StatementNode( build_compound( (yyvsp[(2) - (2)].sn) ) ) ); }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 846 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 852 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (2)].sn)->append_last_case( new StatementNode( build_compound( (yyvsp[(2) - (2)].sn) ) ) ); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 854 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (3)].sn)->set_last( (yyvsp[(2) - (3)].sn)->append_last_case( new StatementNode( build_compound( (yyvsp[(3) - (3)].sn) ) ) ) ) ); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 859 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 865 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (2)].sn)->append_last_case( (yyvsp[(2) - (2)].sn) ); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 867 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (3)].sn)->append_last_case( new StatementNode( build_compound( (StatementNode *)(yyvsp[(2) - (3)].sn)->set_last( (yyvsp[(3) - (3)].sn) ) ) ) ); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 869 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (3)].sn)->set_last( (yyvsp[(2) - (3)].sn)->append_last_case( (yyvsp[(3) - (3)].sn) ))); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 871 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (4)].sn)->set_last( (yyvsp[(2) - (4)].sn)->append_last_case( new StatementNode( build_compound( (StatementNode *)(yyvsp[(3) - (4)].sn)->set_last( (yyvsp[(4) - (4)].sn) ) ) ) ) ) ); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 876 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( BranchStmt::Break ) ); }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 882 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 884 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 889 "parser.yy"
    { (yyval.sn) = new StatementNode( build_while( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn) ) ); }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 891 "parser.yy"
    { (yyval.sn) = new StatementNode( build_while( (yyvsp[(5) - (7)].en), (yyvsp[(2) - (7)].sn), true ) ); }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 893 "parser.yy"
    { (yyval.sn) = new StatementNode( build_for( (yyvsp[(4) - (6)].fctl), (yyvsp[(6) - (6)].sn) ) ); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 898 "parser.yy"
    { (yyval.fctl) = new ForCtl( (yyvsp[(1) - (6)].en), (yyvsp[(4) - (6)].en), (yyvsp[(6) - (6)].en) ); }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 900 "parser.yy"
    { (yyval.fctl) = new ForCtl( (yyvsp[(1) - (4)].decl), (yyvsp[(2) - (4)].en), (yyvsp[(4) - (4)].en) ); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 905 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( (yyvsp[(2) - (3)].tok), BranchStmt::Goto ) ); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 909 "parser.yy"
    { (yyval.sn) = new StatementNode( build_computedgoto( (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 912 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( BranchStmt::Continue ) ); }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 916 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( (yyvsp[(2) - (3)].tok), BranchStmt::Continue ) ); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 919 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( BranchStmt::Break ) ); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 923 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( (yyvsp[(2) - (3)].tok), BranchStmt::Break ) ); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 925 "parser.yy"
    { (yyval.sn) = new StatementNode( build_return( (yyvsp[(2) - (3)].en) ) ); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 927 "parser.yy"
    { (yyval.sn) = new StatementNode( build_throw( (yyvsp[(2) - (3)].en) ) ); }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 929 "parser.yy"
    { (yyval.sn) = new StatementNode( build_throw( (yyvsp[(2) - (3)].en) ) ); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 931 "parser.yy"
    { (yyval.sn) = new StatementNode( build_throw( (yyvsp[(2) - (5)].en) ) ); }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 936 "parser.yy"
    { (yyval.sn) = new StatementNode( build_try( (yyvsp[(2) - (3)].sn), (yyvsp[(3) - (3)].sn), 0 ) ); }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 938 "parser.yy"
    { (yyval.sn) = new StatementNode( build_try( (yyvsp[(2) - (3)].sn), 0, (yyvsp[(3) - (3)].sn) ) ); }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 940 "parser.yy"
    { (yyval.sn) = new StatementNode( build_try( (yyvsp[(2) - (4)].sn), (yyvsp[(3) - (4)].sn), (yyvsp[(4) - (4)].sn) ) ); }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 947 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( 0, (yyvsp[(5) - (5)].sn), true ) ); }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 949 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (6)].sn)->set_last( new StatementNode( build_catch( 0, (yyvsp[(6) - (6)].sn), true ) ) ); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 951 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( 0, (yyvsp[(5) - (5)].sn), true ) ); }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 953 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (6)].sn)->set_last( new StatementNode( build_catch( 0, (yyvsp[(6) - (6)].sn), true ) ) ); }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 958 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( (yyvsp[(5) - (9)].decl), (yyvsp[(8) - (9)].sn) ) ); }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 960 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (10)].sn)->set_last( new StatementNode( build_catch( (yyvsp[(6) - (10)].decl), (yyvsp[(9) - (10)].sn) ) ) ); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 962 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( (yyvsp[(5) - (9)].decl), (yyvsp[(8) - (9)].sn) ) ); }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 964 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (10)].sn)->set_last( new StatementNode( build_catch( (yyvsp[(6) - (10)].decl), (yyvsp[(9) - (10)].sn) ) ) ); }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 969 "parser.yy"
    {
			(yyval.sn) = new StatementNode( build_finally( (yyvsp[(2) - (2)].sn) ) );
		}
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 982 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 987 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 989 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addName( (yyvsp[(2) - (2)].tok) );
		}
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 998 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (6)].flag), (yyvsp[(4) - (6)].constant), 0 ) ); }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1000 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (8)].flag), (yyvsp[(4) - (8)].constant), (yyvsp[(6) - (8)].en) ) ); }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1002 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (10)].flag), (yyvsp[(4) - (10)].constant), (yyvsp[(6) - (10)].en), (yyvsp[(8) - (10)].en) ) ); }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1004 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (12)].flag), (yyvsp[(4) - (12)].constant), (yyvsp[(6) - (12)].en), (yyvsp[(8) - (12)].en), (yyvsp[(10) - (12)].en) ) ); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1006 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (14)].flag), (yyvsp[(5) - (14)].constant), 0, (yyvsp[(8) - (14)].en), (yyvsp[(10) - (14)].en), (yyvsp[(12) - (14)].label) ) ); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1011 "parser.yy"
    { (yyval.flag) = false; }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1013 "parser.yy"
    { (yyval.flag) = true; }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1018 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1025 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) ); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1030 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_asmexpr( 0, (yyvsp[(1) - (4)].constant), (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1032 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_asmexpr( (yyvsp[(2) - (7)].en), (yyvsp[(4) - (7)].constant), (yyvsp[(6) - (7)].en) ) ); }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1037 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1039 "parser.yy"
    { (yyval.en) = new ExpressionNode( (yyvsp[(1) - (1)].constant) ); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1042 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( new ExpressionNode( (yyvsp[(3) - (3)].constant) ) ); }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1047 "parser.yy"
    {
			(yyval.label) = new LabelNode(); (yyval.label)->labels.push_back( *(yyvsp[(1) - (1)].tok) );
			delete (yyvsp[(1) - (1)].tok);									// allocated by lexer
		}
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1052 "parser.yy"
    {
			(yyval.label) = (yyvsp[(1) - (3)].label); (yyvsp[(1) - (3)].label)->labels.push_back( *(yyvsp[(3) - (3)].tok) );
			delete (yyvsp[(3) - (3)].tok);									// allocated by lexer
		}
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1062 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1069 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1074 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1081 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1095 "parser.yy"
    {}
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1096 "parser.yy"
    {}
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1125 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addInitializer( (yyvsp[(2) - (2)].in) );
		}
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1132 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].in) );;
		}
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1137 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (6)].tok), TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (6)].decl)->appendList( (yyvsp[(1) - (6)].decl)->cloneType( (yyvsp[(5) - (6)].tok) )->addInitializer( (yyvsp[(6) - (6)].in) ) );
		}
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1147 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(2) - (3)].tok) );
			(yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) )->addAsmName( (yyvsp[(3) - (3)].decl) );
		}
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1152 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(2) - (3)].tok) );
			(yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) )->addAsmName( (yyvsp[(3) - (3)].decl) );
		}
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1157 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(3) - (4)].tok) );
			(yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(1) - (4)].decl) )->addName( (yyvsp[(3) - (4)].tok) )->addAsmName( (yyvsp[(4) - (4)].decl) );
		}
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1165 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (1)].decl);
		}
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1170 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1175 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1180 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) )->addQualifiers( (yyvsp[(2) - (3)].decl) );
		}
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1185 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (5)].tok), TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneType( (yyvsp[(5) - (5)].tok) ) );
		}
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1216 "parser.yy"
    {
			(yyval.decl) = DeclarationNode::newFunction( (yyvsp[(2) - (7)].tok), (yyvsp[(1) - (7)].decl), (yyvsp[(5) - (7)].decl), 0, true );
		}
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1220 "parser.yy"
    {
			(yyval.decl) = DeclarationNode::newFunction( (yyvsp[(2) - (7)].tok), (yyvsp[(1) - (7)].decl), (yyvsp[(5) - (7)].decl), 0, true );
		}
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1227 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTuple( (yyvsp[(3) - (5)].decl) ); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1231 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTuple( (yyvsp[(3) - (9)].decl)->appendList( (yyvsp[(7) - (9)].decl) ) ); }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1236 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addTypedef();
		}
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1241 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addTypedef();
		}
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1246 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (5)].tok), TypedefTable::TD );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneType( (yyvsp[(5) - (5)].tok) ) );
		}
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1257 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(3) - (3)].decl)->addType( (yyvsp[(2) - (3)].decl) )->addTypedef();
		}
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1262 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneBaseType( (yyvsp[(5) - (5)].decl) )->addTypedef() );
		}
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1267 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(4) - (4)].decl)->addType( (yyvsp[(3) - (4)].decl) )->addQualifiers( (yyvsp[(1) - (4)].decl) )->addTypedef();
		}
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1272 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(3) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addTypedef();
		}
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1277 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(4) - (4)].decl)->addQualifiers( (yyvsp[(1) - (4)].decl) )->addTypedef()->addType( (yyvsp[(1) - (4)].decl) );
		}
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1286 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(2) - (4)].tok), TypedefTable::TD );
			(yyval.decl) = DeclarationNode::newName( 0 );			// unimplemented
		}
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1291 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (7)].tok), TypedefTable::TD );
			(yyval.decl) = DeclarationNode::newName( 0 );			// unimplemented
		}
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1321 "parser.yy"
    {
			(yyval.decl) = distAttr( (yyvsp[(1) - (4)].decl), (yyvsp[(2) - (4)].decl) );
		}
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1333 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (3)].decl)->addAsmName( (yyvsp[(2) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].in) );
		}
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1338 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (6)].decl)->appendList( (yyvsp[(4) - (6)].decl)->addQualifiers( (yyvsp[(3) - (6)].decl) )->addAsmName( (yyvsp[(5) - (6)].decl) )->addInitializer( (yyvsp[(6) - (6)].in) ) );
		}
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1360 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1372 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1382 "parser.yy"
    { (yyval.decl) = DeclarationNode::newQualifier( DeclarationNode::Const ); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1384 "parser.yy"
    { (yyval.decl) = DeclarationNode::newQualifier( DeclarationNode::Restrict ); }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1386 "parser.yy"
    { (yyval.decl) = DeclarationNode::newQualifier( DeclarationNode::Volatile ); }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1388 "parser.yy"
    { (yyval.decl) = DeclarationNode::newQualifier( DeclarationNode::Lvalue ); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1390 "parser.yy"
    { (yyval.decl) = DeclarationNode::newQualifier( DeclarationNode::Atomic ); }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1392 "parser.yy"
    {
			typedefTable.enterScope();
		}
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1396 "parser.yy"
    {
			typedefTable.leaveScope();
			(yyval.decl) = DeclarationNode::newForall( (yyvsp[(4) - (5)].decl) );
		}
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1405 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1407 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1418 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1423 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Extern ); }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1425 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Static ); }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1427 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Auto ); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1429 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Register ); }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1432 "parser.yy"
    { (yyval.decl) = new DeclarationNode; (yyval.decl)->isInline = true; }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1434 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Fortran ); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1437 "parser.yy"
    { (yyval.decl) = new DeclarationNode; (yyval.decl)->isNoreturn = true; }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1439 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Threadlocal ); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1444 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Char ); }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1446 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Double ); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1448 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Float ); }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1450 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Int ); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1452 "parser.yy"
    { (yyval.decl) = DeclarationNode::newLength( DeclarationNode::Long ); }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1454 "parser.yy"
    { (yyval.decl) = DeclarationNode::newLength( DeclarationNode::Short ); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1456 "parser.yy"
    { (yyval.decl) = DeclarationNode::newSignedNess( DeclarationNode::Signed ); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1458 "parser.yy"
    { (yyval.decl) = DeclarationNode::newSignedNess( DeclarationNode::Unsigned ); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1460 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Void ); }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1462 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Bool ); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1464 "parser.yy"
    { (yyval.decl) = DeclarationNode::newComplexType( DeclarationNode::Complex ); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1466 "parser.yy"
    { (yyval.decl) = DeclarationNode::newComplexType( DeclarationNode::Imaginary ); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1468 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBuiltinType( DeclarationNode::Valist ); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1470 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBuiltinType( DeclarationNode::Zero ); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1472 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBuiltinType( DeclarationNode::One ); }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1479 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1481 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1483 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1485 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addType( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1491 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1498 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1500 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1502 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addType( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1507 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (4)].decl); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1509 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeof( (yyvsp[(3) - (4)].en) ); }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1511 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttr( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].decl) ); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1513 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttr( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].en) ); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1519 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1521 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1523 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1529 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1531 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1537 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1539 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1541 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1546 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFromTypedef( (yyvsp[(1) - (1)].tok) ); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1548 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFromTypedef( (yyvsp[(2) - (2)].tok) )->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1550 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1560 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (5)].aggKey), nullptr, nullptr, (yyvsp[(4) - (5)].decl), true )->addQualifiers( (yyvsp[(2) - (5)].decl) ); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1562 "parser.yy"
    {
			typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) );
			(yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (3)].aggKey), (yyvsp[(3) - (3)].tok), nullptr, nullptr, false )->addQualifiers( (yyvsp[(2) - (3)].decl) );
		}
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1567 "parser.yy"
    { typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) ); }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1569 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (7)].aggKey), (yyvsp[(3) - (7)].tok), nullptr, (yyvsp[(6) - (7)].decl), true )->addQualifiers( (yyvsp[(2) - (7)].decl) ); }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1571 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (8)].aggKey), nullptr, (yyvsp[(4) - (8)].en), (yyvsp[(7) - (8)].decl), false )->addQualifiers( (yyvsp[(2) - (8)].decl) ); }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1573 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) ); }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1578 "parser.yy"
    { (yyval.aggKey) = DeclarationNode::Struct; }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1580 "parser.yy"
    { (yyval.aggKey) = DeclarationNode::Union; }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1585 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1587 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl) ? (yyvsp[(1) - (2)].decl)->appendList( (yyvsp[(2) - (2)].decl) ) : (yyvsp[(2) - (2)].decl); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1593 "parser.yy"
    {
			distExt( (yyvsp[(2) - (3)].decl) );								// mark all fields in list
			(yyval.decl) = (yyvsp[(2) - (3)].decl);
		}
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1598 "parser.yy"
    {
			(yyval.decl) = distAttr( (yyvsp[(1) - (3)].decl), (yyvsp[(2) - (3)].decl) ); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1601 "parser.yy"
    {
			distExt( (yyvsp[(3) - (4)].decl) );								// mark all fields in list
			(yyval.decl) = distAttr( (yyvsp[(2) - (4)].decl), (yyvsp[(3) - (4)].decl) );
		}
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1610 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addName( (yyvsp[(2) - (2)].tok) ); }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1612 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(1) - (3)].decl)->cloneType( (yyvsp[(3) - (3)].tok) ) ); }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1614 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->appendList( (yyvsp[(1) - (2)].decl)->cloneType( 0 ) ); }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1620 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->appendList( (yyvsp[(4) - (4)].decl)->addQualifiers( (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1625 "parser.yy"
    { (yyval.decl) = DeclarationNode::newName( 0 ); /* XXX */ }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1627 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBitfield( (yyvsp[(1) - (1)].en) ); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1630 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addBitfield( (yyvsp[(2) - (2)].en) ); }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1633 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addBitfield( (yyvsp[(2) - (2)].en) ); }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1639 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1641 "parser.yy"
    { (yyval.en) = (yyvsp[(1) - (1)].en); }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1646 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en); }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1651 "parser.yy"
    { (yyval.decl) = DeclarationNode::newEnum( nullptr, (yyvsp[(4) - (6)].decl) )->addQualifiers( (yyvsp[(2) - (6)].decl) ); }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1653 "parser.yy"
    {
			typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) );
			(yyval.decl) = DeclarationNode::newEnum( (yyvsp[(3) - (3)].tok), 0 )->addQualifiers( (yyvsp[(2) - (3)].decl) );
		}
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1658 "parser.yy"
    { typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) ); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1660 "parser.yy"
    { (yyval.decl) = DeclarationNode::newEnum( (yyvsp[(3) - (8)].tok), (yyvsp[(6) - (8)].decl) )->addQualifiers( (yyvsp[(2) - (8)].decl) ); }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1665 "parser.yy"
    { (yyval.decl) = DeclarationNode::newEnumConstant( (yyvsp[(1) - (2)].tok), (yyvsp[(2) - (2)].en) ); }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1667 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->appendList( DeclarationNode::newEnumConstant( (yyvsp[(3) - (4)].tok), (yyvsp[(4) - (4)].en) ) ); }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1672 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1674 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en); }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1681 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1689 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 1691 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->addVarArgs(); }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 1693 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->addVarArgs(); }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1701 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 1703 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 1705 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (9)].decl)->appendList( (yyvsp[(5) - (9)].decl) )->appendList( (yyvsp[(9) - (9)].decl) ); }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 1711 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 1716 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 1723 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->addVarArgs(); }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 1730 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 1732 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 1741 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) ); }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 1744 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) ); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 1746 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addName( (yyvsp[(3) - (4)].tok) )->addQualifiers( (yyvsp[(1) - (4)].decl) ); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1756 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1762 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].en) ? new InitializerNode( (yyvsp[(3) - (3)].en) ) : nullptr );
		}
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 1767 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].en) ? new InitializerNode( (yyvsp[(3) - (3)].en) ) : nullptr );
		}
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 1775 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addInitializer( (yyvsp[(2) - (2)].en) ? new InitializerNode( (yyvsp[(2) - (2)].en) ) : nullptr ); }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 1777 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].en) ? new InitializerNode( (yyvsp[(3) - (3)].en) ) : nullptr ); }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 1786 "parser.yy"
    { (yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) ); }
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 1788 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( DeclarationNode::newName( (yyvsp[(3) - (3)].tok) ) ); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1813 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1823 "parser.yy"
    { (yyval.in) = nullptr; }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1825 "parser.yy"
    { (yyval.in) = (yyvsp[(2) - (2)].in); }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 1827 "parser.yy"
    { (yyval.in) = (yyvsp[(2) - (2)].in)->set_maybeConstructed( false ); }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 1831 "parser.yy"
    { (yyval.in) = new InitializerNode( (yyvsp[(1) - (1)].en) ); }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 1832 "parser.yy"
    { (yyval.in) = new InitializerNode( (yyvsp[(2) - (4)].in), true ); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 1837 "parser.yy"
    { (yyval.in) = nullptr; }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 1839 "parser.yy"
    { (yyval.in) = (yyvsp[(2) - (2)].in)->set_designators( (yyvsp[(1) - (2)].en) ); }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 1840 "parser.yy"
    { (yyval.in) = (InitializerNode *)( (yyvsp[(1) - (3)].in)->set_last( (yyvsp[(3) - (3)].in) ) ); }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 1842 "parser.yy"
    { (yyval.in) = (InitializerNode *)( (yyvsp[(1) - (4)].in)->set_last( (yyvsp[(4) - (4)].in)->set_designators( (yyvsp[(3) - (4)].en) ) ) ); }
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 1858 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_varref( (yyvsp[(1) - (2)].tok) ) ); }
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 1864 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (2)].en)->set_last( (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 1870 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_varref( (yyvsp[(2) - (2)].tok) ) ); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 1873 "parser.yy"
    { (yyval.en) = (yyvsp[(3) - (5)].en); }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 1875 "parser.yy"
    { (yyval.en) = (yyvsp[(3) - (5)].en); }
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 1877 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_range( (yyvsp[(3) - (7)].en), (yyvsp[(5) - (7)].en) ) ); }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 1879 "parser.yy"
    { (yyval.en) = (yyvsp[(4) - (6)].en); }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 1903 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 1905 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 1907 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 1913 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 1915 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 1920 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFromTypeGen( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].en) ); }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 1926 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->appendList( (yyvsp[(3) - (4)].decl) ); }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 1931 "parser.yy"
    { typedefTable.addToEnclosingScope( *(yyvsp[(2) - (2)].tok), TypedefTable::TD ); }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 1933 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeParam( (yyvsp[(1) - (4)].tclass), (yyvsp[(2) - (4)].tok) )->addAssertions( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 1939 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Otype; }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 1941 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Dtype; }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 1943 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Ftype; }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 1945 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Ttype; }
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 1950 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 1952 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl) ? (yyvsp[(1) - (2)].decl)->appendList( (yyvsp[(2) - (2)].decl) ) : (yyvsp[(2) - (2)].decl); }
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 1957 "parser.yy"
    {
			typedefTable.openTrait( *(yyvsp[(2) - (5)].tok) );
			(yyval.decl) = DeclarationNode::newTraitUse( (yyvsp[(2) - (5)].tok), (yyvsp[(4) - (5)].en) );
		}
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 1962 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (5)].decl); }
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 1964 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 1969 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_typevalue( (yyvsp[(1) - (1)].decl) ) ); }
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 1972 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (3)].en)->set_last( new ExpressionNode( build_typevalue( (yyvsp[(3) - (3)].decl) ) ) ) ); }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 1974 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) )); }
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 1979 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl); }
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 1981 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 1983 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl)->copyStorageClasses( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 1988 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addAssertions( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 1990 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->addAssertions( (yyvsp[(2) - (4)].decl) )->addType( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 1995 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(1) - (1)].tok), TypedefTable::TD );
			(yyval.decl) = DeclarationNode::newTypeDecl( (yyvsp[(1) - (1)].tok), 0 );
		}
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 2000 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(1) - (6)].tok), TypedefTable::TG );
			(yyval.decl) = DeclarationNode::newTypeDecl( (yyvsp[(1) - (6)].tok), (yyvsp[(4) - (6)].decl) );
		}
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 2008 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(2) - (9)].tok), TypedefTable::ID );
			(yyval.decl) = DeclarationNode::newTrait( (yyvsp[(2) - (9)].tok), (yyvsp[(5) - (9)].decl), 0 );
		}
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 2013 "parser.yy"
    {
			typedefTable.enterTrait( *(yyvsp[(2) - (8)].tok) );
			typedefTable.enterScope();
		}
    break;

  case 512:

/* Line 1806 of yacc.c  */
#line 2018 "parser.yy"
    {
			typedefTable.leaveTrait();
			typedefTable.addToEnclosingScope( *(yyvsp[(2) - (11)].tok), TypedefTable::ID );
			(yyval.decl) = DeclarationNode::newTrait( (yyvsp[(2) - (11)].tok), (yyvsp[(5) - (11)].decl), (yyvsp[(10) - (11)].decl) );
		}
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 2028 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 2038 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (1)].decl);
		}
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 2043 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (1)].decl);
		}
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 2048 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( *(yyvsp[(5) - (5)].tok), TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneType( (yyvsp[(5) - (5)].tok) ) );
		}
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 2056 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 521:

/* Line 1806 of yacc.c  */
#line 2061 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneBaseType( (yyvsp[(5) - (5)].decl) ) );
		}
    break;

  case 522:

/* Line 1806 of yacc.c  */
#line 2071 "parser.yy"
    {}
    break;

  case 523:

/* Line 1806 of yacc.c  */
#line 2073 "parser.yy"
    { parseTree = parseTree ? parseTree->appendList( (yyvsp[(1) - (1)].decl) ) : (yyvsp[(1) - (1)].decl);	}
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 2079 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl) ? (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ) : (yyvsp[(3) - (3)].decl); }
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 2084 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 2092 "parser.yy"
    {
			(yyval.decl) = DeclarationNode::newAsmStmt( new StatementNode( build_asmstmt( false, (yyvsp[(3) - (5)].constant), 0 ) ) );
		}
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 2096 "parser.yy"
    {
			linkageStack.push( linkage );				// handle nested extern "C"/"Cforall"
			linkage = LinkageSpec::linkageCheck( (yyvsp[(2) - (2)].tok) );
		}
    break;

  case 532:

/* Line 1806 of yacc.c  */
#line 2101 "parser.yy"
    {
			linkage = linkageStack.top();
			linkageStack.pop();
			(yyval.decl) = (yyvsp[(5) - (6)].decl);
		}
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 2107 "parser.yy"
    {
			distExt( (yyvsp[(2) - (2)].decl) );								// mark all fields in list
			(yyval.decl) = (yyvsp[(2) - (2)].decl);
		}
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 2121 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addFunctionBody( (yyvsp[(2) - (2)].sn) );
		}
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 2127 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(1) - (4)].decl)->addOldDeclList( (yyvsp[(3) - (4)].decl) )->addFunctionBody( (yyvsp[(4) - (4)].sn) );
		}
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 2136 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addFunctionBody( (yyvsp[(2) - (2)].sn) );
		}
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 2142 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addFunctionBody( (yyvsp[(3) - (3)].sn) )->addType( (yyvsp[(1) - (3)].decl) );
		}
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 2148 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addFunctionBody( (yyvsp[(3) - (3)].sn) )->addQualifiers( (yyvsp[(1) - (3)].decl) );
		}
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 2154 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addFunctionBody( (yyvsp[(3) - (3)].sn) )->addQualifiers( (yyvsp[(1) - (3)].decl) );
		}
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 2160 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(3) - (4)].decl)->addFunctionBody( (yyvsp[(4) - (4)].sn) )->addQualifiers( (yyvsp[(2) - (4)].decl) )->addQualifiers( (yyvsp[(1) - (4)].decl) );
		}
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 2168 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (5)].decl)->addOldDeclList( (yyvsp[(4) - (5)].decl) )->addFunctionBody( (yyvsp[(5) - (5)].sn) )->addType( (yyvsp[(1) - (5)].decl) );
		}
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 2174 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (5)].decl)->addOldDeclList( (yyvsp[(4) - (5)].decl) )->addFunctionBody( (yyvsp[(5) - (5)].sn) )->addQualifiers( (yyvsp[(1) - (5)].decl) );
		}
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 2182 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (5)].decl)->addOldDeclList( (yyvsp[(4) - (5)].decl) )->addFunctionBody( (yyvsp[(5) - (5)].sn) )->addQualifiers( (yyvsp[(1) - (5)].decl) );
		}
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 2188 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(3) - (6)].decl)->addOldDeclList( (yyvsp[(5) - (6)].decl) )->addFunctionBody( (yyvsp[(6) - (6)].sn) )->addQualifiers( (yyvsp[(2) - (6)].decl) )->addQualifiers( (yyvsp[(1) - (6)].decl) );
		}
    break;

  case 549:

/* Line 1806 of yacc.c  */
#line 2203 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_range( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 2208 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 2210 "parser.yy"
    {
			DeclarationNode * name = new DeclarationNode();
			name->asmName = (yyvsp[(3) - (5)].constant);
			(yyval.decl) = name->addQualifiers( (yyvsp[(5) - (5)].decl) );
		}
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 2219 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 2226 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 2231 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (6)].decl); }
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 2237 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 2242 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 2244 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttribute( (yyvsp[(1) - (1)].tok) ); }
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 2246 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttribute( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].en) ); }
    break;

  case 565:

/* Line 1806 of yacc.c  */
#line 2254 "parser.yy"
    { (yyval.tok) = Token{ new string( "__const__" ) }; }
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 2289 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 2292 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 2294 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 2299 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(1) - (1)].tok) );
			(yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) );
		}
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 2304 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 572:

/* Line 1806 of yacc.c  */
#line 2309 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 573:

/* Line 1806 of yacc.c  */
#line 2311 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 574:

/* Line 1806 of yacc.c  */
#line 2313 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 2318 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 576:

/* Line 1806 of yacc.c  */
#line 2320 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 2322 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 2324 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 2329 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 2331 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 581:

/* Line 1806 of yacc.c  */
#line 2340 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 583:

/* Line 1806 of yacc.c  */
#line 2343 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 584:

/* Line 1806 of yacc.c  */
#line 2348 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 2350 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 586:

/* Line 1806 of yacc.c  */
#line 2352 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 2357 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 2359 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 2361 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 2366 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 2368 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 2370 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 2388 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->addIdList( (yyvsp[(3) - (4)].decl) ); }
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 2390 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 2392 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 2397 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 2399 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 601:

/* Line 1806 of yacc.c  */
#line 2401 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 602:

/* Line 1806 of yacc.c  */
#line 2406 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 603:

/* Line 1806 of yacc.c  */
#line 2408 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 604:

/* Line 1806 of yacc.c  */
#line 2410 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 605:

/* Line 1806 of yacc.c  */
#line 2425 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 607:

/* Line 1806 of yacc.c  */
#line 2428 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 608:

/* Line 1806 of yacc.c  */
#line 2430 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 610:

/* Line 1806 of yacc.c  */
#line 2436 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 611:

/* Line 1806 of yacc.c  */
#line 2441 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 612:

/* Line 1806 of yacc.c  */
#line 2443 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 613:

/* Line 1806 of yacc.c  */
#line 2445 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 614:

/* Line 1806 of yacc.c  */
#line 2450 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 615:

/* Line 1806 of yacc.c  */
#line 2452 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 616:

/* Line 1806 of yacc.c  */
#line 2454 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 617:

/* Line 1806 of yacc.c  */
#line 2456 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 618:

/* Line 1806 of yacc.c  */
#line 2461 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 619:

/* Line 1806 of yacc.c  */
#line 2463 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 620:

/* Line 1806 of yacc.c  */
#line 2465 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 621:

/* Line 1806 of yacc.c  */
#line 2475 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 623:

/* Line 1806 of yacc.c  */
#line 2478 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 624:

/* Line 1806 of yacc.c  */
#line 2480 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 625:

/* Line 1806 of yacc.c  */
#line 2485 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 626:

/* Line 1806 of yacc.c  */
#line 2487 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 627:

/* Line 1806 of yacc.c  */
#line 2489 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 628:

/* Line 1806 of yacc.c  */
#line 2494 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 629:

/* Line 1806 of yacc.c  */
#line 2496 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 630:

/* Line 1806 of yacc.c  */
#line 2498 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 631:

/* Line 1806 of yacc.c  */
#line 2500 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 632:

/* Line 1806 of yacc.c  */
#line 2505 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 633:

/* Line 1806 of yacc.c  */
#line 2507 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 634:

/* Line 1806 of yacc.c  */
#line 2509 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 635:

/* Line 1806 of yacc.c  */
#line 2522 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 637:

/* Line 1806 of yacc.c  */
#line 2525 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 638:

/* Line 1806 of yacc.c  */
#line 2527 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 639:

/* Line 1806 of yacc.c  */
#line 2532 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(1) - (1)].tok) );
			(yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) );
		}
    break;

  case 640:

/* Line 1806 of yacc.c  */
#line 2537 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(1) - (1)].tok) );
			(yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) );
		}
    break;

  case 641:

/* Line 1806 of yacc.c  */
#line 2545 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 642:

/* Line 1806 of yacc.c  */
#line 2547 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 643:

/* Line 1806 of yacc.c  */
#line 2549 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 644:

/* Line 1806 of yacc.c  */
#line 2554 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 645:

/* Line 1806 of yacc.c  */
#line 2556 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 646:

/* Line 1806 of yacc.c  */
#line 2561 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 647:

/* Line 1806 of yacc.c  */
#line 2563 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 649:

/* Line 1806 of yacc.c  */
#line 2581 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 650:

/* Line 1806 of yacc.c  */
#line 2583 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 2588 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( 0 ); }
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 2590 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 653:

/* Line 1806 of yacc.c  */
#line 2592 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 2594 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 655:

/* Line 1806 of yacc.c  */
#line 2596 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 657:

/* Line 1806 of yacc.c  */
#line 2602 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 658:

/* Line 1806 of yacc.c  */
#line 2604 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 2606 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 660:

/* Line 1806 of yacc.c  */
#line 2611 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, nullptr, (yyvsp[(3) - (5)].decl), nullptr ); }
    break;

  case 661:

/* Line 1806 of yacc.c  */
#line 2613 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 662:

/* Line 1806 of yacc.c  */
#line 2615 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 663:

/* Line 1806 of yacc.c  */
#line 2621 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, 0, false ); }
    break;

  case 664:

/* Line 1806 of yacc.c  */
#line 2623 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, 0, false )->addArray( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 666:

/* Line 1806 of yacc.c  */
#line 2629 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(3) - (5)].en), 0, false ); }
    break;

  case 667:

/* Line 1806 of yacc.c  */
#line 2631 "parser.yy"
    { (yyval.decl) = DeclarationNode::newVarArray( 0 ); }
    break;

  case 668:

/* Line 1806 of yacc.c  */
#line 2633 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addArray( DeclarationNode::newArray( (yyvsp[(4) - (6)].en), 0, false ) ); }
    break;

  case 669:

/* Line 1806 of yacc.c  */
#line 2635 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addArray( DeclarationNode::newVarArray( 0 ) ); }
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 2670 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 2672 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 2677 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( nullptr ); }
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 2679 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 675:

/* Line 1806 of yacc.c  */
#line 2681 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( nullptr ) ); }
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 2683 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 2685 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 2691 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 2693 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 2695 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 2700 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, nullptr, (yyvsp[(3) - (5)].decl), nullptr ); }
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 2702 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 684:

/* Line 1806 of yacc.c  */
#line 2704 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 686:

/* Line 1806 of yacc.c  */
#line 2711 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 688:

/* Line 1806 of yacc.c  */
#line 2722 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, 0, false ); }
    break;

  case 689:

/* Line 1806 of yacc.c  */
#line 2725 "parser.yy"
    { (yyval.decl) = DeclarationNode::newVarArray( (yyvsp[(3) - (6)].decl) ); }
    break;

  case 690:

/* Line 1806 of yacc.c  */
#line 2727 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, (yyvsp[(3) - (5)].decl), false ); }
    break;

  case 691:

/* Line 1806 of yacc.c  */
#line 2730 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(4) - (6)].en), (yyvsp[(3) - (6)].decl), false ); }
    break;

  case 692:

/* Line 1806 of yacc.c  */
#line 2732 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(5) - (7)].en), (yyvsp[(4) - (7)].decl), true ); }
    break;

  case 693:

/* Line 1806 of yacc.c  */
#line 2734 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(5) - (7)].en), (yyvsp[(3) - (7)].decl), true ); }
    break;

  case 695:

/* Line 1806 of yacc.c  */
#line 2749 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 696:

/* Line 1806 of yacc.c  */
#line 2751 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 697:

/* Line 1806 of yacc.c  */
#line 2756 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( 0 ); }
    break;

  case 698:

/* Line 1806 of yacc.c  */
#line 2758 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 699:

/* Line 1806 of yacc.c  */
#line 2760 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 700:

/* Line 1806 of yacc.c  */
#line 2762 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 701:

/* Line 1806 of yacc.c  */
#line 2764 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 703:

/* Line 1806 of yacc.c  */
#line 2770 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 704:

/* Line 1806 of yacc.c  */
#line 2772 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 705:

/* Line 1806 of yacc.c  */
#line 2774 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 706:

/* Line 1806 of yacc.c  */
#line 2779 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 707:

/* Line 1806 of yacc.c  */
#line 2781 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 710:

/* Line 1806 of yacc.c  */
#line 2791 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 713:

/* Line 1806 of yacc.c  */
#line 2801 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 714:

/* Line 1806 of yacc.c  */
#line 2803 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 715:

/* Line 1806 of yacc.c  */
#line 2805 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 716:

/* Line 1806 of yacc.c  */
#line 2807 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 717:

/* Line 1806 of yacc.c  */
#line 2809 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 718:

/* Line 1806 of yacc.c  */
#line 2811 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 719:

/* Line 1806 of yacc.c  */
#line 2818 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 720:

/* Line 1806 of yacc.c  */
#line 2820 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 721:

/* Line 1806 of yacc.c  */
#line 2822 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 722:

/* Line 1806 of yacc.c  */
#line 2824 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( (yyvsp[(2) - (3)].decl) )->addNewArray( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 723:

/* Line 1806 of yacc.c  */
#line 2826 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 724:

/* Line 1806 of yacc.c  */
#line 2829 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 725:

/* Line 1806 of yacc.c  */
#line 2831 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 726:

/* Line 1806 of yacc.c  */
#line 2833 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 727:

/* Line 1806 of yacc.c  */
#line 2835 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( (yyvsp[(2) - (3)].decl) )->addNewArray( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 728:

/* Line 1806 of yacc.c  */
#line 2837 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 729:

/* Line 1806 of yacc.c  */
#line 2842 "parser.yy"
    { (yyval.decl) = DeclarationNode::newVarArray( (yyvsp[(3) - (6)].decl) ); }
    break;

  case 730:

/* Line 1806 of yacc.c  */
#line 2844 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(4) - (6)].en), (yyvsp[(3) - (6)].decl), false ); }
    break;

  case 731:

/* Line 1806 of yacc.c  */
#line 2849 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(4) - (6)].en), (yyvsp[(3) - (6)].decl), true ); }
    break;

  case 732:

/* Line 1806 of yacc.c  */
#line 2851 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(5) - (7)].en), (yyvsp[(4) - (7)].decl)->addQualifiers( (yyvsp[(3) - (7)].decl) ), true ); }
    break;

  case 734:

/* Line 1806 of yacc.c  */
#line 2878 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 738:

/* Line 1806 of yacc.c  */
#line 2889 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 739:

/* Line 1806 of yacc.c  */
#line 2891 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 740:

/* Line 1806 of yacc.c  */
#line 2893 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 741:

/* Line 1806 of yacc.c  */
#line 2895 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 742:

/* Line 1806 of yacc.c  */
#line 2897 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 743:

/* Line 1806 of yacc.c  */
#line 2899 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 744:

/* Line 1806 of yacc.c  */
#line 2906 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 745:

/* Line 1806 of yacc.c  */
#line 2908 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 746:

/* Line 1806 of yacc.c  */
#line 2910 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 747:

/* Line 1806 of yacc.c  */
#line 2912 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 748:

/* Line 1806 of yacc.c  */
#line 2914 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 749:

/* Line 1806 of yacc.c  */
#line 2916 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 750:

/* Line 1806 of yacc.c  */
#line 2921 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTuple( (yyvsp[(3) - (5)].decl) ); }
    break;

  case 751:

/* Line 1806 of yacc.c  */
#line 2928 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, (yyvsp[(1) - (6)].decl), (yyvsp[(4) - (6)].decl), nullptr ); }
    break;

  case 752:

/* Line 1806 of yacc.c  */
#line 2930 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, (yyvsp[(1) - (6)].decl), (yyvsp[(4) - (6)].decl), nullptr ); }
    break;

  case 755:

/* Line 1806 of yacc.c  */
#line 2954 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 756:

/* Line 1806 of yacc.c  */
#line 2956 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en); }
    break;



/* Line 1806 of yacc.c  */
#line 9345 "Parser/parser.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 2959 "parser.yy"

// ----end of grammar----

extern char *yytext;

void yyerror( const char * ) {
	cout << "Error ";
	if ( yyfilename ) {
		cout << "in file " << yyfilename << " ";
	} // if
	cout << "at line " << yylineno << " reading token \"" << (yytext[0] == '\0' ? "EOF" : yytext) << "\"" << endl;
}

// Local Variables: //
// mode: c++ //
// tab-width: 4 //
// compile-command: "make install" //
// End: //

